<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: ossigeno-catalogo
    File
    /catalogo/index.php
    This file lists catalogo categories
*/

class CatalogoCategory extends OTK_Record
{
    var $id_c;
    var $name;
    function CatalogoCategory($id)
    {
        parent:OTK_Record("oss_catalogo_info", "id");
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (id = '{$id}')");
        if (otk_sql_num_rows($q)) {
            $category = otk_sql_fetch_array($q);
            $this->id   = (int)    $category["id"];
            $this->id_c = (int)    $category["id_c"];
            $this->name = (string) $category["name"];
        }
    }
    function Title()
    {
        $title = ucwords($this->name);
        //search of parent category
        //category without parent -> id_c == 0
        $id = $this->id_c;
        while ($id != 0) {
            $parent = new CatalogoCategory($id);
            //building title
            $title = ucwords($parent->name) . " - " . $title;
            $id = $parent->id_c;
        }
        return $title;
    }
    function Bar()
    {
        $bar = "<a href=\"catalogo/category.php?id_c={$this->id}\">" . ucwords($this->name) . "</a>";
        //search of parent category
        //category without parent -> id_c == 0
        $id = $this->id_s;
        while ($id != 0) {
            $parent = new CatalogoCategory($id);
            //building bar of link
            $bar = "<a href=\"catalogo/category.php?id_c={$parent->id}\">" . ucwords($parent->name) . "</a> - " . $bar;
            $id = $parent->id_c;
        }
        return $bar;
    }
}

class Product extends OTK_Record
{
    var $id_c;
    var $img;
    var $img_mime;
    var $name;
    var $description;
    var $price;
    var $notes;
    function Product($id)
    {
        parent:OTK_Record("oss_catalogo", "id");
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (id = '{$id}')");
        if (otk_sql_num_rows($q)) {
            $product = otk_sql_fetch_array($q);
            $this->id           = (int)    $product["id"];
            $this->id_c         = (int)    $product["id_c"];
            $this->img          = (string) $product["img"];
            $this->img_mime     = (string) $product["img_mime"];
            $this->name         = (string) $product["name"];
            $this->description  = (string) $product["description"];
            $this->price        = (string) $product["price"];
            $this->notes        = (string) $product["notes"];
        }
    }
}

$header["style"] .= "
th.product_name
{
    width: 20%;
}
th.product_img
{
    width: 15%;
}
th.product_description
{
    width: 50%;
}
th.product_price
{
    width: 15%;
}
td.product_name
{
    width: 20%;
}
td.product_img
{
    width: 15%;
}
td.product_description
{
    width: 50%;
}
td.product_price
{
    width: 15%;
}
";
?>
