<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: ossigeno-catalogo
    File
    /catalogo/form_order.php[POST]
    This file displays a form for ordering products
*/

$module = "catalogo";
$only_users = FALSE;
$abc = "catalogo/index.php";
include("../common/config.php");

$header["style"] .= "
label
{
    display: block;
}
";
$header["title"] = $lang["titles"]["form_order"];
require("../common/header.php");
?>
<form action="catalogo/order.php" method="post">
<fieldset>
    <legend>Dati</legend>
    <label>Nome: <input type="text" id="first_name" name="first_name" /></label>
    <label>Cognome: <input type="text" id="last_name" name="last_name" /></label>
    <label>E-mail: <input type="text" id="mail" name="mail" /></label>
    <label>Autorizzo il trattamento dei miei dati personali ai sensi del D.Lgs. 196/03 <input type="checkbox" id="privacy" name="privacy" /></label>
    <label>Accetto le Condizioni di fornitura del servizio <input type="checkbox" id="service" name="service" /></label>
</fieldset>
<fieldset>
    <legend>Recapito</legend>
    <label>Indirizzo: <input type="text" id="address" name="address" /></label>
    <label>Citt: <input type="text" id="city" name="city" /></label>
    <label>CAP: <input type="text" id="cap" name="cap" /></label>
    <label>Telefono: <input type="text" id="tel" name="tel" /></label>
</fieldset>
<fieldset>
    <legend>Data ordine</legend>
    <label>Data:
    <select id="dd" name="dd">
    <?
    for ($i = 1; $i <= 31; $i++) {
        if ($i < 10) {
            $dd = "0{$i}";
        } else {
            $dd = "{$i}";
        }
        if ($i == date("d")) {
            $selected = " selected=\"selected\"";
        } else {
            $selected = "";
        }
        echo "<option value=\"{$i}\"{$selected}>{$dd}</option>
        ";
    }
    ?>
    </select>
    <select id="month" name="month">
    <?
    foreach ($lc["months"]["long"] as $id => $m) {
        if ($id == date("m")) {
            $selected = " selected=\"selected\"";
        } else {
            $selected = "";
        }
        echo "<option value=\"{$m}\"{$selected}>{$m}</option>
        ";
    }
    ?>
    </select>
    <input type="text" id="yyyy" name="yyyy" value="<? echo date("Y"); ?>" />
    </label>
    <label>Ora: <input type="text" id="hh" name="hh" />:<input type="text" id="mm" name="mm" /></label>
</fieldset>
<fieldset>
    <legend>Ordine</legend>
    <?
    $total = 0;
    foreach ($_POST as $input_id => $number) {
        $id = (int) substr($input_id, 1, strlen($input_id) - 1);
        $p = new Product($id);
        echo "<label>{$p->name} <input type=\"text\" readonly=\"readonly\" id=\"{$input_id}\" name=\"{$input_id}\" value=\"{$number}\" /></label>
        ";
        $total += $number * $p->price;
    }
    ?>
    <label>Totale: <input type="text" readonly="readonly" value="<? echo $total; ?>" /></label>
</fieldset>
<div><button type="submit"><? echo $lang["submit"]; ?></button></div>
</form>
<?
require("../common/footer.php");
?>
