<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: ossigeno-sections
    File
    /sections/common.php
    This file defines the module classes
*/

class Section extends OTK_Record
{
    var $id_s;
    var $name;
    var $description;
    var $type;
    var $info;

    function Section($id, $edit = FALSE)
    {
        parent::OTK_Record("oss_sections", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id = '$id'");
        if (otk_sql_num_rows($q)) {
            $section = otk_sql_fetch_array($q);
            $this->id          = (int)    $section["id"];
            $this->id_s        = (int)    $section["id_s"];
            $this->name        = (string) $section["name"];
            $this->description = (string) $section["description"];
            $this->img         = (string) $section["img"];
            $this->type        = (string) $section["type"];
            $this->info        = (string) $section["info"];
            //view fields
            $this->view_order       = (string) $section["view_order"];
            $this->view_limit       = (int)    $section["view_limit"];
            $this->view_cols        = (int)    $section["view_cols"];
            $this->view_ancestors   = (int)   $section["view_ancestors"];
           
            $this->_RegisterFields();

            //blocks inclusion
            $this->edit = $edit;
            if (!$this->edit) {
                otk_include_articles($this->description);
                otk_include_articles($this->info);
            }
        }
    }

    function Title()
    {
        $title = ucwords($this->name);
        if (!$this->view_ancestors) {
            return $title;
        }
        //search of parent section
        $id = $this->id_s;
        while($id != 0) {
            $parent = new Section($id);

            //building title
            $title = ucwords($parent->name)." - ".$title;
            $id = $parent->id_s;
        }
        return $title;
    }

    function Bar()
    {
        $links = array();
        $links[] = "<a href=\"sections/section.php?id_s={$this->id}\">" . ucwords($this->name) . "</a>";
        if (!$this->view_ancestors) {
            return $links[0];
        }
        //search of parent section
        $id = $this->id_s;
        while ($id != 0) {
            $parent = new Section($id);

            //building bar of link
            $links[] = "<a href=\"sections/section.php?id_s={$parent->id}\">".ucwords($parent->name)."</a>";
            $id = $parent->id_s;
        }
        $links = array_reverse($links);
        $bar = implode(" - ", $links);
        return $bar;
    }

    function NumberArticles()
    {
        $q = otk_sql_query("SELECT * FROM oss_sections_articles WHERE id_s = {$this->id}");
        $number = otk_sql_num_rows($q);
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id_s = {$this->id}'");
        if (otk_sql_num_rows($q)) {
            while ($section = otk_sql_fetch_array($q)) {
                $section = new Section($section["id"]);
                $number += $section->NumberArticles();
            }
        }
        return $number;
    }

    function GetLastArticle()
    {
        $q = otk_sql_query("SELECT * FROM oss_sections_articles WHERE id_s = {$this->id} ORDER BY date DESC LIMIT 0, 1");
        $article = otk_sql_fetch_array($q);
        $article = new Article($article["id"]);
        return $article;
    }

    function Set($name, $value)
    {
        if ($this->edit) {
            return parent::Set($name, $value);
        } else {
            //not set field with block inclusion if blocks are included
            if ($name == "description" or $name == "info") {
                return FALSE;
            } else {
                return parent::Set($name, $value);
            }
        }
    }
}

class Article extends OTK_Record
{
    var $id_s;
    var $author;
    var $title;
    var $img;
    var $description;
    var $text;
    var $date;
    var $cons;

    function Article($id, $edit = FALSE)
    {
        parent::OTK_Record("oss_sections_articles", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id = '$id'");
        if (otk_sql_num_rows($q)) {
            $article = otk_sql_fetch_array($q);
            $this->id          = (int)    $article["id"];
            $this->id_s        = (int)    $article["id_s"];
            $this->author      = (string) $article["author"];
            $this->title       = (string) $article["title"];
            $this->img         = (string) $article["img"];
            $this->description = (string) $article["description"];
            $this->text        = (string) $article["text"];
            $this->date        = (int)    $article["date"];
            $this->cons        = (int)    $article["cons"];

            $this->_RegisterFields();

            //special fields
            //tags
            $q = otk_sql_query("SELECT * FROM oss_sections_articles_tags WHERE id_a = {$this->id}");
            $this->tags = array();
            while ($r = otk_sql_fetch_array($q)) {
                $this->tags[] = $r["id_s"];
            }

            //comments
            $q = otk_sql_query("SELECT id FROM oss_sections_comments WHERE id_a = {$this->id}");
            $this->comments = array();
            while ($r = otk_sql_fetch_array($q)) {
                $this->comments[] = $r["id"];
            }

            //blocks inclusion
            $this->edit = $edit;
            if (!$this->edit) {
                otk_include_articles($this->description);
                otk_include_articles($this->text);
            }
        }
    }

    function Presentation()
    {
        $string = "<a href=\"sections/article.php?\">{$this->title}</a><br />
        " .  otk_time_getdate($this->date) . ", <a href=\"community/profile.php?name={$this->author}\">{$this->author}</a>
        ";
        return $string;
    }

    function Info()
    {
        return "<div class=\"sections_article_info\">" . otk_time_getdate($this->date) . ", <a href=\"community/profile.php?name={$this->author}\">{$this->author}</a>
        </div>
        <div class=\"sections_article_tags\">" . $this->Tags() . "
        </div>";
    }

    function Tags() {
        $list = array();
        foreach ($this->tags as $id_s) {
            $s = new Section($id_s);
            $list[$s["id"]] = $s["name"];
        }
        asort($list);
        $sections = array();
        foreach ($list as $id => $name) {
            $sections[] = "<a href=\"sections/section.php?id_s={$id}\">{$name}</a>";
        }
        return implode(", ", $sections);
    }

    function Cons()
    {
        $cons = $this->cons + 1;
        $q = $this->Set("cons", $cons);
    }

    //return previos article in section
    function GetPrevious()
    {
        $id = FALSE;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id < $this->id ORDER BY id DESC");
        while ($article = otk_sql_fetch_array($q)) {
            $article = new Article($article["id"]);
            $section = new Section($article->id_s);
            if ($section->id == $this->id_s) {
                $id = $article->id;
                break;
            }
        }
        if ($id) {
            return new Article($id);
        } else {
            return FALSE;
        }
    }

    //return next article in section
    function GetNext()
    {
        $id = FALSE;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id > $this->id ORDER BY id ASC");
        while ($article = otk_sql_fetch_array($q)) {
            $article = new Article($article["id"]);
            $section = new Section($article->id_s);
            if ($section->id == $this->id_s) {
                $id = $article->id;
                break;
            }
        }
        if ($id) {
            return new Article($id);
        } else {
            return FALSE;
        }
    }

    function Set($name, $value)
    {
        if ($this->edit) {
            return parent::Set($name, $value);
        } else {
            //not set field with block inclusion if blocks are included
            if ($name == "description" or $name == "text") {
                return FALSE;
            } else {
                return parent::Set($name, $value);
            }
        }
    }
}

class ArticleComment extends OTK_Record
{
    function ArticleComment($id)
    {
        parent::OTK_Record("oss_sections_comments", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id = '$id'");
        if (otk_sql_num_rows($q)) {
            $comment = otk_sql_fetch_array($q);
            $this->id     = (int)    $comment["id"];
            $this->id_a   = (int)    $comment["id_a"];
            $this->author = (string) $comment["author"];
            $this->title  = (string) $comment["title"];
            $this->text   = (string) $comment["text"];
            $this->date   = (int)    $comment["date"];
           
            $this->_RegisterFields();
        }
    }

    function Info()
    {
        return "<div class=\"section_article_comment_info\">
            <a href=\"community/profile.php?name={$this->author}\">{$this->author}</a>,
            " . otk_time_getdate($this->date) . " (#{$this->id})
        </div>
        ";
    }
}

//blocks inclusion function
function otk_include_articles(&$txt)
{
    global $level, $level_server;
    $included = TRUE;
    if (strstr($txt, "{{")) {
        $txt = str_replace("}}", "{{", $txt);
        $pieces = explode("{{", $txt);
        $number_pieces = count($pieces);
        for ($i = 0; $i < $number_pieces; $i++) {
            if ($i % 2 == 0) {
                //treatment of normal text
                //nothing to do
            }
            if ($i % 2 == 1) {
                if (substr($pieces[$i], 0, 8) == "section=") {
                    $_GET["id_s"] = substr($pieces[$i], 8, strlen($pieces[$i] - 8));
                    //treatment of sections included
                    ob_start();
                    $temp = $i;
                    include("{$level}sections/section.php");
                    $i = $temp;
                    $pieces[$i] = ob_get_contents();
                    ob_end_clean();
                } else {
                    //treatment of articles included
                    $a = new Article($pieces[$i]);
                    $pieces[$i] = $a->text;
                }
            }
        }
        $txt = implode("", $pieces);
        otk_include_articles($txt);
    }
}

$header["head"] .= "<script type=\"text/javascript\" src=\"{$ossigeno}sections/buttons.js\"></script>
";

$header["style"] .= "
div#sections_article_comments div#sections_navigation
{
    display: none;
}
";

//editing bar
function otk_sections_bar($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_sections_a('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["sections"]["a"]}\">Art</a>
    </div>
    <div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_sections_s('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["sections"]["s"]}\">Sec</a>
    </div>
    <div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_sections_redirect('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["sections"]["redirect"]}\">Red</a>
    </div>
    <br class=\"clear\" />
    ";
}

?>
