<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: ossigeno-sections
    File
    /sections/form_new_article.php?id_s
    This file displays a form to insert a new article
*/

$module = "sections";
$only_users = TRUE;
$abc = "sections/form_new_article.php?id_s={$_GET["id_s"]}";
include("../common/config.php");

$section = new Section($_GET["id_s"]);

//permissions
$url = "sections/index.php?";
if (!$super and !$user->permissions->content["sections"]["full"] and !$user->permissions->content["sections"]["full_{$section->id}"]) {
    otk_error($lang["errors"]["permissions"], $url);
}

//header
$header["title"] = $section->Title() . " - {$lang["titles"]["form_new_article"]}";
$bar = $section->Bar();
$header["fields"] = array("title" => $lang["form_new_article"]["labels"]["title"]);
require("../common/header.php");
?>
<div id="sections_navigation">
<a href="sections/index.php"><? echo $lang["titles"]["index"]; ?></a><br />
<a href="sections/form_search.php"><? echo $lang["titles"]["form_search"]; ?></a><br />
<? echo $lang["titles"]["section"]; ?>: <? echo $bar; ?><br />
<? echo $lang["titles"]["form_new_article"]; ?>
</div>

<form enctype="multipart/form-data" action="sections/new_article.php" method="post">
<?
$security = security_numbers_generate();
?>
<fieldset>
    <div>
        <label for="title"><? echo $lang["form_new_article"]["labels"]["title"]; ?>:</label>
        <input type="text" id="title" name="title" />
    </div>
    <div>
        <label for="description"><? echo $lang["form_new_article"]["labels"]["description"]; ?>:</label>
        <textarea id="description" name="description"></textarea>
    </div>
    <?
    if ($section->type != "gallery") {
        ?>
        <div>
            <label for="img"><? echo $lang["form_new_article"]["labels"]["img"]; ?>:</label>
            <input type="file" id="img" name="img" />
        </div>
        <?
    }

    if ($section->type == "text") {
        ?>
        <div>
            <label for="text"><? echo $lang["form_new_article"]["labels"]["text"]; ?>:</label>
            <textarea id="text" name="text" rows="20"></textarea><br />
            <? otk_sections_bar(); ?><br />
            <? otk_html_bar(); ?><br />
            <?
            $upload = new OTK_Module("upload");
            if ($upload !== NULL) {
                echo "<a class=\"blank\" href=\"upload/form_new_upload.php\">Upload</a>
                ";
            }
            otk_html_smiles();
            ?>
        </div>
        <div>
            <label for="tags">
            <? echo $lang["form_new_article"]["labels"]["tags"]; ?>:
            </label>
            <select id="tags" name="tags[]" multiple="multiple">
            <?
            $q = otk_sql_query("SELECT * FROM oss_sections ORDER BY name");;
            while ($s = otk_sql_fetch_array($q)) {
                $s = new Section($s["id"]);
                echo "<option";
                if ($s->id == $section->id) {
                    echo " selected=\"selected\" ";
                }
                echo " value=\"{$s->id}\">{$s->name}</option>
                ";
            }
            ?>
            </select>
        </div>
        <?
    }

    if ($section->type == "gallery") {
        ?>
        <div>
            <label for="text"><? echo $lang["form_new_article"]["labels"]["gallery"]; ?>:</label>
            <input type="file" id="text" name="text" />
        </div>
        <?
    }

    if ($section->type == "download") {
        ?>
        <div>
            <label for="text"><? echo $lang["form_new_article"]["labels"]["download"]; ?>:</label>
            <input type="file" id="text" name="text" />
        </div>
        <?
    }

    if ($section->type == "link") {
        ?>
        <div>
            <label for="text"><? echo $lang["form_new_article"]["labels"]["link"]; ?>:</label>
            <input type="text" id="text" name="text" />
        </div>
        <?
    }
    ?>
</fieldset>
<div><button type="submit"><? echo $lang["submit"]; ?></button></div>
<div class="hidden">
    <input type="hidden" id="id_s" name="id_s" value="<? echo $section->id; ?>" />
    <input type="hidden" id="id" name="id" value="<? echo $security["id"]; ?>" />
    <input type="hidden" id="number" name="number" value="<? echo $security["number"]; ?>" />
</div>
</form>
<?
require("../common/footer.php");
?>
