<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: ossigeno-sections
    File
    /sections/form_search.php
    This file displays a form to search an article
*/

$module = "sections";
$only_users = FALSE;
$abc = "sections/form_search.php";
include("../common/config.php");

if ($_GET["id_s"]) {
    $section = new Section($_GET["id_s"]);
}

//header
$header["title"] = $lang["titles"]["form_search"];
if ($section) {
    $header["title"] .= ": {$section->name}";
}
$header["fields"] = array("keys" => $lang["form_search"]["labels"]["keys"]);
$header["head"] .= "
<script type=\"text/javascript\">
function verify_checkboxes()
{
    if (document.getElementById('id_s').selectedIndex != 0) {
        document.getElementById('c_id_s').checked = 'checked';
    }
    if (document.getElementById('author').value != '') {
        document.getElementById('c_author').checked = 'checked';
    }
}
</script>
";
require("../common/header.php");
?>
<div id="sections_navigation">
    <a href="sections/index.php"><? echo $lang["titles"]["index"]; ?></a><br />
</div>
<?
$security = security_numbers_generate();
?>
<form action="sections/search.php" method="post">
<fieldset>
    <legend><? echo $lang["form_search"]["legends"]["research"]; ?></legend>

    <div>
        <label for="keys"><? echo $lang["form_search"]["labels"]["keys"]; ?>:</label>
        <input type="text" id="keys" name="keys" />
    </div>
    <div>
        <label for="type"><? echo $lang["form_search"]["labels"]["type"]; ?>:</label>
        <input type="radio" id="type" name="type" value="or" /> <? echo $lang["form_search"]["types"]["or"]; ?><br />
        <input type="radio" id="type" name="type" value="and" checked="checked" /> <? echo $lang["form_search"]["types"]["and"]; ?>
    </div>
<fieldset>
    <legend><? echo $lang["form_search"]["legends"]["options"]; ?></legend>

    <div>
        <label for="id_s">
        <input type="checkbox" id="c_id_s" name="c_id_s" <?
        if ($section) {
            echo "checked=\"checked\" ";
        }
        ?>/>
        <? echo $lang["form_search"]["labels"]["id_s"]; ?>:
        </label>
        <select id="id_s" name="id_s" onchange="verify_checkboxes()">
        <option value=""></option>
        <?
        $q = otk_sql_query("SELECT * FROM oss_sections ORDER BY name");
        while ($s = otk_sql_fetch_array($q)) {
            $s = new Section($s["id"]);
            echo "<option";
            if ($s->id == $section->id) {
                echo " selected=\"selected\" ";
            }
            echo " value=\"{$s->id}\">{$s->name}</option>
            ";
        }
        ?>
        </select>
    </div>
    <div>
        <label for="tags">
        <input type="checkbox" id="c_tags" name="c_tags" />
        <? echo $lang["form_search"]["labels"]["tags"]; ?>:
        </label>
        <select id="tags" name="tags" multiple="multiple">
        <?
        $q = otk_sql_query("SELECT * FROM oss_sections ORDER BY name");;
        while ($s = otk_sql_fetch_array($q)) {
            $s = new Section($s["id"]);
            echo "<option";
            if ($s->id == $section->id) {
                echo " selected=\"selected\" ";
            }
            echo " value=\"{$s->id}\">{$s->name}</option>
            ";
        }
        ?>
        </select>
    </div>
    <div>
        <label for="author">
        <input type="checkbox" id="c_author" name="c_author" />
        <? echo $lang["form_search"]["labels"]["author"]; ?>:
        </label>
    </div>
    <input type="text" id="author" name="author" onchange="verify_checkboxes()" />
</fieldset>
<div><button type="submit"><? echo $lang["submit"]; ?></button></div>
<p class="hidden"><input type="hidden" id="number" name="number" value="<? echo $security["number"]; ?>" /><input type="hidden" id="id" name="id" value="<? echo $security["id"]; ?>" /></p>
</form>
<?
require("../common/footer.php");
?>
