<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: ossigeno-sections
    File
    /sections/search.php
    This file searchs an article by keywords (with form_search.php)
*/

$module = "sections";
$only_users = FALSE;
$abc = "sections/form_search.php";
include("../common/config.php");

$url = "sections/form_search.php?";

//control: security number
if (!security_numbers_validate($_REQUEST["id"], $_REQUEST["number"])) {
    otk_error($lang["errors"]["security_numbers"], $url);
}

//control: at least one key must exist
if ($_REQUEST["keys"] == "") {
    otk_error($lang["errors"]["keys_must_exist"], $url);
}

//control: keys number
$keys = explode(" ", $_REQUEST["keys"]);
if (count($keys) > 10) {
    otk_error($lang["errors"]["too_keys"], $url);
}

//header
$header["title"] = $lang["titles"]["search"];
require("../common/header.php");
?>
<div id="sections_navigation">
    <a href="sections/index.php"><? echo $lang["titles"]["index"]; ?></a><br />
    <a href="sections/form_search.php"><? echo $lang["titles"]["form_search"]; ?></a>
</div>
<?
//composition of query
$clauses = array();

//KEYWORDS
if (TRUE) {
    //boolean logic for keywords search
    if ($_REQUEST["type"] == "or") {
        $c = " OR ";
    } else {
        //if type=="and" or if is not specified
        $c = " AND ";
    }

    //clauses composition
    $highlighted_words = array();
    $keywords_terms = array();
    foreach ($keys as $keyword) {
        $highlighted_words[] = $keyword;
        $keywords_terms[] = "(text LIKE '%{$keyword}%')";
    }
    $subquery = "(";
    $subquery .= implode($c, $keywords_terms);
    $subquery .= ")";
    $clauses[] = $subquery;
}

//ID_S
$_REQUEST["c_id_s"] = (bool) $_REQUEST["c_id_s"];
if ($_REQUEST["c_id_s"] and $_REQUEST["id_s"]) {
    $clauses[] = "(id_s = '{$_REQUEST["id_s"]}')";
}

//AUTHOR
$_REQUEST["c_author"] = (bool) $_REQUEST["c_author"];
if ($_REQUEST["c_author"] and $_REQUEST["author"]) {
    $clauses[] = "(author = '{$_REQUEST["author"]}')";
}

//composition of main query
$query = "SELECT * FROM oss_sections_articles WHERE (";
$query .= implode(" AND ", $clauses);
$query .= ")";
$q = otk_sql_query($query);

//results
if (otk_sql_num_rows($q)) {
    echo "<p>{$lang["search"]["searched"]}: ".implode(", ", $highlighted_words)."</p>
    <div class=\"sections_search\">
    ";
    while ($article = otk_sql_fetch_array($q)) {
        $article = new Article($article["id"]);

        if ($_REQUEST["c_tags"]) {
            foreach ($_POST["tags"] as $id_s) {
                if (!in_array($id_s, $article->tags)) {
                    continue;
                }
            }
        }

        $section = new Section($article->id_s);
        if ($section->type != "text") {
            continue;
        }

        //description
        if ($article->description) {
            $description = "<div class=\"sections_article_description\">
            <a href=\"sections/article.php?id_a={$article->id}\">
            {$article->description}
            </a>
            </div>";
        } else {
            $description = "";
        }

        //image
        $img = new OTK_Img("{$server}{$article->img}");
        $img->ScaleToFit(100, 100);
        $img->SetAttr("class", "sections_article");
        $img->SetStyle("float", "left");

        echo "
        <div class=\"sections_article\" style=\"float: left\">
            <a href=\"sections/article.php?id_a={$article->id}\">";
            $img->Display();
            echo "</a>
            <a href=\"sections/article.php?id_a={$article->id}\">{$article->title}</a>
            (<a href=\"sections/section.php?id_s={$section->id}\">{$section->name}</a>)
            {$description}
            ".$article->Info()."
        </div>
        ";
    }

    ?></div><?
} else {
    echo "<p>{$lang["search"]["no_results"]}</p>
    ";
}
require("../common/footer.php");
?>
