<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: ossigeno-sections
    File
    /sections/section.php?id_s
    This file list subsections and articles of a section
*/

if (!$included) {
    $module = "sections";
    $only_users = FALSE;
    $abc = "sections/section.php?id_s=$_GET[id_s]";
    include("../common/config.php");
    
    }
$section = new Section($_GET["id_s"]);
if ($included) {
    ob_start();
}
$header["title"] = $section->Title();
$bar = $section->Bar();
//header
$width = floor(90 / $section->view_cols);
$header["style"] .= "
div.subsections
{
    width: 100%;
    float: left;
}
div.sections_row
{
    float: left;
    width: 100%;
}
div.sections_article
{
    width: {$width}%;
    float: left;
    margin: 10px;
}
";
require("../common/header.php");

?>
<div id="sections_navigation">
    <a href="sections/index.php"><? echo $lang["titles"]["index"]; ?></a><br />
    <a href="sections/form_search.php"><? echo $lang["titles"]["form_search"]; ?></a><br />
    <? echo $lang["titles"]["section"]; ?>: <? echo $bar; ?><br />
    <a href="sections/form_new_article.php?id_s=<? echo $section->id; ?>"><? echo $lang["titles"]["new_article"]; ?></a>
</div>
<?

//section description (head)
if ($section->description) {
    $img = new OTK_Img($section->img, "");
    $img->ScaleToFit(120, 120);
    $img->SetAttr("class", "section");
    $img->SetStyle("float", "left");
    $img->Display();
    ?>
    <div id="section_description"><? echo $section->description; ?></div>
    <?
}

//subsections
$q = otk_sql_query("SELECT * FROM oss_sections WHERE (id_s = '{$section->id}') ORDER BY name");
if (otk_sql_num_rows($q)) {
    ?>
    <div class="subsections">
    <?
    while ($subsection = otk_sql_fetch_array($q)) {
        $subsection = new Section($subsection["id"]);

        //description
        if ($subsection->description) {
            $description = "<div class=\"section_description\">
            {$subsection->description}
            </div>";
        } else {
            $description = "";
        }

        //image
        $img = new OTK_Img($base.$subsection->img);
        $img->ScaleToFit(100, 100);
        $img->SetAttr("class", "section");
        $img->SetStyle("float", "left");

        echo "
        <div class=\"subsection\">
            <a href=\"sections/section.php?id_s={$subsection->id}\">";
            $img->Display();
            echo "</a>
            <a href=\"sections/section.php?id_s={$subsection->id}\">{$subsection->name}</a>
            {$description}
        </div>
        ";
    }
    ?>
    </div>
    <?
}

if ($included) {
    ob_end_clear();
}

//selection of articles
$q = otk_sql_query("SELECT COUNT(*) AS number FROM oss_sections_articles WHERE id_s = {$section->id}");
$record = otk_sql_fetch_array($q);
$n = $record["number"];
if ($n) {
    //selection of records and calculus of pages where needed
    if ($section->view_limit) {
        $otk_rec = $section->view_limit;
        list($pages, $inf, $rec) = otk_pages($n, $_GET["page"]);
        otk_pages_list($pages, $_GET["page"], "sections/section.php?id_s={$section->id}");
        $limit = "LIMIT $inf, $rec";
    } else {
        $limit = "";
    }
    $q = otk_sql_query("SELECT * FROM oss_sections_articles WHERE id_s = '{$section->id}' ORDER BY id {$section->view_order} {$limit}");

    //view
    switch ($section->type) {
        case "text":
            ?><div class="sections_articles"><?

            $i = 0;
            while ($article = otk_sql_fetch_array($q)) {
                $article = new Article($article["id"]);
                $i++;

                //starting row
                if ($i % $section->view_cols == 1) {
                    ?><div class="sections_row"><?
                }

                //description
                if ($article->description) {
                    $description = "<div class=\"sections_article_description\">
                    <a href=\"sections/article.php?id_a={$article->id}\">
                    {$article->description}
                    </a>
                    </div>";
                } else {
                    $description = "";
                }

                //image
                $img = new OTK_Img($article->img);
                $img->ScaleToFit(100, 100);
                $img->SetAttr("class", "sections_article");
                $img->SetStyle("float", "left");

                echo "
                <div class=\"sections_article\" style=\"float: left\">
                    <a href=\"sections/article.php?id_a={$article->id}\">";
                    $img->Display();
                    echo "</a>
                    <a href=\"sections/article.php?id_a={$article->id}\">{$article->title}</a>
                    {$description}
                    ".$article->Info()."
                </div>
                ";

                //ending row
                if ($i % $section->view_cols == 0) {
                    ?></div><?
                }
            }

            ?></div><?
            break;

        case "gallery":
            ?><table class="sections_articles"><?

            $i = 0;
            while ($article = otk_sql_fetch_array($q)) {
                $article = new Article($article["id"]);
                $i++;

                //starting row
                if ($i % $section->view_cols == 1) {
                    echo "<tr>";
                }

                //calculus dimensions
                $img = new OTK_Img($article->text, $article->title);
                $window_width  = $img->GetAttr("width")  + 50;
                $window_height = $img->GetAttr("height") + 50;
                $img->SetAttr("longdesc", $article->description);
                $img->ScaleToFit(80, 80);

                echo "
                    <td><a href=\"". $img->GetAttr("src") . "\" rel=\"lightbox[roadtrip]\" class=\"blank\">";
                    $img->Display();
                echo "</a></td>
                ";

                //ending row
                if ($i % $section->view_cols == 0) {
                    echo "</tr>";
                }
            }

            ?></table><?
            break;

        case "download":
            ?><div class="sections_articles"><?

            $i = 0;

            while ($article = otk_sql_fetch_array($q)) {
                $article = new Article($article["id"]);
                $i++;

                //starting row
                if ($i % $section->view_cols == 1) {
                    ?><div class="sections_row"><?
                }

                //description
                if ($article->description) {
                    $description = "<div class=\"sections_article_description\">
                    <a href=\"sections/article.php?id_a={$article->id}\">{$article->description}
                    </a>
                    </div>";
                } else {
                    $description = "";
                }

                //image
                $img = new OTK_Img($article->img);
                $img->ScaleToFit(100, 100);
                $img->SetAttr("class", "sections_article");
                $img->SetAttr("style", "float: left;");

                echo "
                    <div class=\"sections_article\">
                    <a href=\"sections/article.php?id_a={$article->id}\">";
                    $img->Display();
                    echo "<strong>{$article->title}</strong></a>
                    {$description}
                    ".$article->Info()."
                    </div>
                ";

                //ending row
                if ($i % $section->view_cols == 0) {
                    ?><br class="clear" /><?
                }
            }

            ?></div><?
            break;

        case "link":
            ?><div class="sections_articles"><?

            $i = 0;
            while ($article = otk_sql_fetch_array($q)) {
                $article = new Article($article["id"]);
                $i++;

                //starting row
                if ($i % $section->view_cols == 1) {
                    ?><div class="sections_row"><?
                }

                //description
                if ($article->description) {
                    $description = "<div class=\"sections_article_description\">
                    <a href=\"sections/article.php?id_a={$article->id}\">{$article->description}
                    </a>
                    </div>";
                } else {
                    $description = "";
                }

                //image
                $img = new OTK_Img($article->img);
                $img->ScaleToFit(100, 100);
                $img->SetAttr("class", "sections_article");
                $img->SetStyle("float", "left");

                echo "
                    <div class=\"section_article\">
                    <a href=\"sections/article.php?id_a={$article->id}\">";
                    $img->Display();
                    echo "{$article->title}</a>
                    {$description}
                    " . $article->Info() . "
                    </div>
                    ";

                //ending row
                if ($i % $section->view_cols == 0) {
                    ?><br class="clear" /><?
                }
            }
            ?></div><?
            break;
    }

    if ($section->view_limit) {
        otk_pages_list($pages, $_GET["page"], "sections/section.php?id_s={$section->id}");
    }
}

if ($included) {
    ob_start();
}

//section info (foot)
$in = $section->info;
otk_include_articles($in);
if ($in) {
    ?><div class="sections_info"><? echo $in; ?></div><?
}
?>
<br class="clear" />
<?
require("../common/footer.php");

if ($included) {
    ob_end_clear();
}
?>
