<?
/*
    +----------------------------------------------------------------------+
    | Xax is a modularized tool for administration of websites             |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: xax-ossigeno
    Module2: sections
    File
    /ossigeno/sections/form_add_section.php
    This file displays a form to add a section (with management.php)
*/

$module = "ossigeno";
$module2 = "sections";
$only_users = TRUE;
$abc = "ossigeno/sections/management.php";
include("../../common/config.php");

$url = "ossigeno/sections/index.php?";
if (!$super) {
    otk_error($lang["errors"]["permissions"], $url);
}
$parent = NULL;
if ($_REQUEST["id_s"]) {
    $parent = new Section($_REQUEST["id_s"]);
}
//header
$header["title"] = $lang["titles"]["form_add_section"];
if ($parent) {
    $header["title"].=(" => {$parent->name}");
}
require("../../common/header.php");
?>
<form action="ossigeno/sections/add_section.php" method="post" enctype="multipart/form-data">
<fieldset>
    <legend><? echo $lang["form_add_section"]["legends"]["main"]; ?></legend>
    <div>
        <label for="name"><? echo $lang["form_add_section"]["labels"]["name"]; ?>:</label>
        <input type="text" id="name" name="name" />
    </div>
    <div>
        <label for="description"><? echo $lang["form_add_section"]["labels"]["description"]; ?>:</label>
        <input type="text" id="description" name="description" />
    </div>
    <div>
        <label for="img"><? echo $lang["form_add_section"]["labels"]["img"]; ?>:</label>
        <input type="file" id="img" name="img" />
    </div>
    <div>
        <label for="type"><? echo $lang["form_add_section"]["labels"]["type"]; ?>:</label>
        <select id="type" name="type">
        <?
        $types = array("text", "documentation", "gallery", "download", "link");
        foreach ($types as $name=>$value) {
            echo "<option value=\"$value\"";
            if ($parent) {
                if ($parent->type==$value) {
                    echo " selected=\"selected\"";
                }
            }
            echo ">$value</option>
            ";
        }
        ?>
        </select>
    </div>
</fieldset>

<fieldset>
    <legend><? echo $lang["form_edit_section"]["legends"]["view"]; ?></legend>

    <div>
        <label for="view_order"><? echo $lang["form_add_section"]["labels"]["view_order"]; ?>:</label>
        <select id="view_order" name="view_order">
        <?
        foreach ($lang["form_add_section"]["values"]["view_order"] as $value => $display) {
            if ($parent and $parent->view_order == $value) {
                $selected = " selected=\"selected\"";
            } else {
                $selected = "";
            }
            echo "<option value=\"{$value}\"{$selected}>{$display}</option>
            ";
        }
        ?>
        </select>
        <? otk_help_button($lang["form_add_section"]["helps"]["view_order"]); ?>
    </div>
    <div>
        <?
        if ($parent) {
            $value = $parent->view_limit;
        } else {
            $value = $otk_rec;
        }
        ?>
        <label for="view_limit"><? echo $lang["form_add_section"]["labels"]["view_limit"]; ?>:</label>
        <input type="text" id="view_limit" name="view_limit" value="<? echo $value; ?>" />
        <? otk_help_button($lang["form_add_section"]["helps"]["view_limit"]); ?>
    </div>
    <div>
        <?
        if ($parent) {
            $value = $parent->view_cols;
        } else {
            $value = 1;
        }
        ?>
        <label for="view_cols"><? echo $lang["form_add_section"]["labels"]["view_cols"]; ?>:</label>
        <input type="text" id="view_cols" name="view_cols" value="<? echo $value; ?>" />
        <? otk_help_button($lang["form_add_section"]["helps"]["view_cols"]); ?>
    </div>
    <div>
        <?
        if ($parent and $parent->view_ancestors) {
            $checked = "checked=\"checked\" ";
        } else {
            $checked = "";
        }
        ?>
    </div>
    <div>
        <label>
        <input type="checkbox" id="view_ancestors" name="view_ancestors" <? echo $checked; ?>/>
        <? echo $lang["form_add_section"]["labels"]["view_ancestors"]; ?>
        <? otk_help_button($lang["form_add_section"]["helps"]["view_ancestors"]); ?>
        </label>
    </div>
</fieldset>

<div><button type="submit"><? echo $lang["submit"]; ?></button></div>
<?
if ($parent) {
    echo "<div class=\"hidden\">
    <input type=\"hidden\" id=\"id_s\" name=\"id_s\" value=\"{$parent->id}\" />
    </div>
    ";
}
?>
</form>
<?
require("../../common/footer.php");
?>
