<?
/*
    +----------------------------------------------------------------------+
    | Xax is a modularized tool for administration of websites             |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: xax-ossigeno
    Module2: sections
    File
    /ossigeno/sections/form_edit_article.php?id_a
    This file displays a form to edit an article (with index.php)
*/

$module  = "ossigeno";
$module2 = "sections";
$only_users = TRUE;
$abc = "ossigeno/sections/form_edit_article.php?id_a=$_GET[id_a]";
include("../../common/config.php");

$url = "ossigeno/sections/index.php?";
$article = new Article($_GET["id_a"], TRUE);
$section = new Section($article->id_s);
if (!$super and !$permissions["sections"]["full"] and !$permissions["sections"]["full_{$section->id}"]) {
    otk_error($lang["errors"]["permissions"], $url);
}
//header
$header["title"] = $lang["titles"]["form_edit_article"];
require("../../common/header.php");
?>
<form method="post" action="ossigeno/sections/edit_article.php" enctype="multipart/form-data">
<fieldset>
    <div>
        <label for="title"><? echo $lang["form_edit_article"]["labels"]["title"]; ?>:
        <textarea rows="1" id="title" name="title"><? echo otk_html_unformat($article->title); ?></textarea>
    </div>
    <div>
        <label for="description"><? echo $lang["form_edit_article"]["labels"]["description"]; ?>:
        <textarea id="description" name="description"><? echo otk_html_unformat($article->description); ?></textarea><br />
        <? otk_sections_bar("description"); ?><br />
        <? otk_html_bar("description"); ?><br />
 
    </div>
    <div>
        <?
        $img = new OTK_Img("{$ossigeno}{$article->img}", "img");
        $img->ScaleToFit(50, 50);
        $img->SetStyle("float", "right");
        $img->Display();
        ?>
        <label for="img"><? echo $lang["form_edit_article"]["labels"]["img"]; ?>:</label>
        <input type="file" id="img" name="img" />
    </div>
    <?
    if (($section->type == "text") or ($section->type == "documentation")) {
        ?>
        <div>
            <label for="text"><? echo $lang["form_edit_article"]["labels"]["text"]; ?>:
            <textarea id="text" name="text" rows="20"><? echo otk_html_unformat($article->text); ?></textarea><br />
            <? otk_sections_bar(); ?><br />
            <? otk_html_bar(); ?><br />
            <? otk_html_smiles(); ?>
        </div>
        <div>
            <label for="tags">
            <? echo $lang["form_new_article"]["labels"]["tags"]; ?>:
            </label>
            <select id="tags" name="tags" multiple="multiple">
            <?
            $q = otk_sql_query("SELECT * FROM oss_sections ORDER BY name");;
            while ($s = otk_sql_fetch_array($q)) {
                $s = new Section($s["id"]);
                echo "<option";
                if (in_array($s->id, $article->tags)) {
                    echo " selected=\"selected\" ";
                }
                echo " value=\"{$s->id}\">{$s->name}</option>
                ";
            }
            ?>
            </select>
        </div>
        <?
    }

    if ($section->type=="gallery") {
        ?>
        <div>
            <label for="text"><? echo $lang["form_edit_article"]["labels"]["gallery"]; ?>:
            <input type="text" id="text" name="text" value="<? echo $article->text; ?>" />
        </div>
        <?
    }

    if ($section->type=="download") {
        ?>
        <div>
            <label for="text"><? echo $lang["form_edit_article"]["labels"]["download"]; ?>:
            <input type="text" id="text" name="text" value="<? echo $article->text; ?>" />
        </div>
        <?
    }

    if ($section->type=="link") {
        ?>
        <div>
            <label for="text"><? echo $lang["form_edit_article"]["labels"]["link"]; ?>:
            <input type="text" id="text" name="text" value="<? echo $article->text; ?>" />
        </div>
        <?
    }
    ?>
</fieldset>
<div><button type="submit"><? echo $lang["submit"]; ?></button></div>
<div class="hidden">
    <input type="hidden" id="id_a" name="id_a" value="<? echo $article->id; ?>" />
</div>
</form>
<?
require("../../common/footer.php");
?>
