<?
/*
    +----------------------------------------------------------------------+
    | Xax is a modularized tool for administration of websites             |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: xax-ossigeno
    Module2: sections
    File
    /ossigeno/sections/form_edit_section.php?id_s
    This file displays a form to edit a section (with management.php)
*/

$module  = "ossigeno";
$module2 = "sections";
$only_users = TRUE;
$abc = "ossigeno/sections/form_edit_section.php?id_s={$_GET["id_s"]}";
include("../../common/config.php");

$url = "ossigeno/sections/index.php?";
if (!$super) {
    otk_error($lang["errors"]["permissions"], $url);
}
$section = new Section($_GET["id_s"], TRUE); //edit mode
if (!$section->id) {
    otk_error($lang["errors"]["wrong_field"], $url);
}
//header
$header["title"] = $lang["titles"]["form_edit_section"];
require("../../common/header.php");
?>
<form action="ossigeno/sections/edit_section.php" method="post" enctype="multipart/form-data">
<fieldset>
    <legend><? echo $lang["form_edit_section"]["legends"]["main"]; ?></legend>

    <div>
        <label for="name"><? echo $lang["form_edit_section"]["labels"]["name"]; ?>:</label>
        <textarea rows="1" id="name" name="name"><? echo $section->name; ?></textarea>
    </div>

    <div>
        <label for="description"><? echo $lang["form_edit_section"]["labels"]["description"]; ?>:</label>
        <textarea id="description" name="description"><? echo $section->description; ?></textarea><br />
            <? otk_sections_bar("description"); ?><br />
            <? otk_html_bar("description"); ?><br />
    </div>

    <div>
        <?
        $img = new OTK_Img("{$ossigeno}{$section->img}", "img");
        $img->ScaleToFit(50, 50);
        $img->SetStyle("float", "right");
        $img->Display();
        ?>
        <label for="img"><? echo $lang["form_edit_section"]["labels"]["img"]; ?>:</label>
        <input type="file" id="img" name="img" />
    </div>
    <div>
        <label for=""><? echo $lang["form_edit_section"]["labels"]["info"]; ?>:</label>
        <textarea id="info" name="info"><? echo $section->info; ?></textarea><br />
            <? otk_sections_bar("info"); ?><br />
            <? otk_html_bar("info"); ?><br />
    </div>
    <div>
        <label for=""><? echo $lang["form_edit_section"]["labels"]["id_s"]; ?>:</label>
        <input type="text" id="id_s" name="id_s" value="<? echo $section->id_s; ?>" />
    </div>
</fieldset>

<fieldset>
    <legend><? echo $lang["form_edit_section"]["legends"]["view"]; ?></legend>
    <div>
        <label for="view_order"><? echo $lang["form_edit_section"]["labels"]["view_order"]; ?>:</label>
        <select id="view_order" name="view_order">
        <?
        foreach ($lang["form_edit_section"]["values"]["view_order"] as $value => $display) {
            if ($section->view_order == $value) {
                $selected = " selected=\"selected\"";
            } else {
                $selected = "";
            }
            echo "<option value=\"{$value}\"{$selected}>{$display}</option>
            ";
        }
        ?>
        </select>
        <? otk_help_button($lang["form_edit_section"]["helps"]["view_order"]); ?>
    </div>
    <div>
        <label for="view_limit"><? echo $lang["form_edit_section"]["labels"]["view_limit"]; ?>:</label>
        <input type="text" id="view_limit" name="view_limit" value="<? echo $section->view_limit; ?>" />
        <? otk_help_button($lang["form_edit_section"]["helps"]["view_limit"]); ?>
    </div>
    <div>
        <label for="view_cols"><? echo $lang["form_edit_section"]["labels"]["view_cols"]; ?>:</label>
        <input type="text" id="view_cols" name="view_cols" value="<? echo $section->view_cols; ?>" />
        <? otk_help_button($lang["form_edit_section"]["helps"]["view_cols"]); ?>
    </div>
    </div>
        <?
        if ($section->view_ancestors) {
            $checked = "checked=\"checked\" ";
        } else {
            $checked = "";
        }
        ?>
        <label for="view_ancestors">
        <input type="checkbox" id="view_ancestors" name="view_ancestors" <? echo $checked; ?>/>
        <? echo $lang["form_edit_section"]["labels"]["view_ancestors"]; ?>
        <? otk_help_button($lang["form_edit_section"]["helps"]["view_ancestors"]); ?>
        </label>
    </div>
</fieldset>

<div><button type="submit"><? echo $lang["submit"]; ?></button></div>
<input type="hidden" id="id" name="id" value="<? echo $section->id; ?>" />
</form>
<?
require("../../common/footer.php");
?>
