<?
/*
    +----------------------------------------------------------------------+
    | Xax is a modularized tool for administration of websites             |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: xax-ossigeno
    Module2: statistics
    File
    /ossigeno/statistics/year.php
    This file shows statistics of the year
*/

$module  = "ossigeno";
$module2 = "statistics";
$only_users = TRUE;
$abc = "ossigeno/statistics/year.php";
include("../../common/config.php");

if (!$super and !$permissions["statistics"]["full"]) {
    otk_error($lang["errors"]["permissions"], $url);
}
//header
$header["title"] = $lang["titles"]["year"];
$header["style"] .= "
table.info
{
    height: auto;
    width: auto;
}
td.info
{
    width: 12px;
}
td.bar_visits
{
    width: 12px;
    height: 350px;
    vertical-align: bottom;
}
td.bar_users
{
    width: 12px;
    height: 150px;
    vertical-align: bottom;
}
div.bar
{
    background-color: #000066;
    width: 10px;
}
a.counter
{
    display: block;
    width: 100%;
    height: 100%;
}
";
require("../../common/header.php");
$q = otk_sql_query("SELECT COUNT(*) AS number FROM oss_statistics");
$r = otk_sql_fetch_array($q);
$start = $r["number"] - 365;
if ($start < 0) {
    $start = 0;
}
$q = otk_sql_query("SELECT day, visits, COUNT(ip) AS users FROM oss_statistics, oss_statistics_ips WHERE oss_statistics.id = oss_statistics_ips.id_d GROUP BY id_d ORDER BY id ASC LIMIT {$start}, 365");
while ($date = otk_sql_fetch_array($q)) {
    $year  = (int) substr($date["day"], 0, 4);
    $month = (int) substr($date["day"], 5, 2);
    $day   = (int) substr($date["day"], 8, 2);
    $months_visits[$month] += $date["visits"];
    $months_users[$month]  += $date["users"];
}
?>
<div class="links">Pagine visitate</div>
<table class="info">
<tr>
<td class="bar_visits" style="width: 40px;">
    <div style="position: relative;">
        <div style="position: absolute; left: 1px; bottom: 300px; width: 30px; height: 20px;">3000</div>
        <div style="position: absolute; left: 1px; bottom: 250px; width: 30px; height: 20px;">2500</div>
        <div style="position: absolute; left: 1px; bottom: 200px; width: 30px; height: 20px;">2000</div>
        <div style="position: absolute; left: 1px; bottom: 150px; width: 30px; height: 20px;">1500</div>
        <div style="position: absolute; left: 1px; bottom: 100px; width: 30px; height: 20px;">1000</div>
        <div style="position: absolute; left: 1px; bottom: 50px; width: 30px; height: 20px;">500</div>
    </div>
</td>
<?
$info = array();
foreach ($months_visits as $month => $visits) {
    echo "<td class=\"bar_visits\">";
    $height = round($visits / 10);
    echo "<div class=\"bar\" style=\"height: {$height}px;\"><a title=\"$visits\" class=\"counter\" href=\"#\" onclick=\"return false;\"></a>
</div>";
    echo "</td>
    ";
    $info[] = "{$month}";
}
?>
</tr>
<tr>
<td></td>
<?
    foreach ($info as $value) {
        echo "<td class=\"info\">
        $value
        </td>
        ";
    }
?>
</tr>
</table>
<br />
<div class="links">Utenti unici</div>
<table class="info">
<tr>
<td class="bar_users" style="width: 40px;">
    <div style="position: relative;">
        <div style="position: absolute; left: 1px; bottom: 100px; width: 30px; height: 20px;">1000</div>
        <div style="position: absolute; left: 1px; bottom: 50px; width: 30px; height: 20px;">500</div>
    </div>
</td>
<?
$info = array();
foreach ($months_users as $month => $users) {
    echo "<td class=\"bar_users\">";
    $height = round($users / 10);
    echo "<div class=\"bar\" style=\"height: {$height}px;\"><a title=\"$users\" class=\"counter\" href=\"#\" onclick=\"return false;\"></a>
</div>";
    echo "</td>
    ";
    $info[] = "{$month}";
}
?>
</tr>
<tr>
<td></td>
<?
    foreach ($info as $value) {
        echo "<td class=\"info\">
        $value
        </td>
        ";
    }
?>
</tr>
</table>
<div class="links">
<a href="ossigeno/statistics/index.php">Gestione Statistics</a>
</div>
<?
require("../../common/footer.php");
?>
