<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Kernel
    File
    /common/classes/forum.php
    This file defines the classes for forum management
*/

require_once("sql.php");

class OTK_Forum extends OTK_Record
{
    var $id_f;
    var $name;
    var $description;
    var $type;
    var $reserved;
    var $private;

    function OTK_Forum($id)
    {
        parent::OTK_Record("oss_forums", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (id = '{$id}')");
        if (otk_sql_num_rows($q)) {
            $forum = otk_sql_fetch_array($q);
            $this->id          = (int)    $forum["id"];
            $this->id_f        = (int)    $forum["id_f"];
            $this->id_t        = (int)    $forum["id_t"];
            $this->name      = (string) $forum["name"];
            $this->description = (string) $forum["description"];
            $this->type        = (string) $forum["type"];
            $this->reserved    = (int)    $forum["reserved"];
            $this->private     = (int)    $forum["private"];
           
            $this->_RegisterFields();
        } else {
            $this->Clear($this);
        }
    }

    //forum title with ancestors
    function Title()
    {
        $title = ucwords($this->name);
        //search of parent forum
        //forum without parent -> id_f==0
        $i = $this->id_f;
        while($i != 0) {
            $q = otk_sql_query("SELECT * FROM oss_forums WHERE (id = '{$i}') ORDER BY name ASC");
            $parent = otk_sql_fetch_array($q);
            $parent = new OTK_Forum($parent["id"]);
            //title and bar of link
            $title = ucwords($parent->name)." - {$title}";
            $i = $parent->id_f;
        }
        return $title;
    }

    //forum link bar with ancestors
    function Bar()
    {
        $bar = "<a href=\"forum/forum.php?id_f={$this->id}\">".ucwords($this->name)."</a>";
        //search of parent forum
        //forum without parent -> id_f==0
        $i = $this->id_f;
        while ($i != 0) {
            $q = otk_sql_query("SELECT * FROM oss_forums WHERE (id = '$i') ORDER BY name ASC");
            $parent = otk_sql_fetch_array($q);
            $parent = new OTK_Forum($parent["id"]);
            //title and bar of link
            $bar = "<a href=\"forum/forum.php?id_f={$parent->id}\">".ucwords($parent->name)."</a> - ".$bar;
            $i = $parent->id_f;
        }
        return $bar;
    }

    //returns links at moderators profiles
    function GetModerators()
    {
        //names of moderators
        $p = "moderator_{$this->id}";
        $q = otk_sql_query("SELECT * FROM oss_permissions WHERE type = 'U' AND module = 'forum' AND operation = '{$p}'");
        $mods = array();
        while($moderator = otk_sql_fetch_array($q)) {
            $mods[] = "<a href=\"community/profile.php?name={$moderator["name"]}\">{$moderator["name"]}</a>";
        }
        return implode(", ", $mods);
    }

    //returns links at group which are moderators profiles
    function GetGroups()
    {
        //names of group moderators
        $p = "moderator_{$this->id}";
        $q = otk_sql_query("SELECT * FROM oss_permissions WHERE type = 'G' AND module = 'forum' AND operation = '{$p}'");
        $groups = array();
        while ($record = otk_sql_fetch_array($q)) {
            $g = new OTK_Group($record["name"]);
            $groups .= "<a href=\"community/profile_group.php?id_g={$g->id}\">{$g->name}</a>";
        }
        return implode(", ", $groups);
    }

    function NumberThreads()
    {
        $q = otk_sql_query("SELECT * FROM oss_threads WHERE id_f = '{$this->id}'");
        return otk_sql_num_rows($q);
    }

    function NumberPosts()
    {
        $q = otk_sql_query("SELECT * FROM oss_posts WHERE id_f = '{$this->id}'");
        return otk_sql_num_rows($q);
    }

    function GetLastPost()
    {
        $q = otk_sql_query("SELECT * FROM oss_posts WHERE id_f = '{$this->id}' ORDER BY id DESC");
        $last_post = otk_sql_fetch_array($q);
        $last_post = new OTK_Post($last_post["id"]);
        return $last_post;
    }

    function GetLastThread()
    {
        $last_post = $this->GetLastPost();
        $q = otk_sql_query("SELECT * FROM oss_threads WHERE id = '{$last_post->id_t}'");
        $last_thread = otk_sql_fetch_array($q);
        $last_thread = new OTK_Thread($last_thread["id"]);
        return $last_thread;
    }
}

class OTK_Thread extends OTK_Record
{
    var $id_f;
    var $img;
    var $name;
    var $description;
    var $cons;
    var $date;
    var $evidence;
    var $follow;
    var $closed;

    function OTK_Thread($id)
    {
        parent::OTK_Record("oss_threads", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id = '{$id}'");
        if (otk_sql_num_rows($q)) {
            $thread = otk_sql_fetch_array($q);
            $this->id          = (int)    $thread["id"];
            $this->id_f        = (int)    $thread["id_f"];
            $this->img         = (string) $thread["img"];
            $this->name      = (string) $thread["name"];
            $this->description = (string) $thread["description"];
            $this->cons        = (int)    $thread["cons"];
            $this->date        = (int)    $thread["date"];
            $this->evidence    = (int)    $thread["evidence"];
            $this->closed      = (int)    $thread["closed"];
           
            $this->_RegisterFields();
           
            //special fields
            $this->followers   = array();
            $q = otk_sql_query("SELECT * FROM oss_threads_followers WHERE (id_t = '{$this->id}')");
            while ($follower = otk_sql_fetch_array($q)) {
                $this->followers[] = $follower["nick"];
            }
        } else {
            $this->Clear($this);
        }
    }

    function NumberPosts()
    {
        $q = otk_sql_query("SELECT * FROM oss_posts WHERE id_t = '{$this->id}'");
        $n_p = otk_sql_num_rows($q);
        return $n_p;
    }

    function Cons()
    {
        $this->Set("cons", $this->cons + 1);
    }

    function GetFirstPost()
    {
        $q = otk_sql_query("SELECT * FROM oss_posts WHERE id_t = '{$this->id}' ORDER BY id ASC");
        $first_post = otk_sql_fetch_array($q);
        $first_post = new OTK_Post($first_post["id"]);
        return $first_post;
    }

    function GetLastPost()
    {
        $q = otk_sql_query("SELECT * FROM oss_posts WHERE id_t = '{$this->id}' ORDER BY id DESC");
        $last_post = otk_sql_fetch_array($q);
        $last_post = new OTK_Post($last_post["id"]);
        return $last_post;
    }

    function AddFollower($nick)
    {
        if (in_array($nick, $this->followers)) {
            return FALSE;
        }
        $q = otk_sql_query("INSERT INTO oss_threads_followers
        (id_t, nick)
        VALUES (
        '{$this->id}',
        '{$nick}'
        )");
        if ($q) {
            $this->followers[] = $nick;
        }
        return $q;
    }

    function RemoveFollower($nick)
    {
        if (!in_array($nick, $this->followers)) {
            return FALSE;
        }
        $q = otk_sql_query("DELETE FROM oss_threads_followers WHERE ((id_t = '{$this->id}') AND (nick = '{$nick}'))");
        if ($q) {
            $index = array_search($nick, $this->followers);
            unset($this->followers[$index]);
        }
        return $q;
    }
}

class OTK_Post extends OTK_Record
{
    var $id_t;
    var $id_f;
    var $author;
    var $text;
    var $date;
    var $modified_nick;
    var $modified_date;

    function OTK_Post($id)
    {
        parent::OTK_Record("oss_posts", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id = '{$id}'");
        if (otk_sql_num_rows($q)) {
            $post = otk_sql_fetch_array($q);
            $this->id            = (int)    $post["id"];
            $this->id_t          = (int)    $post["id_t"];
            $this->id_f          = (int)    $post["id_f"];
            $this->author        = (string) $post["author"];
            $this->text          = (string) $post["text"];
            $this->date          = (int)    $post["date"];
            $this->modified_nick = (string) $post["modified_nick"];
            $this->modified_date = (int)    $post["modified_date"];
           
            $this->_RegisterFields();
        } else {
            $this->Clear($this);
        }
    }

    function Presentation()
    {
        $thread = new OTK_Thread($this->id_t);
        $presentation = "<a href=\"community/profile.php?name={$this->author}\">{$this->author}</a>,<br />
        ". otk_time_getdate($this->date)."<br />
        => <a href=\"forum/thread.php?id_t={$thread->id}&amp;go_last_post=1\">{$thread->name}</a>
        ";
        return $presentation;
    }
}
?>
