<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Kernel
    File
    /common/classes/sql.php
    This file defines the classes OTK_User, OTK_Group, OTK_Forum, ...
*/

class OTK_Record //abstract
{
    //this class represents a sql record (extended by all other classes)
    var $id;
    var $_pk;
    var $_table;

    function OTK_Record($table, $pk = "id")
    {
        //MySQL table name
        $this->_table = $table;
        //primary key
        $fields = explode(",", $pk);
        $this->_pk = array_map("trim", $fields);
    }

    function otk_record_convert_field($f) { return "({$f} = '{$this->{$f}}')"; }

    //WHERE clauses on primary key
    function _Where()
    {
        $clauses = array_map(array(&$this, "otk_record_convert_field"), $this->_pk);
        return "WHERE (" . implode(" AND ", $clauses) . ")";
    }
   
    function _RegisterFields()
    {
        $fields = array();
        foreach ($this as $name => $value) {
            if (substr($name, 0, 1) != "_") {
                $fields[] = $name;
            }
        }
        $this->_fields = $fields;
    }

    function Set($field, $value)
    {
        //sets $field to $value
        $field = (string) $field;
        $value = (string) $value;
        if (!in_array($field, $this->_fields)) {
            return FALSE;
        }
        $q = otk_sql_query("UPDATE {$this->_table} SET {$field}='{$value}' " . $this->_WHERE());
        $this->$field = $value;
        return (bool) $q;
    }

    //sets $field to NULL
    function Reset($field)
    {
        $field = (string) $field;
        if (!in_array($field, $this->_fields)) {
            return FALSE;
        }
        $q = otk_sql_query("UPDATE {$this->_table} SET {$field}=NULL " . $this->_WHERE());
        $this->$field = NULL;
        return (bool) $q;
    }

    function Get($field)
    {
        //returns $field
        return $this->$field;
    }

    function Clear($object)
    {
        $object = NULL;
    }
}

class OTK_Permissions
{
    var $name;
    var $type;
    var $content;

    function OTK_Permissions($name, $type)
    {
        $this->content = array();
        $q = otk_sql_query("SELECT * FROM oss");
        while ($m = otk_sql_fetch_array($q)) {
            $this->content[$m["name"]] = array();
        }
        $this->content["forum"] = array();
        $this->content["surveys"] = array();
        $q = otk_sql_query("SELECT * FROM oss_permissions WHERE ((name = '{$name}') AND (type = '{$type}'))");
        $this->name = $name;
        $this->type = $type;
        while ($p = otk_sql_fetch_array($q)) {
            $this->content[$p["module"]][$p["operation"]] = TRUE;
        }
    }

    //sets tables using $this->content
    function Update()
    {
        otk_sql_query("DELETE FROM oss_permissions WHERE (
                    (name = '{$this->name}') AND
                    (type = '{$this->type}')
                    )");
        foreach ($this->content as $module => $operations) {
            foreach ($operations as $operation => $permitted) {
                if ($permitted) {
                    otk_sql_query("INSERT INTO oss_permissions
                    (name, type, module, operation)
                    VALUES (
                    '{$this->name}',
                    '{$this->type}',
                    '{$module}',
                    '{$operation}'
                    )");
                }
            }
        }
        return TRUE;
    }
}

class OTK_Fields
{
    var $name;
    var $class;
    var $names;
    var $content;

    function OTK_Fields($name, $class)
    {
        $this->name  = $name;
        $this->class = $class;
        $q = otk_sql_query("SELECT * FROM oss_fields WHERE (class = '{$class}')");
        $this->content = array();
        $this->names = array();
        while ($field = otk_sql_fetch_array($q)) {
            $q2 = otk_sql_query("SELECT * FROM oss_fields_values WHERE ((id_f = '{$field["id"]}') AND (name = '{$name}'))");
            while ($value = otk_sql_fetch_array($q2)) {
                $this->content[$field["id"]] = $value["value"];
                $this->names[$field["id"]] = $field["name"];
            }
        }
    }

    //sets custom field $id of $this->name (user, group) to $value
    function Set($id, $value)
    {
        //record already existent or not
        if ($this->content[$id] !== NULL) {
            if ($value == "")  {
                $q = otk_sql_query("DELETE FROM oss_fields_values WHERE ((name = '{$this->name}') AND (id_f = '{$id}'))");
            } else {
                $q = otk_sql_query("UPDATE oss_fields_values SET value='{$value}' WHERE ((name = '{$this->name}') AND (id_f = '{$id}'))");
            }
        } else if ($value != "") {
            $q = otk_sql_query("INSERT INTO oss_fields_values
            (name, id_f, value)
            VALUES (
            '{$this->name}',
            '{$id}',
            '{$value}'
            )");
        }

        //updating content and name of field
        if ($q) {
            $this->content[$id] = $value;
            $q2 = otk_sql_query("SELECT * FROM oss_fields WHERE (id = '{$id}')");
            $field = otk_sql_fetch_array($q2);
            $this->names[$id] = $field["name"];
        }

        return $q;
    }
}

class OTK_Page extends OTK_Record
{
    var $name;
    var $type;
    var $html;
    function OTK_Page($name, $type)
    {
        parent::OTK_Record("oss_pages", "name,type");
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE ((name = '{$name}') AND (type = '{$type}'))");
        $p = otk_sql_fetch_array($q);
        if ($p) {
            $this->id   = NULL;
            $this->name = (string) $p["name"];
            $this->type = (string) $p["type"];
            $this->html = (string) $p["html"];
            $this->_RegisterFields();
        } else {
            $this->Clear($this);
        }
    }
}

class OTK_User extends OTK_Record
{
    var $name;
    var $gender;
    var $mail;
    var $address;
    var $locality;
    var $province;
    var $country;
    var $nick;
    var $pwd;
    var $date;
    var $job;
    var $www;
    var $avatar;
    var $icq;
    var $msnm;
    var $aim;
    var $yim;
    var $honour;
    var $friends;
    var $ignored;
    var $show_mail;
    var $warning;
    var $signature;
    var $extra;
    var $num;
    var $active;
    var $lost_pwd;
    var $rank;
    var $title;
    var $group_name;
    var $permissions;
    var $fields;
    var $session;
    var $page;
    var $follow;
    var $points;
    var $log;
    var $online;
    var $timezone;
    var $dst;
    var $last_visit;
    var $last_action;

    function OTK_User($nick)
    {
        parent::OTK_Record("oss_users", "nick");
        $nick = (string) $nick;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (nick = '{$nick}')");
        if (otk_sql_num_rows($q)) {
            $user = otk_sql_fetch_array($q);
            $this->id          = (int)    $user["id"];
            $this->id_g        = /*NULL*/ $user["id_g"];
            $this->name        = (string) $user["name"];
            $this->gender      = (string) $user["gender"];
            $this->mail        = (string) $user["mail"];
            $this->address     = (string) $user["address"];
            $this->locality    = (string) $user["locality"];
            $this->province    = (string) $user["province"];
            $this->country     = (string) $user["country"];
            $this->nick        = (string) $user["nick"];
            $this->pwd         = (string) $user["pwd"];
            $this->date        = (int)    $user["date"];
            $this->job         = (string) $user["job"];
            $this->www         = (string) $user["www"];
            $this->avatar      = (string) $user["avatar"];
            $this->icq         = (int)    $user["icq"];
            $this->msnm        = (string) $user["msnm"];
            $this->aim         = (string) $user["aim"];
            $this->yim         = (string) $user["yim"];
            $this->honour      = (string) $user["honour"];
            $this->show_mail   = (int)    $user["show_mail"];
            $this->newsletter  = (int)    $user["newsletter"];
            $this->signature   = (string) $user["signature"];
            $this->extra       = (string) $user["extra"];
            $this->num         = (int)    $user["num"];
            $this->active      = (int)    $user["active"];
            $this->lost_pwd    = (int)    $user["lost_pwd"];
            $this->rank        = (int)    $user["rank"];
            $this->title       = (string) $user["title"];
            $this->session     = (int)    $user["session"];
            $this->follow      = (string) $user["follow"];
            $this->points      = (int)    $user["points"];
            $this->warning     = (int)    $user["warning"];
            $this->timezone    =          $user["timezone"];
            $this->last_visit  = (int)    $user["last_visit"];
            $this->last_action = (int)    $user["last_action"];
           
            $this->_RegisterFields();
           
            //special fields
            //online
            $q = otk_sql_query("SELECT * FROM oss_users_online WHERE ((type = 'U') AND (name = '{$this->nick}'))");
            $this->online     = (bool) otk_sql_num_rows($q);

            //groups
            $this->groups = array();
            $q = otk_sql_query("SELECT * FROM oss_users_groups WHERE (nick = '{$this->nick}')");
            while ($r = otk_sql_fetch_array($q)) {
                $this->groups[] = $r["id_g"];
            }

            //permissions
            $this->permissions = new OTK_Permissions($user["nick"], "U");

            //custom fields
            $this->fields = new OTK_Fields($this->nick, "U");

            //friends and ignored users
            $q = otk_sql_query("SELECT * FROM oss_users_relatives WHERE (nick = '{$this->nick}')");
            $this->friends = array();
            $this->ignored = array();
            while ($u = otk_sql_fetch_array($q)) {
                if ($u["type"] == "F") {
                    $this->friends[] = (string) $u["name"];
                } else { //if ($u["type"] == "I") {
                    $this->ignored[] = (string) $u["name"];
                }
            }

            //personal page
            $this->page = new OTK_Page($this->nick, "U");

            //warning logs
            $this->log = array();
            $q = otk_sql_query("SELECT * FROM oss_users_warning_logs WHERE (nick = '{$this->nick}') ORDER BY date");
            while ($log = otk_sql_fetch_array($q)) {
                $this->log[$log["date"]] = $log["text"];
            }
        } else {
            $this->Clear($this);
        }
    }

    function Update()
    {
        $q = otk_sql_query("SELECT * FROM oss_levels WHERE (min >= 0)");
        if ($this->rank < 7) {
            while ($level = otk_sql_fetch_array($q)) {
                if (($this->points >= $level["min"]) and ($this->points <= $level["max"])) {
                    $q2 = $this->Set("rank", $level["rank"]);
                    $q3 = $this->Set("title", $level["name"]);
                }
            }
        }
        $this->permissions->Update();
        return (bool) ($q2 and $q3);
    }

    function IncPoints($points)
    {
        $points = (int) $points;
        $points = $this->points + $points;
        $q  = $this->Set("points", $points);
        $q2 = $this->Update();
        return (bool) ($q and $q2);
    }

    function DecPoints($points)
    {
        $points = (int) $points;
        $points = $this->points - $points;
        echo $points;
        $q  = $this->Set("points", $points);
        $q2 = $this->Update();
        return (bool) ($q and $q2);
    }

    function GetNewMessages()
    {
        $q = otk_sql_query("SELECT * FROM oss_messages WHERE (adressee = '{$this->nick}') AND (seen = '0') AND (deleted_to = '0')");
        $new_messages = otk_sql_num_rows($q);
        return (int) $new_messages;
    }

    function AddFriend($nick)
    {
        if (otk_sql_num_rows(otk_sql_query("SELECT * FROM oss_users_relatives WHERE ((nick = '{$this->nick}') AND (name = '{$nick}') AND (type = 'F'))"))) {
            return FALSE;
        }
        if (!otk_sql_num_rows(otk_sql_query("SELECT * FROM oss_users WHERE (nick = '{$nick}')"))) {
            return FALSE;
        }
        $q = otk_sql_query("INSERT INTO oss_users_relatives
        (nick, name, type)
        VALUES ('{$this->nick}',
        '{$nick}',
        'F'
        )");
        if ($q) {
            $this->friends[] = $nick;
        }
        return $q;
    }

    function AddIgnored($nick)
    {
        if (otk_sql_num_rows(otk_sql_query("SELECT * FROM oss_users_relatives WHERE ((nick = '{$this->nick}') AND (name = '{$nick}') AND (type = 'I'))"))) {
            return FALSE;
        }
        if (!otk_sql_num_rows(otk_sql_query("SELECT * FROM oss_users WHERE (nick = '{$nick}')"))) {
            return FALSE;
        }
        $q = otk_sql_query("INSERT INTO oss_users_relatives
        (nick, name, type)
        VALUES ('{$this->nick}',
        '{$nick}',
        'I'
        )");
        if ($q) {
            $this->ignored[] = $nick;
        }
        return $q;
    }

    function DeleteFriend($nick)
    {
        if (!otk_sql_num_rows(otk_sql_query("SELECT * FROM oss_users_relatives WHERE ((nick = '{$this->nick}') AND (name = '{$nick}') AND (type = 'F'))"))) {
            return FALSE;
        }
        $q = otk_sql_query("DELETE FROM oss_users_relatives WHERE ((nick = '{$this->nick}') AND (name = '{$nick}') AND (type = 'F'))");
        $index = array_search($nick, $this->friends);
        if ($q and $index !== NULL) {
            $this->friends[$index] = NULL;
        }
        return $q;
    }

    function DeleteIgnored($nick)
    {
        if (!otk_sql_num_rows(otk_sql_query("SELECT * FROM oss_users_relatives WHERE ((nick = '{$this->nick}') AND (name = '{$nick}') AND (type = 'I'))"))) {
            return FALSE;
        }
        $q = otk_sql_query("DELETE FROM oss_users_relatives WHERE ((nick = '{$this->nick}') AND (name = '{$nick}') AND (type = 'I'))");
        $index = array_search($nick, $this->ignored);
        if ($q and $index !== NULL) {
            $this->ignored[$index] = NULL;
        }
        return $q;
    }

    function AddGroup($id_g)
    {
        if (in_array($id_g, $this->groups)) {
            return FALSE;
        }
        $q = otk_sql_query("INSERT INTO oss_users_groups
        (nick, id_g)
        VALUES (
        '{$this->nick}',
        '{$id_g}'
        )");
        return $q;
    }

    function DeleteGroup($id_g)
    {
        if (!in_array($id_g, $this->groups)) {
            return FALSE;
        }
        $q = otk_sql_query("DELETE FROM oss_users_groups WHERE ((nick = '{$this->nick}') AND (id_g = '{$id_g}'))");
        if ($this->id_g == $id_g) {
            $this->Reset("id_g");
        }
        return $q;
    }
}

class OTK_Group extends OTK_Record
{
    var $id_g;
    var $name;
    var $img;
    var $founder;
    var $description;
    var $permissions;

    function OTK_Group($id)
    {
        parent::OTK_Record("oss_groups");
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (id = '{$id}')");
        if (otk_sql_num_rows($q)) {
            $group = otk_sql_fetch_array($q);
            $this->id          = (int)    $group["id"];
            $this->id_g        = (int)    $group["id_g"];
            $this->name        = (string) $group["name"];
            $this->img         = (string) $group["img"];
            $this->founder     = (string) $group["founder"];
            $this->description = (string) $group["description"];
           
            $this->_RegisterFields();
           
            //special fields
            $this->permissions = new OTK_Permissions($group["id"], "G");
            //custom fields
            $this->fields = new OTK_Fields($group["id"], "G");
        } else {
            $this->Clear($this);
        }
    }
}

class OTK_Message extends OTK_Record
{
    var $sender;
    var $adressee;
    var $date;
    var $seen;
    var $deleted_to;
    var $deleted_from;
    var $subject;
    var $text;

    function OTK_Message($id)
    {
        parent::OTK_Record("oss_messages", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id = '{$id}'");
        if (otk_sql_num_rows($q)) {
            $message = otk_sql_fetch_array($q);
            $this->id            = (int)    $message["id"];
            $this->sender        = (string) $message["sender"];
            $this->adressee      = (string) $message["adressee"];
            $this->date          = (int)    $message["date"];
            $this->seen          = (int)    $message["seen"];
            $this->deleted_to    = (int)    $message["deleted_to"];
            $this->deleted_from  = (int)    $message["deleted_from"];
            $this->subject       = (string) $message["subject"];
            $this->text          = (string) $message["text"];
           
            $this->_RegisterFields();
        } else {
            $this->Clear($this);
        }
    }
}

class OTK_Partner extends OTK_Record
{
    var $href;
    var $name;

    function OTK_Partner($id)
    {
        parent::OTK_Record("oss_partners", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id = '{$id}'");
        if (otk_sql_num_rows($q)) {
            $partner = otk_sql_fetch_array($q);
            $this->id   = (int)    $partner["id"];
            $this->href = (string) $partner["href"];
            $this->name = (string) $partner["name"];
           
            $this->_RegisterFields();
        } else {
            $this->Clear($this);
        }
    }
}

class OTK_Level extends OTK_Record
{
    var $name;
    var $rank;
    var $min;
    var $max;

    function OTK_Level($id)
    {
        parent::OTK_Record("oss_levels", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (id = '{$id}')");
        if (otk_sql_num_rows($q)) {
            $level = otk_sql_fetch_array($q);
            $this->name = (string) $level["name"];
            $this->rank = (int)    $level["rank"];
            $this->min  = (int)    $level["min"];
            $this->max  = (int)    $level["max"];
           
            $this->_RegisterFields();
        } else {
            $this->Clear($this);
        }
    }
}

class OTK_Module extends OTK_Record
{
    var $name;
    var $date;

    function OTK_Module($name)
    {
        parent::OTK_Record("oss", "id");
        $name = (string) $name;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (name = '{$name}')");
        if (otk_sql_num_rows($q)) {
            $module = otk_sql_fetch_array($q);
            $this->id      = (int)    $module["id"];
            $this->name    = (string) $module["name"];
            $this->date    = (int)    $module["date"];
           
            $this->_RegisterFields();
        } else {
            $this->Clear($this);
        }
    }
}

class OTK_News extends OTK_Record
{
    var $author;
    var $title;
    var $href;
    var $img;
    var $text;
    var $date;
    var $cons;

    function OTK_News($id)
    {
        parent::OTK_Record("oss_news", "id");
        $id = (int) $id;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id = '{$id}'");
        if (otk_sql_num_rows($q)) {
            $news = otk_sql_fetch_array($q);
            $this->id     = (int)    $news["id"];
            $this->author = (string) $news["author"];
            $this->title  = (string) $news["title"];
            $this->href   = (string) $news["href"];
            $this->img    = (string) $news["img"];
            $this->text   = (string) $news["text"];
            $this->date   = (int)    $news["date"];
            $this->cons   = (int)    $news["cons"];
           
            $this->_RegisterFields();
        } else {
            $this->Clear($this);
        }
    }
}
?>
