<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Kernel
    File
    /common/classes/surveys.php
    This file defines the classes for surveys management
*/

require_once("sql.php");

class OTK_SurveysOption extends OTK_Record
{
    var $id_s;
    var $value;

    function OTK_SurveysOption($id)
    {
        parent::OTK_Record("oss_surveys_options", "id");
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (id = '{$id}')");
        if (otk_sql_num_rows($q)) {
            $o = otk_sql_fetch_array($q);
            $this->id     = (int)    $o["id"];
            $this->id_s   = (int)    $o["id_s"];
            $this->value  = (string) $o["value"];
           
            $this->_RegisterFields();
        } else {
            $this->Clear($this);
        }
    }

    function NumberVotes()
    {
        $q = otk_sql_query("SELECT COUNT(*) AS votes FROM oss_surveys_voters WHERE (id_o = '{$this->id}')");
        $result = otk_sql_fetch_array($q);
        return $result["votes"];
    }

    function GetVoters()
    {
        $q = otk_sql_query("SELECT voter FROM oss_surveys_voters WHERE (id_o = '{$this->id}')");
        $voters = array();
        while ($v = otk_sql_fetch_array($q)) {
            $voters[] = $v["voter"];
        }
        return $voters;
    }

    function Vote($nick)
    {
        $q = otk_sql_query("INSERT INTO oss_surveys_voters
        (id_o, voter)
        VALUES (
        '{$this->id}',
        '{$nick}'
        )");
        return $q;
    }
}

class OTK_Survey extends OTK_Record
{
    var $id_t;
    var $question;
    var $voters;
    var $options;
    var $votes;
    var $closed;

    function OTK_Survey($id)
    {
        parent::OTK_Record("oss_surveys", "id");
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE id = '{$id}'");
        if (otk_sql_num_rows($q)) {
            $survey = otk_sql_fetch_array($q);
            $this->id       = (int)    $survey["id"];
            $this->id_t     = (int)    $survey["id_t"];
            $this->question = (string) $survey["question"];
            $this->closed   = (int)    $survey["closed"];
           
            $this->_RegisterFields();
           
            //special fields
            //options and votes
            $q = otk_sql_query("SELECT * FROM oss_surveys_options WHERE (id_s = '{$this->id}')");
            $this->options  = array();
            $this->voters = array();
            while ($o = otk_sql_fetch_array($q)) {
                $o = new OTK_SurveysOption($o["id"]);
                $this->options[] = $o;
                $this->voters = array_merge($this->voters, $o->GetVoters());
            }
        } else {
            $this->Clear($this);
        }
    }

    function Vote($id_o, $nick)
    {
        //closed survey
        if ($this->closed) {
            return FALSE;
        }

        //already voted
        if (in_array($nick, $this->voters)) {
            return FALSE;
        }

        //consistent and correct option
        $index = NULL;
        foreach ($this->options as $i => $o) {
            if ($o->id == $id_o) {
                $index = $i;
            }
        }
        if ($index === NULL) {
            return FALSE;
        }
        $o = $this->options[$index];
        //voting
        $q = $o->Vote($nick);
        return $q;
    }

    function NumberVotes()
    {
        $total = 0;
        foreach ($this->options as $o) {
            $total += $o->NumberVotes();
        }
        return $total;
    }
}
?>
