<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Kernel
    File
    /common/config.php
    This file includes functions, classes and defines global variables
*/

//set error_level
error_reporting(E_ALL ^ E_NOTICE);

//starting output buffering to allow http headers
ob_start();

//set configuration
ini_set("magic_quotes_runtime", "0");
ini_set("magic_quotes_sybase", "0");

//setting $level, path to the Ossigeno root directory
if ($level == "") {
    if ($abc) {
        for ($i = 0; $i < substr_count($abc, "/"); $i++) {
            $level .= "../";
        }
    } else {
        $level = "../";
    }
}

//including non-database informations
include("{$level}personal/constants.php");
include("{$level}personal/info.php");
include("{$level}common/info.php");

//global variables
//$language
//$level
//$level_server
$host                   = $_SERVER["HTTP_HOST"];
$server                 = "http://{$_SERVER["HTTP_HOST"]}";
$base                   = "{$server}{$path}/";
$graphic_base           = "";
$super                  = FALSE;
$otk_char               = ":";
$otk_path_cookie        = "/";
$otk_queries_executed   = 0;
$otk_rec                = 20;
$header                 = array();
$header["libs"] = array();
//$user
//$group
//$permissions

//setting $level_server, path to the server root directory
$level_server = $level;
for ($i = 1; $i <= substr_count($path, "/"); $i++) {
    $level_server .= "../";
}
unset($i);

//including libraries
require_once("{$level}otk/lib/dirs.php");
otk_require_dir("otk/lib/");
otk_require_dir("otk/classes/");
otk_require_dir("common/lib/");
otk_require_dir("common/classes/");

//language selection: Get over Cookie over Default
if (isset($_COOKIE["lang"])) {
    $language = $_COOKIE["lang"];
}
if (isset($_GET["lang"])) {
    $language = $_GET["lang"];
}

//including language files
include("{$level}lang/{$language}-common.php");
include("{$level}lang/{$language}-locale.php");
if ($module) {
    include("{$level}lang/{$language}-{$module}.php");
    if ($module2) {
        include("{$level}lang/{$language}-{$module}-{$module2}.php");
    }
}

//connecting to db
$otk_link = otk_sql_connect();
otk_sql_select_db();

//site info
$q = otk_sql_query("SELECT * FROM oss_info");
while ($i = otk_sql_fetch_array($q)) {
    $info[$i["name"]] = $i["value"];
}
if ($info["rec"]) {
    $otk_rec = $info["rec"];
}

if ($info["timezone"]) {
    putenv("TZ={$_info["timezone"]}");
}
$timestamp       = time();
$micro_timestamp = otk_time_getmicro();

//ajax-requested pages
if ($_REQUEST["ajax"]) {
    $header["template"] = "ajax";
}

//skin info
$graphic_base     = "graphic/{$info["graphic"]}/";
$directory_smiles = "{$level}{$graphic_base}smiles/";

//setting path of cookies
if($path_cookie == "") {
    if($path == "") {
        $path_cookie = "/";
    } else {
        $path_cookie = $path;
    }
}

//user
$_COOKIE["oss_session"] = (int) $_COOKIE["oss_session"];
$k = otk_sql_query("SELECT * FROM oss_users WHERE ((nick = '{$_COOKIE["oss_nick"]}') AND (session = '{$_COOKIE["oss_session"]}'))");
if (otk_sql_num_rows($k)) {
    $user = otk_sql_fetch_array($k);
    $user = new OTK_User($user["nick"]);
} else {
    $user = FALSE;
}

//administrator
if ($user->rank == 8) {
    $super = TRUE;
} else {
    $super = FALSE;
}

//user group(s)
if ($user) {
    //primary group
    $group = new OTK_Group($user->id_g);
    $permissions = $user->permissions->content;
    //group gained permissions
    foreach ($user->groups as $id_g) {
        while ($id_g != 0) {
            $g = new OTK_Group($id_g);
            $permissions = array_merge_recursive($permissions, $g->permissions->content);
            $id_g = $g->id_g;
        }
    }
    unset($g, $id_g);
} else {
    $permissions = new OTK_Permissions("", "NULL");
    $permissions = $permissions->content;
}

//control for only users pages
if ($only_users) {
    otk_cookie_set("oss_abc", $abc);
    $url = "community/form_aut.php?abc={$abc}";

    //cookie 'oss_nick'and 'oss_session' must exists
    if (!isset($_COOKIE["oss_nick"]) or !isset($_COOKIE["oss_session"])) {
        otk_error($lang["errors"]["must_aut"], $url);
    }

    //db research for 'nick' and 'session' must find record.
    if (!$user) {
        otk_error($lang["errors"]["cookie_error"], $url);
    }

    //user must be active
    if (!$user->active) {
        $user->Set("session", rand());
        otk_error($lang["errors"]["user_not_active"], $url);
    }

    //if there's no vars posted by a form
    //updating cookie 'oss_session'
    if(!$_POST and defined("OTK_APACHE")) {
        $session = rand();
        otk_sql_query("UPDATE oss_users SET session='{$session}' WHERE (nick = '{$_COOKIE["oss_nick"]}')");
        otk_cookie_set("oss_nick", $_COOKIE["oss_nick"]);
        otk_cookie_set("oss_session", $session);
        unset($session);
    }
}

//users online
if (!strstr($abc, "exit.php")) {
    if ($user) {

        $user->Set("last_action", $timestamp);

        //user returns online or he's already online
        if (!$user->online) {
            otk_sql_query("INSERT INTO oss_users_online (type, name, page, date)
            VALUES ('U', '{$user->nick}', '{$abc}', '{$timestamp}')");
        } else {
            otk_sql_query("UPDATE oss_users_online SET date='{$timestamp}', page='{$abc}'
            WHERE ((name = '{$user->nick}') AND (type = 'U'))");
        }
    } else {

        //code for new visitors or already online
        $u = otk_sql_num_rows(otk_sql_query("SELECT * FROM oss_users_online
        WHERE ((name = '{$_SERVER["REMOTE_ADDR"]}') AND (type = 'V'))"));
        if($u == 0) {
            otk_sql_query("INSERT INTO oss_users_online (type, name, page, date)
            VALUES ('V', '{$_SERVER["REMOTE_ADDR"]}', '$abc', '$timestamp')");
        } else {
            otk_sql_query("UPDATE oss_users_online SET date='$timestamp', page='$abc'
            WHERE ((name = '{$_SERVER["REMOTE_ADDR"]}') AND (type = 'V'))");
        }
    }
}

//online users and visitors deletion after timeout
$limit = $timestamp - OSS_ONLINE_TIME_LIMIT;
otk_sql_query("UPDATE oss_users, oss_users_online SET oss_users.last_visit = oss_users.last_action
    WHERE oss_users.nick = oss_users_online.name
    AND oss_users_online.type = 'U'
    AND oss_users_online.date < {$limit}");
otk_sql_query("DELETE FROM oss_users_online WHERE date < {$limit}");

unset($limit);

//language cookie
if (isset($_GET["lang"])) {
    otk_cookie_set($_GET["lang"]);
}

//include personalization scripts
otk_include_dir("personal/scripts/");

$ossigeno_variables = array();
foreach ($GLOBALS as $ossigeno_variable_name => $ossigeno_variable_value) {
    $ossigeno_variables[] = $ossigeno_variable_name;
}

if ($module) {
    include_once("common.php");
    if ($module2) {
        include_once("../common.php");
        if ($module3) {
            include_once("../../common.php");
        }
    }
}
?>
