--
-- Struttura della tabella `oss`
--

CREATE TABLE `oss` (
  `id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(20) NOT NULL default '',
  `date` int(11) default NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_blocks`
--

CREATE TABLE `oss_blocks` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `type` varchar(255) NOT NULL default '0',
  `skin` varchar(255) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `skin` (`skin`),
  KEY `type` (`type`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_counter`
--

CREATE TABLE `oss_counter` (
  `id` tinyint(4) unsigned NOT NULL auto_increment,
  `count` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_fields`
--

CREATE TABLE `oss_fields` (
  `id` smallint(6) unsigned NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `class` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_fields_values`
--

CREATE TABLE `oss_fields_values` (
  `name` varchar(30) NOT NULL default '',
  `id_f` smallint(6) unsigned NOT NULL default '0',
  `value` varchar(255) NOT NULL default '',
  KEY `nick` (`name`)
) ;

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_forums`
--

CREATE TABLE `oss_forums` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `id_f` smallint(5) unsigned NOT NULL default '0',
  `id_t` tinyint(3) unsigned NOT NULL default '0',
  `name` varchar(30) NOT NULL default '',
  `description` text NOT NULL,
  `type` varchar(30) NOT NULL default '',
  `reserved` tinyint(1) NOT NULL default '0',
  `private` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id_t` (`id_t`),
  KEY `id_f` (`id_f`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_forums_types`
--

CREATE TABLE `oss_forums_types` (
  `id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_groups`
--

CREATE TABLE `oss_groups` (
  `id` smallint(6) unsigned NOT NULL auto_increment,
  `id_g` smallint(6) NOT NULL default '0',
  `name` varchar(30) NOT NULL default '',
  `img` varchar(255) NOT NULL default '',
  `founder` varchar(30) NOT NULL default '',
  `description` text NOT NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_info`
--

CREATE TABLE `oss_info` (
  `name` varchar(40) NOT NULL default '',
  `value` text NOT NULL
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_levels`
--

CREATE TABLE `oss_levels` (
  `id` tinyint(4) unsigned NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `rank` tinyint(3) unsigned NOT NULL default '0',
  `min` mediumint(9) NOT NULL default '-1',
  `max` mediumint(9) NOT NULL default '-1',
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_messages`
--

CREATE TABLE `oss_messages` (
  `id` bigint(20) NOT NULL auto_increment,
  `sender` varchar(30) NOT NULL default '',
  `adressee` varchar(30) NOT NULL default '',
  `date` int(11) default NULL,
  `seen` tinyint(1) NOT NULL default '0',
  `deleted_to` tinyint(1) NOT NULL default '0',
  `deleted_from` tinyint(1) NOT NULL default '0',
  `subject` varchar(255) NOT NULL default '',
  `text` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `sender` (`sender`,`deleted_from`),
  KEY `adressee` (`adressee`,`deleted_to`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_news`
--

CREATE TABLE `oss_news` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `author` varchar(30) NOT NULL default '',
  `title` varchar(40) NOT NULL default '',
  `href` varchar(255) NOT NULL default '',
  `img` varchar(255) NOT NULL default '',
  `text` text NOT NULL,
  `date` int(11) default NULL,
  `cons` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_newsletter`
--

CREATE TABLE `oss_newsletter` (
  `mail` varchar(255) NOT NULL default '',
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`mail`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_numbers`
--

CREATE TABLE `oss_numbers` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `number` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
)  AUTO_INCREMENT=885 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_pages`
--

CREATE TABLE `oss_pages` (
  `name` varchar(30) NOT NULL default '',
  `type` enum('U','G') NOT NULL default 'U',
  `html` text NOT NULL,
  PRIMARY KEY  (`name`,`type`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_partners`
--

CREATE TABLE `oss_partners` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `href` varchar(255) NOT NULL default '',
  `name` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_permissions`
--

CREATE TABLE `oss_permissions` (
  `name` varchar(30) NOT NULL default '',
  `type` enum('U','G') NOT NULL default 'U',
  `module` varchar(30) NOT NULL default '',
  `operation` varchar(30) NOT NULL default '',
  KEY `name` (`name`),
  KEY `module` (`module`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_posts`
--

CREATE TABLE `oss_posts` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `id_t` mediumint(8) unsigned NOT NULL default '0',
  `id_f` smallint(5) unsigned NOT NULL default '0',
  `author` varchar(30) NOT NULL default '',
  `text` mediumtext NOT NULL,
  `date` int(11) default NULL,
  `modified_nick` varchar(30) NOT NULL default '',
  `modified_date` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `id_t` (`id_t`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_surveys`
--

CREATE TABLE `oss_surveys` (
  `id` mediumint(9) unsigned NOT NULL auto_increment,
  `id_t` mediumint(9) unsigned NOT NULL default '0',
  `question` varchar(255) NOT NULL default '',
  `closed` tinyint(1) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_t` (`id_t`)
) ;

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_surveys_options`
--

CREATE TABLE `oss_surveys_options` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `id_s` mediumint(9) NOT NULL default '0',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `id_s` (`id_s`)
) ;

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_surveys_voters`
--

CREATE TABLE `oss_surveys_voters` (
  `id_o` mediumint(9) unsigned NOT NULL default '0',
  `voter` varchar(255) NOT NULL default '',
  KEY `id_o` (`id_o`)
) ;

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_threads`
--

CREATE TABLE `oss_threads` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `id_f` smallint(5) unsigned NOT NULL default '0',
  `img` varchar(255) NOT NULL default '',
  `name` varchar(30) NOT NULL default '',
  `description` varchar(30) NOT NULL default '',
  `cons` smallint(5) unsigned NOT NULL default '0',
  `date` int(11) default NULL,
  `evidence` tinyint(1) NOT NULL default '0',
  `closed` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id_f` (`id_f`)
) ;

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_threads_followers`
--

CREATE TABLE `oss_threads_followers` (
  `id_t` mediumint(8) unsigned NOT NULL default '0',
  `nick` varchar(255) NOT NULL default '',
  KEY `id_t` (`id_t`),
  KEY `nick` (`nick`)
) ;

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_users`
--

CREATE TABLE `oss_users` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `id_g` smallint(6) default '0',
  `name` varchar(30) NOT NULL default '',
  `gender` varchar(20) NOT NULL default '',
  `mail` varchar(30) NOT NULL default '',
  `address` varchar(50) NOT NULL default '',
  `locality` varchar(30) NOT NULL default '',
  `province` varchar(20) NOT NULL default '',
  `country` varchar(20) NOT NULL default '',
  `nick` varchar(30) NOT NULL default '',
  `pwd` varchar(30) NOT NULL default '',
  `date` int(11) default NULL,
  `job` varchar(30) NOT NULL default '',
  `www` varchar(255) NOT NULL default '',
  `avatar` varchar(255) NOT NULL default '',
  `icq` int(11) NOT NULL default 0,
  `msnm` varchar(255) NOT NULL default '',
  `aim` varchar(255) NOT NULL default '',
  `yim` varchar(255) NOT NULL default '',
  `honour` varchar(30) NOT NULL default '',
  `show_mail` tinyint(1) NOT NULL default '0',
  `newsletter` tinyint(1) NOT NULL default '0',
  `warning` tinyint(4) NOT NULL default '0',
  `signature` text NOT NULL default '',
  `extra` text NOT NULL default '',
  `num` int(11) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '0',
  `lost_pwd` int(11) NOT NULL default '0',
  `rank` tinyint(4) NOT NULL default '0',
  `title` varchar(30) NOT NULL default '',
  `session` int(11) NOT NULL default '0',
  `points` mediumint(9) NOT NULL default '0',
  `timezone` varchar(40) default NULL,
  `last_visit` int(11) default NULL,
  `last_action` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `nick` (`nick`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_users_groups`
--

CREATE TABLE `oss_users_groups` (
  `nick` varchar(255) NOT NULL default '',
  `id_g` smallint(6) NOT NULL default '0',
  KEY `nick` (`nick`)
) ;

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_users_online`
--

CREATE TABLE `oss_users_online` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `type` enum('V','U') NOT NULL default 'V',
  `name` varchar(20) NOT NULL default '',
  `page` varchar(255) NOT NULL default '',
  `date` int(11) default NULL,
  UNIQUE KEY `id` (`id`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_users_relatives`
--

CREATE TABLE `oss_users_relatives` (
  `nick` varchar(30) NOT NULL default '',
  `name` varchar(30) NOT NULL default '',
  `type` enum('F','I') NOT NULL default 'F',
  KEY `nick` (`nick`,`type`)
);

-- --------------------------------------------------------

--
-- Struttura della tabella `oss_users_warning_logs`
--

CREATE TABLE `oss_users_warning_logs` (
  `nick` varchar(255) NOT NULL default '',
  `text` mediumtext NOT NULL,
  `date` int(11) default NULL,
  KEY `nick` (`nick`)
);

-- --------------------------------------------------------

