<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Internal: community
    File
    /community/profile.php?name
    This file display the profile of an user
*/

$module = "community";
$only_users = FALSE;
$abc = "community/profile.php?name={$_GET["name"]}";
include("../common/config.php");

$profile = new OTK_User($_GET["name"]);
if ($profile->nick === $NullUser->nick) {
    exit;
}

//header
$header["title"] = "{$lang["titles"]["profile"]} {$profile->nick}";
$header["style"] .= "
td.profile_name
{
    width: 30%;
    text-align: left;
}
td.profile_value
{
    width: 70%;
}
";
require("../common/header.php");
$date =  otk_time_getdate($profile->date);
echo "<div class=\"links\">
<a href=\"messages/form_new_message.php?to={$profile->nick}\">{$lang["profile"]["send_pm"]}</a><br />
<a href=\"community/page.php?name={$profile->nick}\">{$lang["details"]["page"]}</a>
</div>
";
if (!$profile->active) {
    if ($profile->gender == $lang["genders"]["female"]) {
        echo "<div class=\"links\"><span class=\"negative\">{$lang["details"]["disactivated_f"]}</span></div>";
    } elseif($profile->gender == $lang["genders"]["male"]) {
        echo "<div class=\"links\"><span class=\"negative\">{$lang["details"]["disactivated_m"]}</span></div>";
    }
} else {
    if ($profile->honour) {
        $honour = "<br /><strong>{$profile->honour}</strong>";
    }
    echo "
    <table>
    <tr>
    <td class=\"profile_name\">{$lang["details"]["name"]}, {$lang["details"]["gender"]}: </td>
    <td class=\"profile_value\">{$profile->name}, {$profile->gender}</td>
    </tr>
    <tr>
    <td class=\"profile_name\">{$lang["details"]["title"]}, {$lang["details"]["rank"]}: </td>
    <td class=\"profile_value\">";
    for ($j = 1; $j <= $profile->rank; $j++) {
        //rank bar
        echo "<img src=\"{$graphic_base}community/rank.png\" alt=\"+\" />";
    }
    echo "<br />
    {$profile->title} $honour</td>
    </tr>
    ";
    echo "<tr>
    <td class=\"profile_name\">{$lang["details"]["groups"]}:</td>
    <td class=\"profile_value\">";
    foreach ($profile->groups as $id_g) {
        $g = new OTK_Group($id_g);
        if ($g->id == $profile->id_g) {
            echo "<strong>";
        }
        echo $g->name;
        if ($g->id == $profile->id_g) {
            echo "</strong>";
        }
        echo "<br />
        ";
    }
    echo "</td>
    </tr>
    ";

    $last_visit  = otk_time_getdate($profile->last_visit);
    $last_action = otk_time_getdate($profile->last_action);
    echo "
    <tr>
    <td class=\"profile_name\">{$lang["details"]["last_visit"]}:</td>
    <td class=\"profile_value\">{$last_visit}</td>
    </tr>
    <tr>
    <td class=\"profile_name\">{$lang["details"]["last_action"]}:</td>
    <td class=\"profile_value\">{$last_action}</td>
    </tr>
    <tr>
    <td class=\"profile_name\">$info[points_name]:</td>
    <td class=\"profile_value\">{$profile->points}</td>
    </tr>
    ";
    if ($profile->gender == $lang["genders"]["female"]) {
        $active = "<span class=\"positive\">{$lang["details"]["active_f"]}</span>";
    } else /* if($profile->gender == $lang["genders"]["male"]) */ {
        $active = "<span class=\"positive\">{$lang["details"]["active_m"]}</span>";
    }
    if ($profile->online) {
        $online="<span class=\"positive\">Online</span>";
    } else {
        $online="<span class=\"negative\">Offline</span>";
    }
    echo "<tr>
    <td class=\"profile_name\">Status:</td>
    <td class=\"profile_value\">$active, $online</td>
    </tr>
    ";
    if ($profile->show_mail) {
        echo "<tr>
        <td class=\"profile_name\">E-Mail:</td>
        <td class=\"profile_value\">{$profile->mail}</td>
        </tr>
        ";
    }
    $q = otk_sql_query("SELECT * FROM oss_fields WHERE (class = 'U')");
    while ($field = otk_sql_fetch_array($q)) {
        echo "<tr>
        <td class=\"profile_name\">{$field["name"]}:</td>
        <td class=\"profile_value\">{$profile->fields->content[$field["id"]]}</td>
        </tr>
        ";
    }
    echo "<tr>
    <td class=\"profile_name\">{$lang["details"]["local_time"]}:</td>
    <td class=\"profile_value\">";
    $time = $timestamp;
    $settings = getdate(0);
    if ($settings["hours"] > 12) {
        $settings["hours"] -= 24;
    }
    $hours = $settings["hours"];
    $settings = localtime($timestamp, TRUE);
    $dst = $settings["tm_isdst"];
    $time -= (3600 * ($hours + $dst)); //time on clocks at Greenwich
    if ($profile and ($profile->timezone !== NULL)) {
        $time += (3600 * ($profile->timezone + $profile->dst));
    } else {
        $time += (3600 * ($info["timezone"] + $info["dst"]));
    }
    echo date("G:i", $time);
    $date =  otk_time_getdate($profile->date);
    echo "</td>
    </tr>
    <tr>
    <td class=\"profile_name\">{$lang["details"]["date"]}: </td>
    <td class=\"profile_value\">$date</td>
    </tr>
    <tr>
    <td class=\"profile_name\">{$lang["details"]["job"]}:</td>
    <td class=\"profile_value\">{$profile->job}</td>
    </tr>
    ";
    if ($profile->www) {
        echo "<tr>
        <td class=\"profile_name\">WWW:</td>
        <td class=\"profile_value\">{$profile->www}</td>
        </tr>
        ";
    }
    if ($profile->page) {
        echo "<tr>
        <td class=\"profile_name\">{$lang["details"]["page"]}:</td>
        <td class=\"profile_value\"><a href=\"community/page.php?name={$profile->nick}\">Link</a></td>
        </tr>
        ";
    }
    if ($profile->icq) {
        echo "<tr>
        <td class=\"profile_name\">ICQ#:</td>
        <td class=\"profile_value\">{$profile->icq}</td>
        </tr>
        ";
    }
    if ($profile->msnm) {
        echo "<tr>
        <td class=\"profile_name\">MSNM#:</td>
        <td class=\"profile_value\">{$profile->msnm}</td>
        </tr>
        ";
    }
    if ($profile->aim) {
        echo "<tr>
        <td class=\"profile_name\">AIM#:</td>
        <td class=\"profile_value\">{$profile->aim}</td>
        </tr>
        ";
    }
    if ($profile->yim) {
        echo "<tr>
        <td class=\"profile_name\">YIM#:</td>
        <td class=\"profile_value\">{$profile->yim}</td>
        </tr>
        ";
    }
    echo "
    <tr>
    <td class=\"profile_name\">Avatar:</td>
    <td class=\"profile_value\">";
    if ($profile->avatar) {
        echo $profile->avatar;
    }
    echo "</td>
    </tr>
    <tr>
    <td class=\"profile_name\">{$lang["details"]["signature"]}:</td>
    <td class=\"profile_value\">{$profile->signature}</td>
    </tr>
    <tr>
    <td class=\"profile_name\">{$lang["details"]["extra"]}:</td>
    <td class=\"profile_value\">{$profile->extra}</td>
    </tr>
    ";
    if ($profile->rank < 7) {
        echo "<tr>
        <td class=\"profile_name\">{$lang["details"]["warning"]}:</td>
        <td class=\"profile_value\">";
        if ($user->rank >= 7) {
            echo "<a href=\"community/warning.php?name={$profile->nick}\">";
        }
        for ($j = 1; $j <= $profile->warning; $j++) {
            echo "<img class=\"null\" src=\"{$graphic_base}community/warning1.png\" alt=\"|\" />";
        }
        $avv_no = 100 - $profile->warning;
        for ($j = 1; $j <= $avv_no; $j++) {
            echo "<img class=\"null\" src=\"{$graphic_base}community/warning0.png\" alt=\"|\" />";
        }
        echo "&nbsp;{$profile->warning}%";
        if ($user->rank >= 7) {
            echo "</a>";
        }
        echo "</td>
        </tr>
        ";
    }
    echo "</table>";
}
require("../common/footer.php");
?>
