<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Internal: community
    File
    /community/your_account.php{POST}
    This file displays options of account management
    with POST does update of user details
*/

$module = "community";
$only_users = TRUE;
$abc = "community/your_account.php";
include("../common/config.php");

$_POST["action"] = (string) $_POST["action"];
switch ($_POST["mode"]) {
    case "set_details":
        //updating data
        //controls on POST variables
        $_POST["name"]      = otk_html_normalize($_POST["name"]);
        $_POST["mail"]      = otk_html_normalize($_POST["mail"]);
        $_POST["address"]   = otk_html_normalize($_POST["address"]);
        $_POST["locality"]  = otk_html_normalize($_POST["locality"]);
        $_POST["province"]  = otk_html_normalize($_POST["province"]);
        $_POST["country"]   = otk_html_normalize($_POST["country"]);
        $_POST["job"]       = otk_html_normalize($_POST["job"]);
        $_POST["www"]       = otk_html_normalize($_POST["www"]);
        $_POST["id_g"]      = (int) $_POST["id_g"];
        $_POST["icq"]       = (int) $_POST["icq"];
        $_POST["msnm"]      = (string) $_POST["msnm"];
        $_POST["aim"]       = (string) $_POST["aim"];
        $_POST["yim"]       = (string) $_POST["yim"];
        $_POST["honour"]    = otk_html_normalize($_POST["honour"]);
        $_POST["show_mail"] = (int) (bool) $_POST["show_mail"];
        $_POST["newsletter"] = (int) (bool) $_POST["newsletter"];
        $_POST["signature"] = otk_html_format($_POST["signature"]);
        $_POST["extra"]     = otk_html_normalize($_POST["extra"]);
        $_POST["pwd1"]      = (string) $_POST["pwd1"];
        $_POST["pwd2"]      = (string) $_POST["pwd2"];

        //control: for an honour the points must be > 100
        if ($user->points < 100) {
            $_POST["honour"] = "";
        }

        $url = "community/details.php?";

        //control: the new password must come from to equal fields
        if ($_POST["pwd2"] != $_POST["pwd1"]) {
            otk_error($lang["errors"]["passwords_not_match"], $url);
        }

        //control: the new password must exists
        if (!$_POST["pwd1"]) {
            otk_error($lang["errors"]["passwords_not_exist"], $url);
        }

        //control: the mail must exists
        if (!$_POST["mail"]) {
            otk_error($lang["errors"]["mail_not_exist"], $url);
        }

        //control and setting the avatar
        if(
            (substr($_POST["avatar"], "-4") == ".gif") or
            (substr($_POST["avatar"], "-4") == ".png") or
            (substr($_POST["avatar"], "-4") == ".jpg") or
            (substr($_POST["avatar"], "-4") == ".jpe") or
            (substr($_POST["avatar"], "-5") == ".jpeg") or
            (substr($_POST["avatar"], "-6") == ".pjpeg")) {
            list($width, $height, ,$attributes) = getimagesize($_POST["avatar"]);
            if ($width > 100) {
                $proportions = $height / $width;
                $width = 100;
                $height = $proportions * $width;
                $attributes = "width=\"{$width}\" height=\"{$height}\"";
            }
            $avatar = "<img src=\"{$_POST[avatar]}\" alt=\"{$user->nick}\" {$attributes} />";
        } else {
            $avatar = $user->avatar;
        }

        //timezone to NULL (use website's one)
        if ($_POST["timezone"] != "NOT_SET") {
            $user->Set("timezone", $_POST["timezone"]);
        } else {
            $user->Reset("timezone");
        }
        $user->Set("name", $_POST["name"]);
        $user->Set("gender", $lang["genders"][$_POST["gender"]]);
        $user->Set("mail", $_POST["mail"]);
        $user->Set("address", $_POST["address"]);
        $user->Set("locality", $_POST["locality"]);
        $user->Set("province", $_POST["province"]);
        $user->Set("country", $_POST["country"]);
        $user->Set("job", $_POST["job"]);
        $user->Set("www", $_POST["www"]);
        $user->Set("avatar", $avatar);

        //primary group
        if ($_POST["id_g"] == "") {
            $user->Reset("id_g");
        } else {
            $user->Set("id_g", $_POST["id_g"]);
        }
        $user->Set("icq", $_POST["icq"]);
        $user->Set("msnm", $_POST["msnm"]);
        $user->Set("aim", $_POST["aim"]);
        $user->Set("yim", $_POST["yim"]);
        $user->Set("honour", $_POST["honour"]);
        $user->Set("show_mail", $_POST["show_mail"]);
        $user->Set("newsletter", $_POST["newsletter"]);
        $user->Set("signature", $_POST["signature"]);
        $user->Set("extra", $_POST["extra"]);
        $user->Set("pwd", $_POST["pwd1"]);
        foreach ($_POST as $name => $value) {
            if ($name{0} != "_") {
                continue;
            }
            $id = (int) substr($name, 1, strlen($name) - 1);
            $user->fields->Set($id, $value);
        }
        $message = $lang["your_account"]["ok"]["details"];
        break;

    case "set_home":
        if ($user->page === NULL) {
            otk_sql_query("INSERT INTO oss_pages
            (name, type, html) VALUES (
            '{$user->nick}',
            'U',
            ''
            )");
        }
        $user = new OTK_User($user->nick);
        $user->page->Set("html", $_POST["html"]);
        $message = $lang["your_account"]["ok"]["home"];
        break;

    case "add_friend":
        //control: the friend must not already exist in list of friends and must exist in users list
        $result = $user->AddFriend($_REQUEST["name"]);
        if ($result) {
            $message = $lang["your_account"]["ok"]["friend_added"];
        } else {
            $message = $lang["your_account"]["problem"]["friend_not_existent"];
        }
        break;

    case "delete_friend":
        //control: the ignored user must not already exist in list of friends and must exist in users list
        $result = $user->DeleteFriend($_REQUEST["name"]);
        if ($result) {
            $message = $lang["your_account"]["ok"]["friend_deleted"];
        } else {
            $message = $lang["your_account"]["problem"]["friend_not_existent"];
        }
        break;
}

//header
$header["title"] = $lang["titles"]["your_account"];
require("../common/header.php");
if ($message) {
    echo "<p><strong>$message</strong></p>";
}
?>
<p><? echo $lang["your_account"]["title"]; ?></p>
<table>
<tr>
<td>
    <a href="messages/index.php">
    <img src="<? echo $graphic_base; ?>community/account/messages.png" alt="" /><br />
    MP <?
    $new_messages = $user->GetNewMessages();
    if ($new_messages) {
        echo "({$lang["your_account"]["buttons"]["have"]} $new_messages {$lang["your_account"]["buttons"]["messages"]})";
    } else {
        echo "({$lang["your_account"]["buttons"]["not_new_messages"]})";
    }
    ?>
    </a>
</td>
<td>
    <a href="community/details.php">
    <img src="<? echo $graphic_base; ?>community/account/details.png" alt="" /><br />
    <? echo $lang["your_account"]["buttons"]["details"]; ?>
    </a>
</td>
<td>
    <a href="community/friends.php">
    <img src="<? echo $graphic_base; ?>community/account/friends.png" alt="" /><br />
    <? echo $lang["your_account"]["buttons"]["friends"]; ?>
    </a>
</td>
<td>
    <a href="community/warning.php?name=<? echo $user->nick; ?>">
    <img src="<? echo $graphic_base; ?>community/account/warning.png" alt="" /><br />
    <? echo $lang["your_account"]["buttons"]["warning"]; ?>
    </a>
</td>
</tr>
<tr>
<td>
    <a href="community/home.php">
    <img src="<? echo $graphic_base; ?>community/account/page.png" alt="" /><br />
    <? echo $lang["your_account"]["buttons"]["page"]; ?></a>
</td>
<td>
    <a href="community/exit.php">
    <img src="<? echo $graphic_base; ?>community/account/exit.png" alt="" /><br />
    <? echo $lang["your_account"]["buttons"]["exit"]; ?></a>
</td>
<td>
    <a href="community/delete_cookies.php">
    <img src="<? echo $graphic_base; ?>community/account/delete_cookies.png" alt="" /><br />
    <? echo $lang["your_account"]["buttons"]["delete_cookies"]; ?></a>
</td>
</tr>
</table>
<?
require("../common/footer.php");
?>
