<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: forum
    File
    /forum/form_new_post.php?id_t
    This file prints the form to create a new post
*/

$module = "forum";
$only_users = TRUE;
$abc = "forum/form_new_post.php?id_t=$_GET[id_t]";
include("../common/config.php");

$thread = new OTK_Thread($_GET["id_t"]);
$forum  = new OTK_Forum($thread->id_f);
//control: if forum is private user needs permissions
if ($forum->private and !in_array("private", $permissions) and !in_array("private_{$forum->id}", $permissions)) {
    otk_error($lang["errors"]["permissions"], "forum/index.php?");
}
//control: if thread is closed users can't insert new posts
if ($thread->closed) {
    exit;
}
$header["title"] = $forum->Title();
$header["title"] .= " - {$thread->name} - {$lang["titles"]["form_new_post"]}";
$bar = $forum->Bar();
$header["common_text"] = "<div class=\"forum_navigation\">
<a href=\"forum/index.php\">{$lang["common_text"]["index"]}</a><br />
{$lang["common_text"]["forum"]}: $bar</a><br />
{$lang["common_text"]["thread"]}: <a href=\"forum/thread.php?id_t={$thread->id}\">{$thread->name}<br />
{$lang["common_text"]["new_post"]}
</div>
";
$header["style"] .= "
td.author
{
    vertical-align: top;
    width: 168px;
    text-align: left;
}
td.post
{
    vertical-align: top;
    width: 519px;
    text-align: left;
}
td.survey_box
{
    width: 10%;
}
td.survey_option
{
    width: 90%;
}
";
require("../common/header.php");
$security = security_numbers_generate();
?>
<form action="forum/new_post.php" method="post">
<fieldset>
    <div>
        <label for="text"><? echo $lang["form_new_post"]["labels"]["text"]; ?>:<br />
            <? otk_html_smiles(); ?></label>
        <textarea class="required" id="text" name="text"><?
        if ($_GET["quote"]) {
                $post = new OTK_Post($_GET["quote"]);
                echo "<strong>" . otk_html_unnormalize($post->author). " {$lang["form_new_post"]["quoting"]} (" .  otk_time_getdate($post->date, TRUE) . "): </strong><div class=\"quote\">".otk_html_unformat($post->text)."</div>\n";
        }
        ?></textarea><br />
            <? otk_html_bar(); ?>
    </div>
</fieldset>
<?
$q = otk_sql_query("SELECT * FROM oss_surveys WHERE id_t = '{$thread->id}'");
if (otk_sql_num_rows($q)) {
    $survey = otk_sql_fetch_array($q);
    $survey = new OTK_Survey($survey["id"]);
    if (!in_array($user->nick, $survey->voters)) {
        echo "<p>{$lang["forum"]["survey"]}: {$survey->question}</p>
        <fieldset>";
        foreach ($survey->options as $i => $option) {
            echo "<div>
            <td class=\"survey_box\"><input type=\"radio\" id=\"option\" name=\"option\" value=\"{$option->id}\" /></label>
            <td class=\"survey_option\">{$option->value}</label>
            </div>
            ";
        }
        echo "</fieldset>
        ";
    }
}
?>
<div><button type="submit"><? echo $lang["submit"]; ?></button></div>
<div class="hidden">
    <input type="hidden" id="id_t" name="id_t" value="<? echo $thread->id; ?>" />
    <input type="hidden" id="id" name="id" value="<? echo $security["id"]; ?>" />
    <input type="hidden" id="number" name="number" value="<? echo $security["number"]; ?>" />
</div>
</form>
<p><? echo $lang["form_new_post"]["previous_posts"]; ?>:</p>
<table>
<?
$q = otk_sql_query("SELECT * FROM oss_posts WHERE id_t = '{$thread->id}' ORDER BY id DESC LIMIT 0, 6");
while ($post = otk_sql_fetch_array($q)) {
    $post = new OTK_Post($post["id"]);
    $author = new OTK_User($post->author);
    echo "
    <tr>
    <td class=\"author\">
    <a href=\"community/profile.php?name={$author->nick}\">{$author->nick}</a><br /><br />";
    if($author->active)
    {
        for($j = 1; $j <= $author->rank; $j++)
        {
            //rank bar
            echo "<img src=\"{$graphic_base}community/rank.png\" alt=\"+\" />";
        }
        echo "<br/>
        {$author->title}<br />\n";
        if($author->honour)
        {
            //if there is an honour, print it
            echo "<strong>{$author->honour}</strong><br />\n";
        }
        if ($author->id_g) {
            $primary_group = new OTK_Group($author->id_g);
            echo "{$lang["details"]["primary_group"]}: {$primary_group->name}<br />";
        }
        if ($author->gender == $lang["genders"]["female"]) {
            echo $lang["details"]["registered_f"];
        } else /* if($author->gender == $lang["genders"]["male"]) */ {
            echo $lang["details"]["registered_m"];
        }
        echo ": $date_reg<br />
        $info[points_name]: {$author->points}<br />";    //points

        if ($author->fields->content) {
            foreach ($author->fields->names as $id => $name) {
                echo "{$name}: {$author->fields->content[$id]}<br />
                ";
            }
        }

        //control: online/offline
        if ($author->online) {
            echo "<div class=\"positive\"><strong>{$lang["details"]["online"]}</strong></div>
            ";
        } else {
            echo "<div class=\"negative\"><strong>{$lang["details"]["offline"]}</strong></div>
            ";
        }
        if ($author->rank < 7) {
            //printing bar of warning
            if (($user->rank >= 7) or ($user->nick == $author->nick)) {
                echo "<a href=\"community/warning.php?name={$author->nick}\">";
            }
            echo "{$lang["details"]["warning_short"]} : ";
            for ($i = 1; $i <= $author->warning; $i++) {
                echo "<img class=\"null\" src=\"{$graphic_base}community/warning1.png\" alt=\"-\" />";
            }
            $warning_no = 100 - $author->warning;
            for ($i = 1; $i <= $warning_no; $i++) {
                echo "<img class=\"null\" src=\"{$graphic_base}community/warning0.png\" alt=\"|\" />";
            }
            echo "&nbsp;$author->warning%";
            if (($user->rank >= 7) or ($user->nick == $author->nick)) {
                echo "</a>";
            }
        }
    } else {
        if ($author->gender == $lang["genders"]["female"]) {
            echo "<div class=\"negative\"><strong>{$lang["details"]["disactivated_f"]}</strong></div>";
        } else /* if($author->gender == $lang["genders"]["male"]) */ {
            echo "<div class=\"negative\"><strong>{$lang["details"]["disactivated_m"]}</strong></div>";
        }
    }
    echo "</td>
    <td class=\"post\">";
    //text
    echo "{$post->text}<br /><br />";
    if ($post->modified_nick) {
        echo "<em>{$lang["thread"]["edited_by"]} <strong>{$post->modified_nick}</strong>, " .  otk_time_getdate($post->modified_date) . "</em>";
    }
    echo "</td>
    </tr>
    ";
}
?>
</table>
<hr />
<?
require("../common/footer.php");
?>
