<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: forum
    File
    /forum/form_new_thread.php?id_f
    This file prints the form to create a new thread
*/

$module = "forum";
$only_users = TRUE;
$abc = "forum/form_new_thread.php?id_f=$_GET[id_f]";
include("../common/config.php");

$forum = new OTK_Forum($_GET["id_f"]);
//control: if forum is private user needs permissions
if ($forum->private and !in_array("private", $permissions["forum"]) and !in_array("private_{$forum->id}", $permissions["forum"])) {
    otk_error($lang["errors"]["permissions"], "forum/index.php?");
}
//control: if forum is reserved normal user cant open threads
if ($forum->reserved and !in_array("reserved", $permissions["forum"]) and !in_array("reserved_{$forum->id}", $permissions["forum"])) {
    exit;
}
$bar = $forum->Bar();
$header["title"] = $forum->Title(). " - {$lang["titles"]["form_new_thread"]}";
$header["common_text"] = "<div class=\"forum_navigation\">
<a href=\"forum/index.php\">{$lang["common_text"]["index"]}</a><br />
{$lang["common_text"]["forum"]}: $bar</a><br />
{$lang["common_text"]["new_thread"]}
</div>
";
require("../common/header.php");
$security = security_numbers_generate();
//control: if forum is reserved normal user can't open new threads
if ($forum->reserved and ($user->rank < 7)) {
    exit;
}
?>
<form action="forum/new_thread.php" method="post">
<fieldset>
    <div>
        <label for="img"><? echo $lang["form_new_thread"]["labels"]["img"]; ?>:</label>
        <select onchange="otk_update('preview', this)" id="img" name="img">
            <option value="">--------</option>
            <?
            $directory = opendir("../{$graphic_base}forum/img");
            while(!(($img = readdir($directory))===FALSE))
            {
                if ($img === ".") {
                    continue;
                }
                if ($img === "..") {
                    continue;
                }
                echo "<option value=\"{$graphic_base}forum/img/{$img}\">$img</option>
                ";
            }
            closedir($directory);
            ?>
        </select><img id="preview" name="preview" src="" alt="" /></label>
    </div>
    <div>
        <label for="name"><? echo $lang["form_new_thread"]["labels"]["name"]; ?>:</label>
        <input class="required" type="text" id="name" name="name" /></label>
    </div>
    <div>
        <label for="description"><? echo $lang["form_new_thread"]["labels"]["description"]; ?>:</label>
        <input type="text" id="description" name="description" /></label>
    </div>
    <div>
        <label for=""><? echo $lang["form_new_thread"]["labels"]["text"]; ?>:</label>
        <textarea class="required" id="text" name="text"></textarea><br />
            <? otk_html_bar(); ?>
            <? otk_html_smiles(); ?>
    </div>
    <div>
        <label for="follow"><? echo $lang["form_new_thread"]["labels"]["follow"]; ?>:</label>
        <input type="checkbox" id="follow" name="follow" /></label>
    </div>
</fieldset>
<p><a href="#" onclick="return otk_show_hide('new_survey');"><? echo $lang["form_new_thread"]["labels"]["new_survey"]; ?></a></p>
<fieldset id="new_survey" class="hidden">
    <div>
        <label for="question"><? echo $lang["form_new_thread"]["labels"]["question"]; ?>:</label>
        <input type="text" id="question" name="question" /></label>
    </div>
    <div>
        <label><? echo $lang["form_new_thread"]["labels"]["options"]; ?>:</label>
        <?
        for ($i = 1; $i <= OSS_SURVEYS_MAX_OPTIONS; $i++) {
            echo "<input type=\"text\" id=\"_{$i}\" name=\"_{$i}\" /><br />
            ";
        }
        ?></label>
    </div>
</fieldset>
<div><button type="submit"><? echo $lang["submit"]; ?></button></div>
<div class="hidden">
    <input type="hidden" id="id" name="id" value="<? echo $security["id"]; ?>" />
    <input type="hidden" id="number" name="number" value="<? echo $security["number"]; ?>" />
    <input type="hidden" id="id_f" name="id_f" value="<? echo $forum->id; ?>" />
</div>
</form>
<?
require("../common/footer.php");
?>
