<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: forum
    File
    /forum/form_search.php
    This file prints the form to search posts
*/

$module = "forum";
$only_users = FALSE;
$abc = "forum/form_search.php";
include("../common/config.php");

if ($_GET["id_f"]) {
    $forum = new OTK_Forum($_GET["id_f"]);
}
$header["title"] = $lang["titles"]["form_search"];
if ($forum) {
    $header["title"] .= ": {$forum->name}";
}
$header["common_text"] = "<div class=\"forum_navigation\">
<a href=\"forum/index.php\">{$lang["common_text"]["index"]}</a><br />
{$lang["common_text"]["search"]}
</div>
";
$header["head"] .= "
<script type=\"text/javascript\">
function verify_checkboxes()
{
    if (document.getElementById('id_f').selectedIndex != 0) {
        document.getElementById('c_id_f').checked = 'checked';
    }
    if (document.getElementById('author').value != '') {
        document.getElementById('c_author').checked = 'checked';
    }
}
</script>
";
require("../common/header.php");
$security = security_numbers_generate();
?>
<form action="forum/search.php" method="post">
<fieldset>
    <div>
        <label for="keys"><? echo $lang["form_search"]["labels"]["keys"]; ?>:</label>
        <input class="required" type="text" id="keys" name="keys" />
    </div>
    <div>
        <label for="type"><? echo $lang["form_search"]["labels"]["type"]; ?>:</label>
        <input type="radio" name="type" value="or" /> <? echo $lang["form_search"]["types"]["or"]; ?><br />
        <input type="radio" id="type" name="type" value="and" checked="checked" /> <? echo $lang["form_search"]["types"]["and"]; ?>
    </div>
    <div>
        <label for="id_f"><input type="checkbox" id="c_id_f" name="c_id_f" <?
        if ($forum) {
            echo "checked=\"checked\" ";
        }
        ?>/><? echo $lang["form_search"]["labels"]["id_f"]; ?>:</label>
        <select id="id_f" name="id_f" onchange="verify_checkboxes()">
        <option value=""></option>
        <?
        $q = otk_sql_query("SELECT * FROM oss_forums_types ORDER BY id");
        while ($type = otk_sql_fetch_array($q)) {
            $forums = otk_sql_query("SELECT * FROM oss_forums WHERE (id_t = '{$type["id"]}') ORDER BY name");
            echo "<optgroup label=\"{$type["name"]}\">
            ";
            while ($f = otk_sql_fetch_array($forums)) {
                $f = new OTK_Forum($f["id"]);
                //control: if forum is private user needs permissions
                if ($f->private and !in_array("private", $permissions["forum"]) and !in_array("private_{$f->id}", $permissions["forum"])) {
                    continue;
                }
                echo "<option";
                if ($f->id == $forum->id) {
                    echo " selected=\"selected\" ";
                }
                echo " value=\"{$f->id}\">{$f->name}</option>
                ";
            }
            echo "</optgroup>
            ";
        }
        ?></select>
    </div>
    <div>
        <input type="checkbox" id="c_author" name="c_author" /><label for="author"><? echo $lang["form_search"]["labels"]["author"]; ?>:</label>
        <input type="text" id="author" name="author" onchange="verify_checkboxes()" />
    </div>
    </fieldset>
<div><button type="submit"><? echo $lang["submit"]; ?></button></div>
<div class="hidden">
    <input type="hidden" id="number" name="number" value="<? echo $security["number"]; ?>" />
    <input type="hidden" id="id" name="id" value="<? echo $security["id"]; ?>" />
</div>
</form>
<?
require("../common/footer.php");
?>
