<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: forum
    File
    /forum/forum.php?id_f
    This file lists the threads in a forum
*/

$module = "forum";
$only_users = FALSE;
$abc = "forum/forum.php?id_f={$_GET["id_f"]}";
include("../common/config.php");
$link=otk_sql_connect();
$forum = new OTK_Forum($_GET["id_f"]);
//control: if forum is private user needs permissions
if ($forum->private and !in_array("private", $permissions["forum"]) and !in_array("private_{$forum->id}", $permissions["forum"])) {
    otk_error($lang["errors"]["permissions"], "forum/index.php?");
}
$header["title"] = $forum->Title();
$bar = $forum->Bar();
//header
$header["common_text"] = "<div class=\"forum_navigation\">
    <a href=\"forum/index.php\">{$lang["common_text"]["index"]}</a><br />
    {$lang["common_text"]["forum"]}: $bar
</div>
";
require("../common/header.php");
//eventual forums IN this forum
$q = otk_sql_query("SELECT * FROM oss_forums WHERE (id_f = '{$forum->id}') ORDER BY name");
if (otk_sql_num_rows($q)) {
    ?>
    <div class="index">
    <table class="forum_index">
    <thead>
        <tr>
        <th class="forum_index_x"><? echo $lang["index"]["th"]["x"]; ?></th>
        <th class="forum_index_name"><? echo $lang["index"]["th"]["name"]; ?></th>
        <th class="forum_index_n_t"><? echo $lang["index"]["th"]["n_t"]; ?></th>
        <th class="forum_index_n_p"><? echo $lang["index"]["th"]["n_p"]; ?></th>
        <th class="forum_index_last_post"><? echo $lang["index"]["th"]["last_post"]; ?></th>
        </tr>
    </thead>
    <tbody>
    <?
    while ($f = otk_sql_fetch_array($q)) {
        $f = new OTK_Forum($f["id"]);
        if ($f->private and !in_array("private", $permissions["forum"]) and !in_array("private_{$f->id}", $permissions["forum"])) {
            echo "
            <tr>
                <td class=\"forum_index_x\"></td>
                <td class=\"forum_index_name\">
                {$f->name}</p>
            <div class=\"forum_description\">{$f->description}</div>";
            if ($mods = $f->GetModerators()) {
                echo "<div class=\"forum_moderators\">$mods</div>";
            }
            if ($groups = $f->GetGroups()) {
                echo "<div class=\"forum_groups\">$groups</div>";
            }
            echo "</td>
                <td class=\"forum_index_n_t\">&nbsp;</td>
                <td class=\"forum_index_n_p\">&nbsp;</td>
                <td class=\"forum_index_last_post\">&nbsp;</td>
            </tr>
            ";
            continue;
        }
        $last_thread = $f->GetLastThread();
        $last_post   = $f->GetLastPost();
        //row
        echo "
        <tr>
           <td class=\"forum_index_x\">";
        //control of new posts
        if ($last_post->date > $user->last_visit) {
            echo "<img src=\"{$graphic_base}forum/icons/1.png\" alt=\"O\" />
            ";
        } else {
            echo "<img src=\"{$graphic_base}forum/icons/0.png\" alt=\"X\" />
            ";
        }
        echo "</td>
            <td class=\"forum_index_name\">
            <a href=\"forum/forum.php?id_f={$f->id}\">{$f->name}</a>
            <div class=\"forum_description\">{$f->description}</div>";
            if ($mods = $f->GetModerators()) {
                echo "<div class=\"forum_moderators\">$mods</div>";
            }
            if ($groups = $f->GetGroups()) {
                echo "<div class=\"forum_groups\">$groups</div>";
            }
        echo "</td>
            <td class=\"forum_index_n_t\">" . $f->NumberThreads() . "</td>
            <td class=\"forum_index_n_p\">" . $f->NumberPosts() . "</td>
            <td class=\"forum_index_last_post\">";
            if ($last_post) {
                echo $last_post->Presentation();
            }
            echo "</td>
        </tr>
        ";
    }
    ?></tbody>
    </table>
    </div>
    <br />
    <?
}
$q = otk_sql_query("SELECT * FROM oss_threads WHERE id_f = {$forum->id} AND evidence = 0");
$n = otk_sql_num_rows($q);
//selection of records and calculus of pages
list($pages, $inf, $rec) = otk_pages($n, $_GET["page"]);
$m = otk_sql_query("SELECT * FROM oss_threads WHERE ((id_f = '{$forum->id}') AND (evidence = '0')) ORDER BY date DESC LIMIT $inf, $rec");
//selection of threads 'in evidence'
$e = otk_sql_query("SELECT * FROM oss_threads WHERE ((id_f = '{$forum->id}') AND (evidence = '1')) ORDER BY id DESC");
otk_pages_list($pages, $_GET["page"], "forum/forum.php?id_f={$forum->id}");
//control: if forum is reserved normal user can't open new threads
if (!$forum->reserved or ($forum->reserved and $user and (in_array("reserved", $permissions["forum"]) or in_array("reserved_{$forum->id}", $permissions["forum"])))) {
    ?>
    <div class="forum_buttons_new_thread">
    <a href="forum/form_new_thread.php?id_f=<? echo $forum->id; ?>" class="button"><?
    echo $lang["buttons"]["new_thread"];
    ?></a>
    </div>
    <?
} else {
    ?>
    <div class="forum_buttons_reserved"><?
    echo $lang["buttons"]["reserved"];
    ?></div>
    <?
}
?>
<br class="clear" />
<table class="forum">
    <thead>
        <tr>
        <th class="forum_x"><? echo $lang["forum"]["th"]["x"]; ?></th>
        <th class="forum_name"><? echo $lang["forum"]["th"]["name"]; ?></th>
        <th class="forum_replies"><? echo $lang["forum"]["th"]["replies"]; ?></th>
        <th class="forum_author"><? echo $lang["forum"]["th"]["author"]; ?></th>
        <th class="forum_cons"><? echo $lang["forum"]["th"]["cons"]; ?></th>
        <th class="forum_last_post"><? echo $lang["forum"]["th"]["last_post"]; ?></th>
        </tr>
    </thead>
    <tbody>
<?
//thread in evidence
if (otk_sql_num_rows($e)) {
    echo "<td class=\"evidence\" colspan=\"6\">{$lang["forum"]["captions"]["evidence"]}</td>
    ";
    while ($thread = otk_sql_fetch_array($e)) {
        $thread = new OTK_Thread($thread["id"]);
        $q = otk_sql_query("SELECT * FROM oss_surveys WHERE id_t = {$thread->id}");
        $s = otk_sql_num_rows($q);
        //control: if thread have a survey show a string before thread name
        if ($s) {
            $survey = "{$lang["forum"]["survey"]}: ";
        } else {
            $survey = "";
        }
        if ($thread->img) {
            $img = "<img src=\"{$thread->img}\" alt=\"{$thread->img}\" />";
        } else {
            $img = "";
        }
        if ($thread->description) {
            $description = "<div class=\"forum_description\">{$thread->description}</div>";
        } else {
            $description = "";
        }
        $posts = $thread->NumberPosts();
        $p = ceil($posts / $rec);
        if ($p == 1) {
            $thread_pages = "";
        } elseif ($p == 2) {
            $thread_pages = "<br /><em>P:&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=2\">2</a></em>";
        } elseif ($p == 3) {
            $thread_pages = "<br /><em>P:&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=2\">2</a>,&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=3\">3</a></em>";
        } else {
            $thread_pages = "<br /><em>P:&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=2\">2</a>&nbsp;..&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=$p\">$p</a></em>";
        }
        $replies = $posts - 1;
        $first_post = $thread->GetFirstPost();
        $last_post  = $thread->GetLastPost();
        $date1 =  otk_time_getdate($first_post->date);
        $date2 =  otk_time_getdate($last_post->date);
        echo "
          <tr>
           <td class=\"forum_x\">";
        if ($thread->closed) {
            //if thread is closed print a padlock
            echo "<img src=\"{$graphic_base}forum/icons/-1.png\" alt=\"#\" />";
        } else {
            //thread updates and old threads
            if ($last_post->date > $user->last_visit) {
                echo "<img src=\"{$graphic_base}forum/icons/1.png\" alt=\"O\" />
                ";
            } else {
                echo "<img src=\"{$graphic_base}forum/icons/0.png\" alt=\"X\" />
                ";
            }
        }
        echo "</td>
           <td class=\"forum_name\"><a href=\"forum/thread.php?id_t={$thread->id}\"><strong>{$img}{$survey}{$thread->name}{$description}{$thread_pages}</strong></a></td>
           <td class=\"forum_replies\"><a href=\"javascript:otk_popup('forum/popups/posts.php?id_t={$thread->id}');\">$replies</a></td>
           <td class=\"forum_author\"><a href=\"community/profile.php?name={$first_post->author}\">{$first_post->author},</a><br />$date1</td>
           <td class=\"forum_cons\">{$thread->cons}</td>
           <td class=\"forum_last_post\"><a href=\"community/profile.php?name={$last_post->author}\">{$last_post->author},</a><br />$date2</td>
          </tr>";
    }
    echo "<td class=\"not_evidence\" colspan=\"6\">{$lang["forum"]["captions"]["normal"]}</td>
    ";
}
//normal threads
while ($thread = otk_sql_fetch_array($m)) {
    $thread = new OTK_Thread($thread["id"]);
    $q = otk_sql_query("SELECT * FROM oss_surveys WHERE id_t = '{$thread->id}'");
    $s = otk_sql_num_rows($q);
    //control: if thread have a survey show a string before thread name
    if ($s) {
        $survey = "{$lang["forum"]["survey"]}: ";
    } else {
        $survey = "";
    }
    if ($thread->img) {
        $img = "<img src=\"{$thread->img}\" alt=\"{$thread->img}\" />";
    } else {
        $img = "";
    }
    if ($thread->description) {
        $description = "<p class=\"small\">{$thread->description}</p>";
    } else {
        $description = "";
    }
    $posts = $thread->NumberPosts();
    $p = ceil($posts / $rec);
    if ($p == 1) {
        $thread_pages = "";
    } elseif ($p == 2) {
        $thread_pages = "<br /><em>P:&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=2\">2</a></em>";
    } elseif ($p == 3) {
        $thread_pages = "<br /><em>P:&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=2\">2</a>,&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=3\">3</a></em>";
    } else {
        $thread_pages = "<br /><em>P:&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=2\">2</a>&nbsp;..&nbsp;<a href=\"forum/thread.php?id_t={$thread->id}&amp;page=$p\">$p</a></em>";
    }
    $replies = $posts-1;
    $first_post = $thread->GetFirstPost();
    $last_post  = $thread->GetLastPost();
    $date1 =  otk_time_getdate($first_post->date);
    $date2 =  otk_time_getdate($last_post->date);
    echo "
      <tr>
       <td class=\"forum_x\">";
    if ($thread->closed) {
        //if thread is closed print a padlock
        echo "<img src=\"{$graphic_base}forum/icons/-1.png\" alt=\"#\" />";
    } else {
        //thread updates and old threads
        if ($last_post->date > $user->last_visit) {
            echo "<img src=\"{$graphic_base}forum/icons/1.png\" alt=\"O\" />";
        } else {
            echo "<img src=\"{$graphic_base}forum/icons/0.png\" alt=\"X\" />";
        }
    }
    echo "</td>
       <td class=\"forum_name\"><a href=\"forum/thread.php?id_t={$thread->id}\">{$img}{$survey}{$thread->name}{$description}</a>{$thread_pages}</td>
       <td class=\"forum_replies\"><a href=\"javascript:otk_popup('forum/popups/posts.php?id_t={$thread->id}');\">$replies</a></td>
       <td class=\"forum_author\"><a href=\"community/profile.php?name={$first_post->author}\">{$first_post->author},</a><br />$date1</td>
       <td class=\"forum_cons\">{$thread->cons}</td>
       <td class=\"forum_last_post\"><a href=\"community/profile.php?name={$last_post->author}\">{$last_post->author},</a><br />$date2</td>
      </tr>";
}
?>
 </tbody>
</table>
<?
otk_pages_list($pages, $_GET["page"], "forum/forum.php?id_f={$forum->id}");
//control: if forum is reserved normal user can't open new threads
if (!$forum->reserved or ($forum->reserved and $user and (in_array("reserved", $permissions["forum"]) or in_array("reserved_{$forum->id}", $permissions["forum"])))) {
    ?>
    <div class="forum_buttons_new_thread">
    <a href="forum/form_new_thread.php?id_f=<? echo $forum->id; ?>" class="button"><?
    echo $lang["buttons"]["new_thread"];
    ?></a>
    </div>
    <?
} else {
    ?>
    <div class="forum_buttons_reserved"><?
    echo $lang["buttons"]["reserved"];
    ?></div>
    <?
}
?>
<br class="clear" />
<hr />
<p>
<img src="<? echo $graphic_base; ?>forum/icons/1.png" alt="X" /> <?
echo $lang["forum"]["legend"]["new_messages"];
?>
<img src="<? echo $graphic_base; ?>forum/icons/0.png" alt="-" /> <?
echo $lang["forum"]["legend"]["no_new_messages"];
?>
<img src="<? echo $graphic_base; ?>forum/icons/-1.png" alt="-" /> <?
echo $lang["forum"]["legend"]["thread_closed"];
?>
</p>
<?
require("../common/footer.php");
?>
