<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: forum
    File
    /forum/index.php
    This file lists the forum in categories
*/

$module = "forum";
$only_users = FALSE;
$abc = "forum/index.php";
$no_gotoforum = TRUE;
include("../common/config.php");


//header
$header["title"] = $lang["titles"]["index"];
$header["common_text"] = "<div class=\"forum_navigation\">{$lang["common_text"]["welcome"]}</div>
";
require("../common/header.php");
?>
<table class="forum_index">
    <thead>
        <tr>
        <th class="forum_index_x"><? echo $lang["index"]["th"]["x"]; ?></th>
        <th class="forum_index_name"><? echo $lang["index"]["th"]["name"]; ?></th>
        <th class="forum_index_n_t"><? echo $lang["index"]["th"]["n_t"]; ?></th>
        <th class="forum_index_n_p"><? echo $lang["index"]["th"]["n_p"]; ?></th>
        <th class="forum_index_last_post"><? echo $lang["index"]["th"]["last_post"]; ?></th>
        </tr>
    </thead>
    <tbody>
    <?
    $q1 = otk_sql_query("SELECT * FROM oss_forums_types");
    while ($type = otk_sql_fetch_array($q1)) {
        $q = otk_sql_query("SELECT * FROM oss_forums WHERE ((id_t = '{$type["id"]}') AND (id_f = '0')) ORDER BY name");
        echo "<tr>
        <td class=\"forum_index_caption\" colspan=\"5\">{$type["name"]}</td>
        </tr>
        ";
        while ($forum = otk_sql_fetch_array($q)) {
            $forum = new OTK_Forum($forum["id"]);
            if ($forum->private and !in_array("private", $permissions["forum"]) and !in_array("private_{$forum->id}", $permissions["forum"])) {
                echo "
                <tr>
                    <td class=\"forum_index_x\"></td>
                    <td class=\"forum_index_name\">
                {$forum->name}
                <div class=\"forum_description\">{$forum->description}</div>";
                if ($mods = $forum->GetModerators()) {
                    echo "<div class=\"forum_moderators\"><em>[M] $mods</em></div>";
                }
                if ($groups = $forum->GetGroups()) {
                    echo "<div class=\"forum_groups\"><em>[G] $groups</em></div>";
                }
                echo "</td>
                    <td class=\"forum_index_n_t\">&nbsp;</td>
                    <td class=\"forum_index_n_p\">&nbsp;</td>
                    <td class=\"forum_index_last_post\">&nbsp;</td>
                </tr>
                ";

                //private mode
                continue;
            }
            $last_thread = $forum->GetLastThread();
            $last_post   = $forum->GetLastPost();
            //row
            echo "
            <tr>
                <td class=\"forum_index_x\">";
            //control of new posts
            if ($last_post->date > $user->last_visit) {
                echo "<img src=\"{$graphic_base}forum/icons/1.png\" alt=\"O\" />
                ";
            } else {
                echo "<img src=\"{$graphic_base}forum/icons/0.png\" alt=\"X\" />
                ";
            }
            echo "</td>
                <td class=\"forum_index_name\">
                <a href=\"forum/forum.php?id_f={$forum->id}\">{$forum->name}</a>
                <div class=\"forum_description\">{$forum->description}</div>";
            if ($mods = $forum->GetModerators()) {
                echo "<div class=\"forum_moderators\"><em>[M] $mods</em></div>";
            }
            if ($groups = $forum->GetGroups()) {
                echo "<div class=\"forum_groups\"><em>[G] $groups</em></div>";
            }
            echo "</td>
                <td class=\"forum_index_n_t\">" . $forum->NumberThreads() . "</td>
                <td class=\"forum_index_n_p\">" . $forum->NumberPosts() . "</td>
                <td class=\"forum_index_last_post\">";
            if ($last_post) {
                echo $last_post->Presentation();
            }
            echo "</td>
            </tr>
            ";
        }
    }
    ?>
    </tbody>
</table>
<br />
<p>
<img src="<? echo $graphic_base; ?>forum/icons/1.png" alt="X" /> <?
echo $lang["index"]["legend"]["new_messages"];
?>
<img src="<? echo $graphic_base; ?>forum/icons/0.png" alt="-" /> <?
echo $lang["index"]["legend"]["no_new_messages"];
?>
</p>
<?
require("../common/footer.php");
?>
