<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: forum
    File
    /forum/new_thread.php[POST]
    This file create a new thread (with form_new_thread.php)
*/

$module = "forum";
$only_users = TRUE;
$abc = "forum/form_new_thread.php?id_f=$_POST[id_f]";
include("../common/config.php");


//control: security number
if (!security_numbers_validate($_POST["id"], $_POST["number"])) {
    otk_error($lang["errors"]["security_numbers"], $abc);
}

$forum = new OTK_Forum($_POST["id_f"]);

//control: if forum is private user needs permissions
if ($forum->private and !in_array("private", $permissions["forum"]) and !in_array("private_{$forum->id}", $permissions["forum"])) {
    otk_error($lang["errors"]["permissions"], "forum/index.php?");
}

//control: if forum is reserved normal user cant open threads
if ($forum->reserved and !in_array("reserved", $permissions["forum"]) and !in_array("reserved_{$forum->id}", $permissions["forum"])) {
    exit;
}

//control: name of thread must exists
if ($_POST["name"] == "") {
    otk_error($lang["errors"]["title_must_exist"], $abc);
}

//control: name of thread mustn't exists in table of threads
if (otk_sql_num_rows(otk_sql_query("SELECT * FROM oss_threads WHERE name = '$_POST[name]'"))) {
    otk_error($lang["errors"]["thread_already_exists"], $abc);
}

//inserting the thread
$_POST["name"]      = otk_html_normalize($_POST["name"]);
$_POST["description"] = otk_html_normalize($_POST["description"]);
$_POST["img"]         = basename($_POST["img"]);
if ($_POST["img"]) {
    $img = "{$base}{$graphic_base}forum/img/{$_POST["img"]}";
} else {
    $img = "";
}
$q = otk_sql_query("INSERT INTO oss_threads
(id_f, img, name, description, date)
VALUES (
'$_POST[id_f]',
'$img',
'$_POST[name]',
'$_POST[description]',
'$timestamp'
)");
$thread["id"] = otk_sql_insert_id();
if ($_POST["follow"]) {
    otk_sql_query("INSERT INTO oss_threads_followers
    (nick, id_t)
    VALUES (
    '{$user->nick}',
    '{$thread["id"]}'
    )");
}
$thread = new OTK_Thread($thread["id"]);
$user->IncPoints(OSS_POINTS_NEW_THREAD);

//creation of survey, if is set
if ($_POST["question"]) {
    $question = otk_html_normalize((string) $_POST["question"]);
    if ($question === "") {
        otk_error($lang["errors"]["empty_field"], $url);
    }
    unset($_POST["question"], $_POST["id"], $_POST["number"], $_POST["name"], $_POST["id_f"]);
    $q = otk_sql_query("INSERT INTO oss_surveys
    (id_t, question)
    VALUES (
    '{$thread->id}',
    '{$question}'
    )");
    $id_s = otk_sql_insert_id();
    foreach ($_POST as $name => $value) {
        if (strstr($name, "_") and $value) {
            $value = otk_html_normalize($value);
            otk_sql_query("INSERT INTO oss_surveys_options
            (id_s, value)
            VALUES (
            '{$id_s}',
            '{$value}'
            )");
        }
    }
    $user->IncPoints(OSS_POINTS_NEW_SURVEY);
}
$text = otk_html_format($_POST["text"]);
$q = $q and otk_sql_query("INSERT INTO oss_posts
(id_t, id_f, author, text, date)
VALUES (
'{$thread->id}',
'{$forum->id}',
'{$user->nick}',
'{$text}',
'{$timestamp}'
)");
$post["id"] = otk_sql_insert_id();
$post = new OTK_Post($post["id"]);

//header
$header["title"] = $forum->Title();
$bar = $forum->Bar();
$header["title"] .= " - {$lang["titles"]["new_thread"]}";
$header["common_text"] = "<div class=\"forum_navigation\">{$lang["common_text"]["thread_inserted"]} <strong>{$thread->name}</strong></div>
";
require("../common/header.php");
?>
<div class="links">
    <a href="forum/thread.php?id_t=<? echo $thread->id; ?>&amp;go_last_post=1#<? echo $post->id; ?>">
    <? echo $lang["common_text"]["thread"]; ?>: <? echo $thread->name; ?></a><br />
    <a href="forum/form_new_thread.php?id_f=<? echo $forum->id; ?>"><? echo $lang["common_text"]["new_thread"]; ?></a><br />
    <? echo $lang["common_text"]["forum"]; ?>: <? echo $bar; ?><br />
    <a href="forum/index.php"><? echo $lang["common_text"]["index"]; ?></a>
</div>
<?
require("../common/footer.php");
?>
