<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: forum
    File
    /forum/search.php[POST]
    This file search a post (with form_search.php)
*/

$module = "forum";
$only_users = FALSE;
$abc = "forum/form_search.php";
include("../common/config.php");

$url = "forum/form_search.php?";
//control; security number
if (!security_numbers_validate($_POST["id"], $_POST["number"])) {
    otk_error($lang["errors"]["security_numbers"], $url);
}
//controllo: deve esistere almeno una chiave
if ($_POST["keys"] == "") {
    otk_error($lang["errors"]["keys_must_exist"], $url);
}
$keys = explode(" ", $_POST["keys"]);
if (count($keys) > 10) {
    otk_error($lang["errors"]["too_keys"], $url);
}
$header["title"] = $lang["titles"]["search"];
$header["common_text"] = "<div class=\"forum_navigation\">
<a href=\"forum/index.php\">{$lang["common_text"]["index"]}</a><br />
<a href=\"forum/form_search.php\">{$lang["common_text"]["search"]}</a>: $_POST[keys]
</div>
";
$header["style"] .= "
th.search_thread
{
    width: 20%;
}
th.search_forum
{
    width: 20%;
}
th.search_replies
{
    width: 20%;
}
th.search_author
{
    width: 20%;
}
th.search_last_post
{
    width: 20%;
}
td.search_thread
{
    width: 20%;
    text-align: left;
}
td.search_forum
{
    width: 20%;
    text-align: left;
}
td.search_replies
{
    width: 20%;
}
td.search_author
{
    width: 20%;
}
td.search_last_post
{
    width: 20%;
}
";
require("../common/header.php");
//composition of query
$clauses = array();
//KEYWORDS
if (TRUE) {
    //boolean logic for keywords search
    if ($_POST["type"] == "or") {
        $c = " OR ";
    } else {
        //if type=="and" or if is not specified
        $c = " AND ";
    }
    $highlighted_words = array();
    $keywords_terms = array();
    foreach ($keys as $keyword) {
        $highlighted_words[] = $keyword;
        $keywords_terms[] = "(text LIKE '%{$keyword}%')";
    }
    $subquery = "(";
    $subquery .= implode($c, $keywords_terms);
    $subquery .= ")";
    $clauses[] = $subquery;
}
//AUTHOR
$_POST["c_author"] = (bool) $_POST["c_author"];
$_POST["c_id_f"] = (bool) $_POST["c_id_f"];
if ($_POST["c_id_f"] and $_POST["id_f"]) {
    $clauses[] = "(id_f = '{$_POST["id_f"]}')";
}
if ($_POST["c_author"] and $_POST["author"]) {
    $clauses[] = "(author = '{$_POST["author"]}')";
}
//composition of main query
$query = "SELECT * FROM oss_posts WHERE (";
$query .= implode(" AND ", $clauses);
$query .= ")";
$q = otk_sql_query($query);
echo "<p>{$lang["search"]["searched"]}: ".implode(", ", $highlighted_words)."</p>
";
if (otk_sql_num_rows($q)) {
    ?>
    <table>
    <thead>
     <tr>
      <th class="search_thread"><? echo $lang["search"]["th"]["thread"]; ?></th>
      <th class="search_forum"><? echo $lang["search"]["th"]["forum"]; ?></th>
      <th class="search_replies"><? echo $lang["search"]["th"]["replies"]; ?></th>
      <th class="search_author"><? echo $lang["search"]["th"]["author"]; ?></th>
      <th class="search_last_post"><? echo $lang["search"]["th"]["last_post"]; ?></th>
     </tr>
    </thead>
    <tbody>
    <?
    $already = array();
    $highlight = otk_char_encode($highlighted_words);
    while ($post = otk_sql_fetch_array($q)) {
        $post   = new OTK_Post($post["id"]);
        $thread = new OTK_Thread($post->id_t);
        $forum  = new OTK_Forum($post->id_f);
        //control: if forum is private user needs permissions
        if ($forum->private and !in_array("private", $permissions["forum"]) and !in_array("private_{$forum->id}", $permissions["forum"])) {
            continue;
        }
        if (in_array($thread->id, $already)) {
            continue;
        }
        $already[] = $thread->id;
        $last_post = $thread->GetLastPost();
        $first_post = $thread->GetFirstPost();
        $date1 =  otk_time_getdate($first_post->date);
        $date2 =  otk_time_getdate($last_post->date);
        $forum = new OTK_Forum($thread->id_f);
        $replies = $thread->NumberPosts() - 1;
        echo "
          <tr>
           <td class=\"search_thread\"><a href=\"forum/thread.php?id_t={$thread->id}&amp;highlight=$highlight\">{$thread->name}</a></td>
           <td class=\"search_forum\"><a href=\"forum/forum.php?id_f={$forum->id}\">{$forum->name}</a></td>
           <td class=\"search_replies\"><a href=\"javascript:otk_popup('forum/popups/posts.php?id_t={$thread->id}');\">{$replies}</a></td>
           <td class=\"search_author\"><a href=\"community/profile.php?name={$first_post->author}\">{$first_post->author}</a>, <br />$date1</td>
           <td class=\"search_last_post\"><a href=\"community/profile.php?name={$last_post->author}\">{$last_post->author}</a>, <br />$date2</td>
          </tr>
        ";
    }
    ?>
    </table>
    <?
} else {
    echo "<p>{$lang["search"]["no_results"]}</p>
    <div class="links">
<a href=\"forum/form_search.php\">{$lang["titles"]["form_search"]}</a>
</div>
    ";
}
require("../common/footer.php");
?>
