<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: forum
    File
    /forum/thread.php?id_t
    This file lists the posts in a thread
*/

$module = "forum";
$only_users = FALSE;
$abc = "forum/thread.php?id_t=$_GET[id_t]";
include("../common/config.php");

$thread = new OTK_Thread($_GET["id_t"]);
if ($thread === NULL) {
    exit;
}
$forum  = new OTK_Forum($thread->id_f);
//control: if forum is private user needs permissions
if ($forum->private and !in_array("private", $permissions["forum"]) and !in_array("private_{$forum->id}", $permissions["forum"])) {
    otk_error($lang["errors"]["permissions"], "forum/index.php?");
}
$header["title"] = $forum->Title();
$header["title"] .= " - {$lang["titles"]["thread"]}: {$thread->name}";
$bar = $forum->Bar();
$header["common_text"] = "<div class=\"forum_navigation\">
<a href=\"forum/index.php\">{$lang["common_text"]["index"]}</a><br />
{$lang["common_text"]["forum"]}: $bar<br />
{$lang["common_text"]["thread"]}: {$thread->name}
</div>
";
require("../common/header.php");
if ($user) {
    //user will/won't follow thread by mail
    if ($_GET["follow"] == "yes") {
        $thread->AddFollower($user->nick);
    }
    if ($_GET["follow"] == "no") {
        $thread->RemoveFollower($user->nick);
    }
    if (in_array($user>nick, $thread->followers)) {
        //the user is following the thread
        echo "<p><a href=\"forum/thread.php?id_t={$thread->id}&amp;follow=no\">
        {$lang["thread"]["follow"]["yes"]}</a></p>
        ";
    } else {
        //the user isn't following the thread
        echo "<p><a href=\"forum/thread.php?id_t={$thread->id}&amp;follow=yes\">
        {$lang["thread"]["follow"]["no"]}</a></p>
        ";
    }
}
$a = otk_sql_query("SELECT * FROM oss_posts WHERE id_t = '{$thread->id}'");
$n = otk_sql_num_rows($a);
//calculus pages
list($pages, $inf, $rec) = otk_pages($n, $_GET["page"]);
if (isset($_GET["go_last_post"])) {
    //if user want to go to last_post, ricalculus the pages
    $_GET["page"] = $pages;
    list($pages, $inf, $rec) = otk_pages($n, $_GET["page"]);
}
$b = otk_sql_query("SELECT * FROM oss_posts WHERE id_t = {$thread->id} ORDER BY id ASC LIMIT $inf, $rec");
otk_pages_list($pages, $_GET["page"], "forum/thread.php?id_t={$thread->id}");
//control: if forum is reserved normal user can't open new threads
if (!$forum->reserved or ($forum->reserved and $user and (in_array("reserved", $permissions["forum"]) or in_array("reserved_{$forum->id}", $permissions["forum"])))) {
    ?>
    <div class="forum_buttons_new_thread">
    <a href="forum/form_new_thread.php?id_f=<? echo $forum->id; ?>" class="button"><?
    echo $lang["buttons"]["new_thread"];
    ?></a>
    </div>
    <?
} else {
    ?>
    <div class="forum_buttons_reserved"><?
    echo $lang["buttons"]["reserved"];
    ?></div>
    <?
}
//control: if thread is closed user can't reply
if ($thread->closed) {
    ?>
    <div class="forum_buttons_closed"><?
    echo $lang["buttons"]["closed"];
    ?></div>
    <?
} else {
    ?>
    <div class="forum_buttons_new_post">
    <a href="forum/form_new_post.php?id_t=<? echo $thread->id; ?>" class="button"><?
    echo $lang["buttons"]["new_post"];
    ?></a>
    </div>
    <?
}
?>
<br class="clear" />
<?
$q = otk_sql_query("SELECT * FROM oss_surveys WHERE id_t = {$thread->id}");
if (otk_sql_num_rows($q)) {
    //if there is a survey
    $survey = otk_sql_fetch_array($q);
    $survey = new OTK_Survey($survey["id"]);
    echo "<table>
    <caption>{$lang["forum"]["survey"]}: {$survey->survey}</caption>
    ";
    $total = $survey->NumberVotes();
    foreach ($survey->options as $i => $option)
    {
        if ($total != 0) {
            //if total is not 0, calculate the percentages
            $percentage = $option->NumberVotes() / $total * 100;
            $percentage = round($percentage, OSS_DECIMAL_PRECISION);
        } else {
            $percentage = "0";
            if (OSS_DECIMAL_PRECISION > 0) {
                $percentage .= ".";
                for ($j = 1; $j <= OSS_DECIMAL_PRECISION; $j++) {
                    $percentage .= "0";
                }
            }
        }
        echo "<tr>
        <td class=\"survey_a\">{$option->value}</td>
        <td class=\"survey_bar\"><strong>{$percentage}%</strong> (" . $option->NumberVotes() . " voti)&nbsp;";
        //graceful coloured bar
        $length = round($percentage);
        for ($j = 1; $j <= $length; $j++) {
            echo "<img class=\"null\" src=\"{$graphic_base}surveys/bar.png\" alt=\"|\" />";
        }
        echo "</td>
        </tr>
        ";
    }
    echo "</table>
    ";
} ?>
<table>
<?
$authors = array();
while($post = otk_sql_fetch_array($b))
{
    $post = new OTK_Post($post["id"]);
    //for each post, if there is an author on a post above, use that
    if (array_search($post->author, $authors)) {
        $author = $authors[$post->author];
    } else {
        $author = new OTK_User($post->author);
        $authors[$author->nick] = $author;
    }
    $date =  otk_time_getdate($post->date);
    $date_reg =  otk_time_getdate($author->date);
    $author_title = strtolower($author->title);
    echo "<tr>";

    //AUTHOR
    echo "
    <td class=\"forum_thread_author\">
    <a href=\"community/profile.php?name={$author->nick}\">{$author->nick}</a><br /><br />";
    if($author->active)
    {
        echo "{$author->avatar}<br />";    //avatar
        for($j = 1; $j <= $author->rank; $j++)
        {
            //rank bar
            echo "<img src=\"{$graphic_base}community/rank.png\" alt=\"+\" />";
        }
        echo "<br/>
        {$author->title}<br />\n";
        if($author->honour)
        {
            //if there is an honour, print it
            echo "<strong>{$author->honour}</strong><br />\n";
        }
        if ($author->id_g) {
            $primary_group = new OTK_Group($author->id_g);
            echo "{$lang["details"]["primary_group"]}: {$primary_group->name}<br />";
        }
        if ($author->gender == $lang["genders"]["female"]) {
            echo $lang["details"]["registered_f"];
        } else /* if($author->gender == $lang["genders"]["male"]) */ {
            echo $lang["details"]["registered_m"];
        }
        echo ": $date_reg<br />
        $info[points_name]: {$author->points}<br />";    //points

        if ($author->fields->content) {
            foreach ($author->fields->names as $id => $name) {
                echo "{$name}: {$author->fields->content[$id]}<br />
                ";
            }
        }

        //control: online/offline
        if ($author->online) {
            echo "<div class=\"positive\"><strong>{$lang["details"]["online"]}</strong></div>
            ";
        } else {
            echo "<div class=\"negative\"><strong>{$lang["details"]["offline"]}</strong></div>
            ";
        }
        if ($author->rank < 7) {
            //printing bar of warning
            if (($user->rank >= 7) or ($user->nick == $author->nick)) {
                echo "<a href=\"community/warning.php?name={$author->nick}\">";
            }
            echo "{$lang["details"]["warning_short"]} : ";
            for ($i = 1; $i <= $author->warning; $i++) {
                echo "<img class=\"null\" src=\"{$graphic_base}community/warning1.png\" alt=\"-\" />";
            }
            $warning_no = 100 - $author->warning;
            for ($i = 1; $i <= $warning_no; $i++) {
                echo "<img class=\"null\" src=\"{$graphic_base}community/warning0.png\" alt=\"|\" />";
            }
            echo "&nbsp;$author->warning%";
            if (($user->rank >= 7) or ($user->nick == $author->nick)) {
                echo "</a>";
            }
        }
    } else {
        if ($author->gender == $lang["genders"]["female"]) {
            echo "<div class=\"negative\"><strong>{$lang["details"]["disactivated_f"]}</strong></div>";
        } else /* if($author->gender == $lang["genders"]["male"]) */ {
            echo "<div class=\"negative\"><strong>{$lang["details"]["disactivated_m"]}</strong></div>";
        }
    }
    echo "</td>";

    //TEXT
    echo "<td class=\"forum_thread_post\">
    <div class=\"forum_post_info\">
    <a id=\"_{$post->id}\"></a>&nbsp;
    $date;&nbsp;
    Id post: {$post->id};&nbsp;
    </div>
    ";
    if ($user->nick == $author->nick) {
        //author services: edit and delete
        echo "<div class=\"forum_thread_edit\">
        <a href=\"forum/form_edit_post.php?id_p={$post->id}\" class=\"button\">
        {$lang["thread"]["buttons"]["edit"]}
        </a>
        </div>
        <div class=\"forum_thread_delete\">
        <a href=\"forum/delete_post.php?id_p={$post->id}\" class=\"button\">
        {$lang["thread"]["buttons"]["delete"]}
        </a>
        </div>
        ";
    } elseif($user and (in_array("moderator", $permissions["forum"]) or in_array("moderator_{$forum->id}", $permissions["forum"]))) {
        //moderator services: edit and delete
        echo "<div class=\"forum_thread_edit\">
        <a href=\"{$admin}ossigeno/forum/form_edit_post.php?id_p={$post->id}\" class=\"button\">
        {$lang["thread"]["buttons"]["edit"]}
        </a>
        </div>
        <div class=\"forum_thread_delete\">
        <a href=\"{$admin}ossigeno/forum/delete_post.php?id_p={$post->id}\" class=\"button\">
        {$lang["thread"]["buttons"]["delete"]}
        </a>
        </div>
        ";
    }
    if ($user) {
        //user services
        if (!$thread->closed) {
            echo "
            <div class=\"forum_thread_quoting\">
            <a href=\"forum/form_new_post.php?id_t=$_GET[id_t]&amp;quote={$post->id}\" class=\"button\">
            {$lang["thread"]["buttons"]["quote"]}
            </a>
            </div>
            ";
        }
        $mods = $forum->GetModerators();
        if (!$mods) {
            $q2 = otk_sql_query("SELECT * FROM oss_users WHERE rank = '8'");
            $mods = array();
            while ($name = otk_sql_fetch_array($q2)) {
                $mods[] = $name["nick"];
            }
        }
        $mod = otk_char_encode($mods);
        echo "<div class=\"forum_thread_report\">
        <a href=\"messages/form_new_message.php?to=$mod&amp;subject=Report: thread({$_GET[id_t]}), post({$post->id})\" class=\"button\">
        {$lang["thread"]["buttons"]["report"]}
        </a>
        </div>
        ";
    }
    echo "
    <div class=\"forum_thread_up\">
    <a href=\"forum/thread.php?id_t=$_GET[id_t]&amp;page=$_GET[page]#top\">&nbsp;&nbsp;&nbsp;&nbsp;</a>
    </div>
    <br class=\"clear\" />
    <hr /><br />";
    //text
    $text = $post->text;
    if (isset($_GET["highlight"])) {
        $keys = otk_char_decode($_GET["highlight"]);
        foreach ($keys as $key) {
            $text = str_replace($key, "<span class=\"evidence\">".$key."</span>", $text);
        }
    }
    echo "<div class=\"forum_post_text\">
    {$text}
    </div>";
    if($post->modified_nick)
    {
        echo "<em>{$lang["thread"]["edited_by"]} <strong>{$post->modified_nick}</strong>, ". otk_time_getdate($post->modified_date)."</em>";
    }
    echo "<hr /><br />
    {$author->signature}
    <br /><hr />";

    //barra utente
    echo "<div class=\"forum_thread_profile\">
    <a href=\"community/profile.php?name={$author->nick}\" class=\"button\">
    {$lang["thread"]["buttons"]["profile"]}
    </a>
    </div>
    <div class=\"forum_thread_pm\">
    <a href=\"messages/form_new_message.php?to={$author->nick}\" class=\"button\">
    {$lang["thread"]["buttons"]["pm"]}
    </a>
    </div>
    ";
    if ($author->www) {
        echo "<div class=\"forum_thread_www\">
        <a href=\"{$author->www}\" class=\"button_blank\">
        {$lang["thread"]["buttons"]["www"]}
        </a>
        </div>
        ";
    }
    if ($author->page) {
        echo "<div class=\"forum_thread_page\">
        <a href=\"community/page.php?name={$author->nick}\" class=\"button\">
        {$lang["thread"]["buttons"]["page"]}
        </a>
        </div>
        ";
    }
    if ($author->show_mail) {
        echo "<div class=\"forum_thread_email\">
        <a href=\"mailto:{$author->mail}\" class=\"button\">
        {$lang["thread"]["buttons"]["email"]}
        </a>
        </div>
        ";
    }
    if ($author->icq) {
        echo "<div class=\"forum_thread_icq\">
        <a href=\"javascript:otk_popup('{$base}community/popups/icq.php?name={$author->nick}')\" class=\"button\">
        {$lang["thread"]["buttons"]["icq"]}
        </a>
        </div>
        ";
    }
    if ($author->msnm) {
        echo "<div class=\"forum_thread_msnm\">
        <a href=\"javascript:otk_popup('{$base}community/popups/msnm.php?name={$author->nick}')\" class=\"button\">
        {$lang["thread"]["buttons"]["msnm"]}
        </a>
        </div>
        ";
    }
    if ($author->aim) {
        echo "<div class=\"forum_thread_aim\">
        <a href=\"javascript:otk_popup('{$base}community/popups/aim.php?name={$author->nick}')\" class=\"button\">
        {$lang["thread"]["buttons"]["aim"]}
        </a>
        </div>
        ";
    }
    if ($author->yim) {
        echo "<div class=\"forum_thread_yim\">
        <a href=\"javascript:otk_popup('{$base}community/popups/yim.php?name={$author->nick}')\" class=\"button\">
        {$lang["thread"]["buttons"]["yim"]}
        </a>
        </div>
        ";
    }
    echo "</td>
       </tr>
     ";
}
$thread->Cons();
?>
</table>
<?
//control: if forum is reserved normal user can't open new threads
if (!$forum->reserved or ($forum->reserved and $user and (in_array("reserved", $permissions["forum"]) or in_array("reserved_{$forum->id}", $permissions["forum"])))) {
    ?>
    <div class="forum_buttons_new_thread">
    <a href="forum/form_new_thread.php?id_f=<? echo $forum->id; ?>" class="button"><?
    echo $lang["buttons"]["new_thread"];
    ?></a>
    </div>
    <?
} else {
    ?>
    <div class="forum_buttons_reserved"><?
    echo $lang["buttons"]["reserved"];
    ?></div>
    <?
}
//control: if thread is closed user can't reply
if ($thread->closed) {
    ?>
    <div class="forum_buttons_closed"><?
    echo $lang["buttons"]["closed"];
    ?></div>
    <?
} else {
    ?>
    <div class="forum_buttons_new_post">
    <a href="forum/form_new_post.php?id_t=<? echo $thread->id; ?>" class="button"><?
    echo $lang["buttons"]["new_post"];
    ?></a>
    </div>
    <?
    if ($user) {
        //if user is authentified, fast reply
        ?>
        <div class="forum_buttons_fast_new_post">
        <a href="#" onclick="return otk_show_hide('form')" class="button"><?
        echo $lang["buttons"]["fast_new_post"];
        ?></a>
        </div>
        <?
    }
}
?>
<br class="clear" />
<?
otk_pages_list($pages, $_GET["page"], "forum/thread.php?id_t=$_GET[id_t]");
if ($user) {
    //form fast reply for authentified user
    $security = security_numbers_generate();
    ?>
    <form action="forum/new_post.php" method="post" id="form" class="hidden" onsubmit="return otk_validate()">
    <textarea id="text" name="text"></textarea>
    <p class="hidden">
    <input type="hidden" id="id_t" name="id_t" value="<? echo $thread->id; ?>" />
    <input type="hidden" id="id" name="id" value="<? echo $security["id"]; ?>" />
    <input type="hidden" id="number" name="number" value="<? echo $security["number"]; ?>" />
    </p>
    <button type="submit"><? echo $lang["submit"]; ?></button></div>
    </form>
    <?
}
require("../common/footer.php");
?>
