<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Library: html_extended
    File
    /common/classes/html_extended.php
    This file defines classes for some xhmtl common entities
*/

require_once("html_tags.php");
require_once("html_forms.php");

class OTK_InputButtonHelp extends OTK_InputButton
{
    function OTK_InputButtonHelp($message, $id = "", $value = "?")
    {
        parent::OTK_InputButton($id, $value);
        $this->SetAttr("onclick", "alert('" . addslashes($message) . "');");
    }
}

class OTK_PagesList extends OTK_P
{
    function OTK_PagesList($pages, $page, $url)
    {
        global $lang, $lc;
        $pages = (int) $pages;
        $page  = (int) $page;
        $url   = (string) $url;
        if ($page == 0) {
            $page = 1;
        }
        if ($pages == 0) {
            $this->Clear($this);
        }
        if ($pages == 1) {
            $this->Clear($this);
        }
        $this->SetAttr("class", "OTK_PagesList");
        $text = new OTK_Span("{$lang["lib"]["pages"]}:&nbsp;");
        $this->AddChild($text);
        //  <<
        if ($page > 2) {
            $a = new OTK_A("{$url}&amp;page=1", "{$lc["<"]}{$lc["<"]}&nbsp;");
            $this->AddChild($a);
        }
        //  <
        if ($page > 1) {
            $prev = $page - 1;
            $a = new OTK_A("{$url}&amp;page=$prev", "{$lc["<"]}&nbsp;");
            $this->AddChild($a);
        }
        $min = max(((int) $pages / 2) - 2, 1);
        $max = min(((int) $pages / 2) + 2, $pages);
        for ($i = $min; $i <= $max; $i++) {
            if ($i != $page) {
                $tag = new OTK_A("{$url}&amp;page={$i}", "{$i}&nbsp;");
            } else {
                $tag = new OTK_Span("{$i}&nbsp;");
            }
            $this->AddChild($tag);
        }
        //  >
        if ($pages - $page >= 1) {
            $next = $page + 1;
            $a = new OTK_A("{$url}&amp;page=$next", "{$lc[">"]}&nbsp;");
            $this->AddChild($a);
        }
        //  >>
        if ($pages - $page >= 2) {
            $a = new OTK_A("{$url}&amp;page=$pages", "{$lc[">"]}{$lc[">"]}&nbsp;");
            $this->AddChild($a);
        }
        echo "</div>
        ";
    }
}
?>
