<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Librari: html_tags
    File
    /common/classes/html_tags.php
    This file defines classes for xhmtl basic management
*/

class OTK_Tag
{
    //base class
    //tag (x)html
    var $name;
    var $attrs;
    var $parent;
    var $children;
    var $child;
    var $text;
    var $empty;
    function OTK_Tag($name, $text = "", $css = FALSE)
    {
        $this->name     = $name;
        $this->attrs    = array();
        $this->style    = array();
        $this->parent   = NULL;
        $this->children = array();
        $this->text     = $text;
        $this->empty    = FALSE;
        if ($css) {
            $this->SetAttr("class", strtolower(get_class($this)));
        }
    }
    function SetAttr($name, $value)
    {
        $this->attrs[$name] = $value;
    }
    function GetAttr($name)
    {
        return $this->attrs[$name];
    }
    function SetStyle($property, $value) {
        $this->style[$property] = $value;
        $s = array();
        foreach ($this->style as $p => $v) {
            $s[] = "{$p}: {$v};";
        }
        $this->SetAttr("style", implode(" ", $s));
    }
    function SetParent(&$parent)
    {
        $this->parent = &$parent;
    }
    function AddChild(&$tag)
    {
        $tag->SetParent($this);
        $this->children[] = &$tag;
        $this->child = &$tag;
    }
    function SetText($text)
    {
        $this->text = $text;
    }
    function GetText()
    {
        return $this->text;
    }
    function Display($echo = TRUE)
    {
        $text = "";
        if ($this->name !== NULL) {
            $text .= "<{$this->name}";
            foreach ($this->attrs as $name => $value) {
                $text .= " {$name}=\"{$value}\"";
            }
            if ($this->empty) {
                $text .= " />\n";
            } else {
                $text .= ">\n";
                foreach ($this->children as $tag) {
                    $text .= $tag->Display(FALSE);
                }
                $text .= $this->text;
                $text .= "</{$this->name}>\n";
            }
        }
        if ($echo) {
            echo $text;
        } else {
            return $text;
        }
    }
    function Dump()
    {
        echo "<div style=\"border: 1px solid blue; margin: 2px;\">";
        echo $this->name;
        foreach ($this->children as $tag) {
            $tag->Dump();
        }
        echo "</div>";
    }
    function Clear($object)
    {
        $object = new OTK_Tag(NULL);
    }
}

class OTK_Div extends OTK_Tag
{
    function OTK_Div($text = "")
    {
        parent::OTK_Tag("div");
        $this->text = $text;
    }
}

class OTK_P extends OTK_Tag
{
    function OTK_P($text = "")
    {
        parent::OTK_Tag("p");
        $this->text = $text;
    }
}

class OTK_Span extends OTK_Tag
{
    function OTK_Span($text = "")
    {
        parent::OTK_Tag("span");
        $this->text = $text;
    }
}

class OTK_A extends OTK_Tag
{
    function OTK_A($href, $text)
    {
        parent::OTK_Tag("a", $text);
        $this->SetAttr("href", $href);
    }
    function SetTitle($title)
    {
        $this->SetAttr("title", $title);
    }
}

class OTK_Img extends OTK_Tag
{
    var $mime;
    function OTK_Img($src, $alt = "")
    {
        global $base;
        parent::OTK_Tag("img");
        $this->empty = TRUE;
        $this->text = "";
        $this->SetAttr("src", $src);
        $this->SetAttr("alt", $alt);
        if (strstr($src, "://")) {
            $url = $src;
        } else {
            $url = "{$base}{$src}";
        }
        $info = @getimagesize($url);
        $this->SetAttr("width", $info[0]);
        $this->SetAttr("height", $info[1]);
        $this->mime = $info["mime"];
    }
    function SetWidth($w)
    {
        $this->SetAttr("width", $w);
    }
    function SetHeight($h)
    {
        $this->SetAttr("height", $h);
    }
    function ScaleToWidth($w)
    {
        if ($this->attrs["width"] > $w) {
            $p = $this->attrs["height"] / $this->attrs["width"];
            $this->attrs["width"] = $w;
            $this->attrs["height"] = round($p * $this->attrs["width"]);
        }
    }
    function ScaleToHeight($h)
    {
        if ($this->attrs["height"] > $h) {
            $p = $this->attrs["width"] / $this->attrs["height"];
            $this->attrs["height"] = $h;
            $this->attrs["width"] = round($p * $this->attrs["height"]);
        }
    }
    function ScaleToFit($w, $h)
    {
        $this->ScaleToWidth($w);
        $this->ScaleToHeight($h);
    }
}

?>
