<?
/*
    +----------------------------------------------------------------------+
    | OTK is a set of library for Ossigeno and Xax                         |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Library: date-time
    This file defines some functions to get human date and time
*/

function otk_time_getdate($time, $force_general = FALSE)
{
    global $lang, $lc, $timestamp, $info, $xax_info, $user;
    if ($xax_info) {
        //xax environment vs. oss environment
        $_info = $xax_info;
    } else {
        $_info = $info;
    }
    $time = (int) $time;
    if ($user->timezone !== NULL) {
        putenv("TZ={$user->timezone}");
    } else if ($_info["timezone"]) {
        putenv("TZ={$_info["timezone"]}");
    }
    /*
        $settings = getdate(0);
        if ($settings["hours"] > 12) {
            $settings["hours"] -= 24;
        }
        $hours = $settings["hours"];
        $settings = localtime($timestamp, TRUE);
        $dst = $settings["tm_isdst"];
        $time -= (3600 * ($hours + $dst)); //time on clocks at Greenwich
        if ($user and ($user->timezone !== NULL)) {
            $time += (3600 * ($user->timezone + $user->dst));
        } else {
            $time += (3600 * ($_info["timezone"] + $_info["dst"]));
        } //time on clocks on user screen, or at least on website
    */
    if ($time <= 0) {
        return $lc["time"]["never"];
    }
    //formatting codes
    $codes_names = array("a", "A", "B", "d", "D", "F", "g", "G", "h", "H", "i", "I", "j", "l", "L", "m", "M", "n", "O", "r", "s", "S", "t", "T", "U", "w", "W", "y", "Y", "z", "Z");
    $string = implode("@", $codes_names);
    $string = date($string, $time);
    $codes_values = explode("@", $string);
    $i = 0;
    $elements = array();
    while ($codes_names[$i]) {
        $elements[$codes_names[$i]] = $codes_values[$i];
        $i++;
    }
    $today = getdate($timestamp);
    $start_today     = mktime(0, 0, 0, $today["mon"], $today["mday"], $today["year"]);
    $start_yesterday = $start_today - 86400;
    $start_tomorrow  = $start_today + 86400;
    $end_tomorrow    = $start_tomorrow + 85399;
    if ($time >= $start_yesterday and !$force_general) {
        //Yesterday, 16:50
        $date = $lc["time"]["format_special"];
    } else {
        //Thu 6 Jul 2004, 16:20
        $date = $lc["time"]["format_general"];
    }
    $elements["D"] = $lc["days"]["short"][$elements["w"]];
    $elements["l"] = $lc["days"]["long"][$elements["w"]];
    $elements["M"] = $lc["months"]["short"][$elements["n"]];
    $elements["F"] = $lc["months"]["long"][$elements["n"]];
    $date = strtr($date, $elements);
    if (($start_tomorrow <= $time) and ($time <= $end_tomorrow)) {
        //Tomorrow, 14:43
        $date = str_replace("PPPP", $lc["time"]["tomorrow"], $date);
    } elseif (($start_today <= $time) and ($time < $start_tomorrow)) {
        //Today, 8:09
        $date = str_replace("PPPP", $lc["time"]["today"], $date);
    } elseif (($start_yesterday <= $time) and ($time < $start_today)) {
        //Yesterday, 16:50
        $date = str_replace("PPPP", $lc["time"]["yesterday"], $date);
    }
    return $date;
}

function otk_time_getmicro()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float) $usec + (float) $sec);
}
?>
