<?
/*
    +----------------------------------------------------------------------+
    | OTK is a set of library for Ossigeno and Xax                         |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Library: dirs
    Inclusions management
*/

function _otk_dir(&$path)
{
    if (substr($path, strlen($path) - 1, 1) != "/") {
        $path .= "/";
    }
}

function _otk_ext($filename)
{
    $slice = strrchr($filename, "."); //.php
    if ($slice) {
        return substr($slice, 1); //php
    } else {
        return ""; //no extension
    }
}

function _otk_name($filename)
{
    $p = strpos($filename, ".");
    if ($p !== FALSE) {
        return substr($filename, 0, $p);
    } else {
        return $filename; //no extension
    }
}

function _otk_set_include_path()
{
    global $level;
    $paths = explode(PATH_SEPARATOR, get_include_path());
    $index = array_search(".", $paths);
    if ($index !== NULL) {
        unset($paths[$index]);
    }
    $new_paths = array(".", $level);
    $new_paths = $new_paths + $paths;
    set_include_path(implode(PATH_SEPARATOR, $new_paths));
}
_otk_set_include_path();

function otk_include_dir($abs_path)
{
    foreach ($GLOBALS as $name => $value) {
        $$name = &$GLOBALS[$name];
    }
    static $included_files = array();
    _otk_dir($abs_path);
    $path = $level . $abs_path;

    //listing files
    if (file_exists("{$path}info.php")) {
        require("{$path}info.php"); //define $lib
    } else {
        $lib["files"] = array();
        $lib["deps"]  = array();
        $libs = opendir($path);
        while (($file = readdir($libs)) !== FALSE) {
            if (in_array($file, array("."))) {
                continue;
            }
            if (!is_dir("{$path}{$file}")) {
                $lib["files"][] = $file;
            }
        }
        closedir($libs);
    }

    //dependencies
    foreach ($lib["deps"] as $required) {
        otk_include_dir($required);
    }

    //including
    foreach ($lib["files"] as $file) {
        if (in_array("{$abs_path}{$file}", $included_files)) {
            continue;
        }
        $included_files[] = "{$abs_path}{$file}";
        if (_otk_ext($file) == "php") {
            require_once("{$path}{$file}");
        }
        if (_otk_ext($file) == "css") {
            echo "<link rel=\"StyleSheet\" href=\"{$abs_path}{$file}\" type=\"text/css\" media=\"" . _otk_name($file) . "\" />\n";
        }
        if (_otk_ext($file) == "js") {
            echo "<script type=\"text/javascript\" src=\"{$abs_path}{$file}\"></script>\n";
        }
    }
}

function otk_require_dir($abs_path)
{
    otk_include_dir($abs_path);
}
?>
