<?
/*
    +----------------------------------------------------------------------+
    | OTK is a set of library for Ossigeno and Xax                         |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Library: errors
    This file defines some functions to generate and show errors
*/

function otk_error($error, $url)
{
    global $link, $base;
    $error = (string) $error;
    $url   = (string) $url;
    if (strpos($url, "?") === FALSE) {
        $url .= "?";
    }
        $error = urlencode($error);
    if ($_GET["ajax"]) {
        $error .= "&ajax=1";
    }
    header("Location: {$base}{$url}&error={$error}");
    exit;
}

function otk_error_echo($error)
{
    $error = (string) $error;
    if ($error) {
        echo "<div class=\"error\">".stripslashes($error)."</div>
        ";
    }
}

function otk_assert_handler($file, $line, $code)
{
    echo "<hr />Assertion failed<br />
    File: $file<br />
    Line: $line<br />
    Code: $code<br />
    <hr />";
    ob_end_flush();
    ob_start();
}

assert_options(ASSERT_ACTIVE, 1);
assert_options(ASSERT_WARNING, 0);
assert_options(ASSERT_BAIL, 0);
assert_options(ASSERT_QUIET_EVAL, 1);
assert_options(ASSERT_CALLBACK, "otk_assert_handler");
?>
