<?
/*
    +----------------------------------------------------------------------+
    | OTK is a set of library for Ossigeno and Xax                         |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Library: html
    This file defines some functions to control and manipulate html code inserted
*/

function otk_html_smiles($area = "text")
{
    global $directory_smiles, $graphic_base, $lang, $base, $ossigeno, $xax_version;
    if ($xax_version) {
        $path = "{$base}{$ossigeno}{$graphic_base}";
    } else {
        $path = $graphic_base;
    }
    if ($directory_smiles) {
        echo "<div class=\"otk_html_smiles\">
        ";
        $smiles = opendir($directory_smiles);
        while (($file = readdir($smiles)) !== FALSE) {
            if (in_array($file, array(".", "..", "others"))) {
                continue;
            }
            $smile = new OTK_Smile($file, $area);
            echo $smile->Display();
        }
        closedir($smiles);
        if (!$xax_version) {
            echo "<a href=\"javascript:otk_popup('{$base}community/popups/smiles.php?area={$area}', '400', '400');\">{$lang["html_buttons"]["smiles"]}</a>
            ";
        }
        echo "</div>
        ";
    }
}

function otk_html_strong($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_short\">
    <a href=\"javascript:otk_html_strong('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["b"]}\">B</a>
    </div>";
}

function otk_html_em($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_short\">
    <a href=\"javascript:otk_html_em('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["i"]}\">I</a>
    </div>";
}

function otk_html_ol($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_short\">
    <a href=\"javascript:otk_html_ol('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["ol"]}\">OL</a>
    </div>";
}

function otk_html_ul($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_short\">
    <a href=\"javascript:otk_html_ul('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["ul"]}\">UL</a>
    </div>";
}

function otk_html_dl($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_short\">
    <a href=\"javascript:otk_html_dl('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["dl"]}\">DL</a>
    </div>";
}

function otk_html_samp($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_samp('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["samp"]}\">SAMP</a>
    </div>";
}

function otk_html_kbd($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_kbd('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["kbd"]}\">KBD</a>
    </div>";
}

function otk_html_var($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_var('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["var"]}\">VAR</a>
    </div>";
}

function otk_html_abbr($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_abbr('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["abbr"]}\">ABBR</a>
    </div>";
}

function otk_html_acronym($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_acronym('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["acronym"]}\">ACR</a>
    </div>";
}

function otk_html_code($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_code('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["code"]}\">CODE</a>
    </div>";
}

function otk_html_quote($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_quote('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["quote"]}\">QUOT</a>
    </div>";
}

function otk_html_q($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_short\">
    <a href=\"javascript:otk_html_q('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["q"]}\">Q</a>
    </div>";
}

function otk_html_hr($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_short\">
    <a href=\"javascript:otk_html_hr('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["hr"]}\">HR</a>
    </div>";
}

function otk_html_img($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_img('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["img"]}\">IMG</a>
    </div>";
}

function otk_html_a($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_short\">
    <a href=\"javascript:otk_html_a('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["a"]}\">A</a>
    </div>";
}

function otk_html_link($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_tag_long\">
    <a href=\"javascript:otk_html_link('{$area}')\" title=\"{$lang["helps"]["html_buttons"]["link"]}\">LINK</a>
    </div>";
}

function otk_html_color_map($area = "text")
{
    global $lang;
    $groups = array(
        array("black", "gray", "silver", "white"),
        array("navy", "blue", "aqua", "turquoise"),
        array("teal", "green", "lime", "springgreen"),
        array("purple", "fuchsia", "violet", "pink"),
        array("maroon", "brown", "sienna", "olive"),
        array("crimson", "red", "tomato", "salmon"),
        array("orange", "gold", "yellow", "khaki")
        );
    echo "<div class=\"otk_html_color_map\">
    ";
    foreach ($groups as $colors) {
        echo "<div class=\"otk_html_color_column\">
        ";
        foreach ($colors as $color) {
            echo "<div class=\"otk_html_color\" style=\"background-color: {$color};\">
            <a class=\"otk_html_color\" href=\"javascript:otk_html_color('{$color}', '{$area}')\">&nbsp;&nbsp;&nbsp;&nbsp;</a>
            </div>
            ";
        }
        echo "</div>
        ";
    }
    echo "</div>
    ";
}

function otk_html_bar($area = "text")
{
    global $lang;
    echo "<div class=\"otk_html_bar\">";
    //general
    otk_html_strong($area);
    otk_html_em($area);
    otk_html_img($area);
    otk_html_a($area);
    otk_html_link($area);
    echo "<br class=\"clear\" />
    ";
    //programmers utility
    otk_html_samp($area);
    otk_html_kbd($area);
    otk_html_var($area);
    otk_html_abbr($area);
    otk_html_acronym($area);
    echo "<br class=\"clear\" />
    ";
    //block level elements and quotes
    otk_html_code($area);
    otk_html_quote($area);
    otk_html_q($area);
    otk_html_hr($area);
    echo "<br class=\"clear\" />
    ";
    //lists
    otk_html_ol($area);
    otk_html_ul($area);
    otk_html_dl($area);
    //smiles
    otk_html_smiles($area);
    //color map
    otk_html_color_map($area);
    echo "</div>
    ";
}

function otk_html_normalize($string)
{
    $string = str_replace("&", "&amp;", $string);
    $string = str_replace("<", "&lt;", $string);
    $string = str_replace(">", "&gt;", $string);
    return $string;
}

function otk_html_unnormalize($string)
{
    $string = str_replace("&amp;", "&", $string);
    $string = str_replace("&lt;", "<", $string);
    $string = str_replace("&gt;", ">", $string);
    return $string;
}

function otk_html_format($string)
{
    global $directory_smiles, $base, $graphic_base, $otk_char, $lang;
    $allowed_tags = array("img", "a", "div", "strong", "em", "samp", "kbd", "var", "abbr", "acronym", "hr", "blockquote", "q", "ol", "ul", "li", "dl", "dt", "dd", "span", "table", "thead", "th", "tbody", "tr", "td", "tfoot", "caption");
    //CODE
    $string = stripslashes($string);
    $string = str_replace("</code></div>", "<code>", $string);
    $string = str_replace("<strong>{$lang["lib"]["code"]}:</strong><div class=\"code\"><code>", "<code>", $string);
    //$table = get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);
    $pieces = explode("<code>", $string);
    $number_pieces = count($pieces);
    for ($i = 0; $i < $number_pieces; $i++) {
        if ($i % 2 == 0) {
            //treatment of normal text
            //$pieces[$i] = strtr($pieces[$i], $table);
            $pieces[$i] = str_replace("&", "&amp;", $pieces[$i]);
            $pieces[$i] = str_replace("<", "&lt;", $pieces[$i]);
            //allowed tags
            foreach ($allowed_tags as $tag) {
                $pieces[$i] = str_replace("&lt;{$tag} ", "<{$tag} ", $pieces[$i]);
                $pieces[$i] = str_replace("&lt;{$tag}>", "<{$tag}>", $pieces[$i]);
                $pieces[$i] = str_replace("&lt;/{$tag}>", "</{$tag}>", $pieces[$i]);
            }
        }
        if ($i % 2 == 1) {
            //treatment of code
            $pieces[$i] = str_replace("&", "&amp;", $pieces[$i]);
            $pieces[$i] = str_replace("<", "&lt;", $pieces[$i]);
            $pieces[$i] = str_replace(">", "&gt;", $pieces[$i]);
        }
    }
    $string = "";
    //ricomposition
    for ($i = 0; $i < $number_pieces; $i++) {
        $string .= $pieces[$i];
        if ($i % 2 == 0 and $i != $number_pieces - 1) {
            $string .= "<strong>{$lang["lib"]["code"]}:</strong><div class=\"code\"><code>";
        }
        if ($i % 2 == 1) {
            $string .= "</code></div>";
        }
    }
    //convert "\n" -> "<br />\n"
    $string = nl2br($string);
    $string = str_replace("<ul><br />", "<ul>", $string);
    $string = str_replace("</ul><br />", "</ul>", $string);
    $string = str_replace("<ol><br />", "<ol>", $string);
    $string = str_replace("</ol><br />", "</ol>", $string);
    $string = str_replace("</li><br />", "</li>", $string);
    $string = str_replace("<dl><br />", "<dl>", $string);
    $string = str_replace("</dl><br />", "</dl>", $string);
    $string = str_replace("</dt><br />", "</dt>", $string);
    $string = str_replace("</dd><br />", "</dd>", $string);
    $string = str_replace("<table><br />", "<table>", $string);
    $string = str_replace("</table><br />", "</table>", $string);
    $string = str_replace("<thead><br />", "<thead>", $string);
    $string = str_replace("</thead><br />", "</thead>", $string);
    $string = str_replace("<tbody><br />", "<tbody>", $string);
    $string = str_replace("</tbody><br />", "</tbody>", $string);
    $string = str_replace("<tfoot><br />", "<tfoot>", $string);
    $string = str_replace("</tfoot><br />", "</tfoot>", $string);
    $string = str_replace("<tr><br />", "<tr>", $string);
    $string = str_replace("</tr><br />", "</tr>", $string);
    $string = str_replace("<th><br />", "<th>", $string);
    $string = str_replace("</th><br />", "</th>", $string);
    $string = str_replace("<td><br />", "<td>", $string);
    $string = str_replace("</td><br />", "</td>", $string);
    //SMILES
    if ($directory_smiles) {
        $smiles = opendir($directory_smiles);
        while (($file = readdir($smiles)) !== FALSE) {
            $pieces = explode(".", $file);
            $name = $pieces[0];
            $string = str_replace($otk_char.$name.$otk_char, "<img src=\"{$base}{$graphic_base}smiles/{$file}\" alt=\"{$name}\" />", $string);
        }
        closedir($smiles);
        $smiles = opendir("{$directory_smiles}others/");
        while (($file = readdir($smiles)) !== FALSE) {
            $pieces = explode(".", $file);
            $name = $pieces[0];
            $string = str_replace($otk_char.$name.$otk_char, "<img src=\"{$base}{$graphic_base}smiles/others/{$file}\" alt=\"{$name}\" />", $string);
        }
        closedir($smiles);
    }
    $string = addslashes($string);
    return $string;
}

function otk_html_unformat($string)
{
    global $directory_smiles, $base, $graphic_base, $otk_char, $lang;
    //SMILES
    if ($directory_smiles) {
        $smiles = opendir($directory_smiles);
        while (($file = readdir($smiles)) !== FALSE) {
            $pieces = explode(".", $file);
            $name = $pieces[0];
            $string = str_replace("<img src=\"{$base}{$graphic_base}smiles/{$file}\" alt=\"{$name}\" />", $otk_char.$name.$otk_char, $string);
        }
        closedir($smiles);
    }
    //convert "<br />\n" -> "\n"
    $string = str_replace("<br />", "", $string);
    //CODE
    $string = str_replace("<strong>{$lang["lib"]["code"]}:</strong><div class=\"code\"><code>", "<code>", $string);
    $string = str_replace("</code></div>", "<code>", $string);
    $pieces = explode("<code>", $string);
    $number_pieces = count($pieces);
    $table = array_flip(get_html_translation_table(HTML_ENTITIES, ENT_QUOTES));
    for ($i = 0; $i < $number_pieces; $i++) {
        if ($i % 2 == 0) {
            //treatment of normal text
            $pieces[$i] = str_replace("&lt;", "<", $pieces[$i]);
            $pieces[$i] = str_replace("&amp;", "&", $pieces[$i]);
        }
        if ($i % 2 == 1) {
            //treatment of code
            $pieces[$i] = str_replace("&lt;", "<", $pieces[$i]);
            $pieces[$i] = str_replace("&gt;", ">", $pieces[$i]);
            $pieces[$i] = str_replace("&amp;", "&", $pieces[$i]);
        }
    }
    $string = "";
    for ($i = 0; $i < $number_pieces; $i++) {
        $string .= $pieces[$i];
        if ($i % 2 == 0 and $i != $number_pieces - 1 and $number_pieces > 1) {
            $string .= "<strong>{$lang["lib"]["code"]}:</strong><div class=\"code\"><code>";
        }
        //if piece %2 == 1 add "end code"
        if ($i % 2 == 1) {
            $string .= "</code></div>";
        }
    }
    return $string;
}
?>
