<?
/*
    +----------------------------------------------------------------------+
    | OTK is a set of library for Ossigeno and Xax                         |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Library: modules
    This file defines some functions to work with modules
*/

function _otk_module_explode_tag($tag)
{
    for ($i = 0; $i < strlen($tag); $i++) {
        if (((int) $tag{$i})) {
            break;
        }
    }
    $type = substr($tag, 0, $i);
    switch ($type) {
        case "alpha":
            $type = 1;
            break;
        case "beta":
            $type = 2;
            break;
        case "pre":
            $type = 3;
            break;
        case "rc":
            $type = 4;
            break;
        /* official release
        case "":
            $type = 5;
            break;
        */
        case "p":
            $type = 6;
            break;
    }
    $number = (int) substr($tag, $i, strlen($tag) - $i);
    return array($type, $number);
}

function otk_module_compare($version1, $version2)
{
    if (strstr($version1, "_")) {
        list($version1, $tag1) = explode("_", $version1);
    }
    if (strstr($version2, "_")) {
        list($version2, $tag2) = explode("_", $version2);
    }
    //versions: 2.1 vs 1.4
    $subversions1 = explode(".", $version1);
    $subversions2 = explode(".", $version2);
    $n = count($subversions1);
    $m = count($subversions2);
    if ($m > $n) {
        $n = $m;
    }
    for ($i = 0; $i < $n; $i++) {
        if ($subversions1[$i] > $subversions2[$i]) {
            return 1;
        }
        if ($subversions1[$i] < $subversions2[$i]) {
            return -1;
        }
    }
    //tags: alpha1 vs beta3
    if ($tag1) {
        list($type1, $number1) = _otk_module_explode_tag($tag1);
    } else {
        $type1 = 5;
        $number2 = 0;
    }
    if ($tag2) {
        list($type2, $number2) = _otk_module_explode_tag($tag2);
    } else {
        $type2 = 5;
        $number2 = 0;
    }
    //alpha vs beta
    if ($type1 > $type2) {
        return 1;
    } else if ($type2 > $type1) {
        return -1;
    }
    //alpha2 vs alpha3
    if ($number1 > $number2) {
        return 1;
    } else if ($number2 > $number1) {
        return -1;
    }
    //identical versions
    return 0;
}
?>
