<?
/*
    +----------------------------------------------------------------------+
    | OTK is a set of library for Ossigeno and Xax                         |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Library: pages
    This file defines some functions to simplify calculus of pages in record printing
*/

function otk_pages($n, $page, $rec = NULL)
{
    global $otk_rec;
    if ($rec === NULL) {
        $rec = $otk_rec;
    }
    $n    = (int) $n;
    $page = (int) $page;
    if ($page == 0) {
        $page = 1;
    }
    $pages = ceil($n / $rec);
    if ($page > $pages) {
        $page = 1;
    }
    $inf = $page * $rec - $rec;
    return array($pages, $inf, $rec);
}

function otk_pages_list($pages, $page, $url)
{
    global $lang;
    $pages = (int) $pages;
    $page  = (int) $page;
    $url   = (string) $url;
    if (strpos($url, "?") === FALSE) {
        $url .= "?";
    }
    if ($page == 0) {
        $page = 1;
    }
    if ($pages == 0) {
        return 0;
    }
    if ($pages == 1) {
        return 0;
    }
    echo "<div class=\"otk_pages_list\">{$lang["lib"]["pages"]}:&nbsp;
    ";
    //  <<
    if ($page > 2) {
        echo "<a href=\"{$url}&amp;page=1\">{$lc["<"]}{$lc["<"]}</a>&nbsp;";
    }
    //  <
    if ($page > 1) {
        $prev = $page - 1;
        echo "<a href=\"{$url}&amp;page=$prev\">{$lc["<"]}</a>&nbsp;";
    }
    for ($i = 1; $i <= $pages; $i++) {
        if ($i > 1) {
            echo ",&nbsp;";
        }
        if ($i!=$page) {
            echo "<a href=\"{$url}&amp;page=$i\">$i</a>";
        } else {
            echo $i;
        }
    }
    //  >
    if ($pages - $page >= 1) {
        $next = $page + 1;
        echo "&nbsp;<a href=\"{$url}&amp;page=$next\">{$lc[">"]}</a>";
    }
    //  >>
    if ($pages - $page >= 2) {
        echo "&nbsp;<a href=\"{$url}&amp;page=$pages\">{$lc[">"]}{$lc[">"]}</a>";
    }
    echo "</div>
    ";
}
?>
