<?
/*
    +----------------------------------------------------------------------+
    | Ossigeno is a modularized CMS                                        |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Internal: surveys
    File
    /surveys/survey.php
    Display a survey with its results
*/

$module = "surveys";
$only_users = FALSE;
$abc = "surveys/survey.php?id_s={$_GET["id_s"]}";
include("../common/config.php");

$survey = new OTK_Survey($_GET["id_s"]);
if ($survey === NULL) {
    otk_error($lang["errors"]["survey_does_not_exist"], "surveys/index.php?");
}

//header
$header["title"] = "{$lang["titles"]["survey"]}: {$survey->question}";
require("../common/header.php");
error_reporting(2047);
?>
<div class="links"><? echo $survey->question; ?></div>
<table>
<thead>
    <tr>
    <th class="survey_option"><? echo $lang["survey"]["th"]["option"]; ?></th>
    <th class="survey_bar"><? echo $lang["survey"]["th"]["bar"]; ?></th>
    </tr>
</thead>
<tbody>
<?
$total = $survey->NumberVotes();
if ($total != 0) {
    foreach ($survey->options as $id => $option) {
        echo "<tr>
        <td class=\"survey_option\">{$option->value}</td>
        <td class=\"survey_bar\">";
        $percentage = round($option->NumberVotes() / $total * 100, OSS_DECIMAL_PRECISION);
        //graceful coloured bar
        $length = round($percentage);
        for ($j = 1; $j <= $length; $j++) {
            echo "<img class=\"null\" src=\"{$graphic_base}surveys/bar.png\" alt=\"|\" />";
        }
        echo " ({$percentage}%, " . $option->NumberVotes() . " {$lang["survey"]["votes"]})</td>
        </tr>
        ";
    }
} else {
    foreach ($survey->options as $id => $option) {
        echo "<tr>
        <td class=\"survey_option\">{$option->value}</td>
        <td class=\"survey_bar\">0 {$lang["survey"]["votes"]}</td>
        </tr>
        ";
    }
}
?>
</tbody>
</table>
<div class="links"><?
if (in_array($user->nick, $survey->voters)) {
    echo $lang["survey"]["already"];
} else {
    ?><a href="surveys/form_vote.php?id_s=<? echo $survey->id; ?>"><? echo $lang["titles"]["form_vote"]; ?></a><?
}
?>
<a href="surveys/form_new_survey.php"><? echo $lang["titles"]["form_new_survey"]; ?></a><br />
<a href="surveys/index.php"><? echo $lang["titles"]["index"]; ?></a>
</div>
<?
require("../common/footer.php");
?>
