<?
/*
    +----------------------------------------------------------------------+
    | Xax is a modularized tool for administration of websites             |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Kernel
    File
    /common/class.php
    This file defines the Xax classes
*/

class OTK_XaxRecord
{
    //this class represents a sql record (extended by all other classes)
    var $id;
    var $_pk;
    var $_table;
    function OTK_XaxRecord($table, $pk = "id")
    {
        //MySQL table name
        $this->_table = $table;
        //primary key
        $fields = explode(",", $pk);
        $this->_pk = array_map("trim", $fields);
    }
    function otk_record_convert_field($f) { return "({$f} = '{$this->{$f}}')"; }
    function _Where()
    {
        //WHERE clauses of primary key
        $clauses = array_map(array(&$this, "otk_record_convert_field"), $this->_pk);
        return "WHERE (" . implode(" AND ", $clauses) . ")";
    }
    function Set($field, $value)
    {
        //sets $field to $value
        $field = (string) $field;
        $value = (string) $value;
        $q = otk_sql_query("UPDATE {$this->_table} SET {$field}='{$value}' " . $this->_WHERE());
        $this->$field = $value;
        return (bool) $q;
    }
    function Reset($field)
    {
        //sets $field to NULL
        $field = (string) $field;
        $q = otk_sql_query("UPDATE {$this->_table} SET {$field}=NULL " . $this->_WHERE());
        $this->$field = NULL;
        return (bool) $q;
    }
    function Get($field)
    {
        //returns $field
        return $this->$field;
    }
    function Clear($object)
    {
        $object = NULL;
    }
}

class OTK_XaxPermissions
{
    var $name;
    var $type;
    var $content;
    function OTK_XaxPermissions($name, $type = "U")
    {
        $this->content = array();
        $q = otk_sql_query("SELECT * FROM xax");
        while ($m = otk_sql_fetch_array($q)) {
            $this->content[$m["name"]] = array();
        }
        $q = otk_sql_query("SELECT * FROM xax_permissions WHERE ((name = '{$name}') AND (type = '{$type}'))");
        $this->name = $name;
        $this->type = $type;
        while ($p = otk_sql_fetch_array($q)) {
            $this->content[$p["module"]][$p["operation"]] = TRUE;
        }
    }
    function Update()
    {
        otk_sql_query("DELETE FROM xax_permissions WHERE (
                    (name = '{$this->name}') AND
                    (type = '{$this->type}')
                    )");
        foreach ($this->content as $module => $operations) {
            foreach ($operations as $operation => $permitted) {
                if ($permitted) {
                    otk_sql_query("INSERT INTO xax_permissions
                    (name, type, module, operation)
                    VALUES (
                    '{$this->name}',
                    '{$this->type}',
                    '{$module}',
                    '{$operation}'
                    )");
                }
            }
        }
        return TRUE;
    }
}

class OTK_XaxUser extends OTK_XaxRecord
{
    var $id;
    var $nick;
    var $pwd;
    var $session;
    var $permissions;
    var $active;
    function OTK_XaxUser($nick)
    {
        $this->_table = "xax_users";
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (nick = '$nick')");
        if (otk_sql_num_rows($q)) {
            $xax_user = otk_sql_fetch_array($q);
            $this->id          = (int)    $xax_user["id"];
            $this->nick        = (string) $xax_user["nick"];
            $this->pwd         = (string) $xax_user["pwd"];
            $this->session     = (int)    $xax_user["session"];
            $this->active      = (bool)   $xax_user["active"];
            //special fields
            $this->permissions = new OTK_XaxPermissions($xax_user["nick"], "U");
        } else {
            $this->Clear($this);
        }
    }
}

class OTK_XaxModule extends OTK_XaxRecord
{
    //this class represents a Xax module, or a Xax internal
    var $name;
    var $date;
    function OTK_XaxModule($name)
    {
        $this->_table = "xax";
        $name = (string) $name;
        $q = otk_sql_query("SELECT * FROM {$this->_table} WHERE (name = '$name')");
        if (otk_sql_num_rows($q)) {
            $module = otk_sql_fetch_array($q);
            $this->id      = (int)    $module["id"];
            $this->name    = (string) $module["name"];
            $this->date    = (int)    $module["date"];
        } else {
            $this->Clear($this);
        }
    }
}

?>
