<?
/*
    +----------------------------------------------------------------------+
    | Xax is a modularized tool for administration of websites             |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Kernel
    File
    /common/config.php
    This file includes libraries and define global variables
*/

//set error_level
error_reporting(E_ALL ^ E_NOTICE);
//starting output buffer
ob_start();
//set configuration
ini_set("magic_quotes_runtime", "0");
ini_set("magic_quotes_sybase", "0");

//setting $level, path to the xax root directory
if ($level == "") {
    if ($abc) {
        $n = substr_count($abc, "/");
        for ($i = 1; $i <= $n; $i++) {
            $level .= "../";
        }
    } else {
        $level = "../";
    }
}
include("{$level}personal/info.php");
include("{$level}common/info.php");

$host   = $_SERVER["HTTP_HOST"];
$server = "http://".$_SERVER["HTTP_HOST"];
$base   = $server.$path."/";
$otk_char = ":";
$otk_rec  = "20";
$graphic_base = "";
$super = FALSE;
$queries_executed = 0;
$max = getrandmax();
$header = array();
$header["libs"] = array();
//$xax_user
//$xax_permissions

//setting $level_server, path to the server root directory
$level_server = $level;
for ($i = 1; $i <= substr_count($path, "/"); $i++) {
    $level_server .= "../";
}
unset($i);

$ossigeno = "../";  //path to the ossigeno root directory, from xax position (example: "../ossigeno/")

//including libraries
require_once("{$level}{$ossigeno}otk/lib/dirs.php");
otk_require_dir("{$ossigeno}otk/lib/");
otk_require_dir("{$ossigeno}otk/classes/");
include_once("{$level}{$ossigeno}personal/constants.php");
//including Xax own classes
otk_require_dir("common/lib/");
otk_require_dir("common/classes/");

//including language files
include("{$level}lang/{$language}-common.php");
include("{$level}lang/{$language}-locale.php");
//open lang file
if ($module) {
    include("{$level}lang/{$language}-{$module}.php");
    if ($module2) {
        include("{$level}lang/{$language}-{$module}-{$module2}.php");
        if ($module3) {
            include("{$level}lang/{$language}-{$module}-{$module2}-{$module3}.php");
        }
    }
}

//connecting
$otk_link = otk_sql_connect();
otk_sql_select_db();
$q = otk_sql_query("SELECT * FROM xax_info");
while ($i = otk_sql_fetch_array($q)) {
    $xax_info[$i["name"]] = $i["value"];
}
unset($q, $i);
if ($_REQUEST["ajax"]) {
    $header["template"] = "ajax";
}

//info
$xax_graphic_base = "graphic/".$xax_info["graphic"]."/";
if ($path_cookie == "") {
    if ($path=="") {
        $path_cookie = "/";
    } else {
        $path_cookie = $path;
    }
}

if ($xax_info["timezone"]) {
    putenv("TZ={$_info["timezone"]}");
}
$timestamp       = time();
$micro_timestamp = otk_time_getmicro();

//user
$_COOKIE["xax_session"] = (int) $_COOKIE["xax_session"];
$k = otk_sql_query("SELECT * FROM xax_users WHERE ((nick = '$_COOKIE[xax_nick]') AND (session = '$_COOKIE[xax_session]'))");
if (otk_sql_num_rows($k)) {
    $xax_user = otk_sql_fetch_array($k);
} else {
    $xax_user = FALSE;
}
if ($xax_user) {
    $xax_user = new OTK_XaxUser($xax_user["nick"]);
    $permissions = $xax_user->permissions;
} else {
    $permissions = new OTK_XaxPermissions("", "NULL");
    $permissions = $permissions->content;
}

//control for only users pages
if ($only_users) {
    otk_cookie_set("xax_abc", $abc);
    $url = "users/form_aut.php?abc=$abc";
    if (!isset($_COOKIE["xax_nick"]) or !isset($_COOKIE["xax_session"])) {
        //cookie 'xax_nick'and 'xax_session' must exists
        otk_error($lang["errors"]["must_aut"], $url);
    }
    if (!$xax_user) {
        //db research for 'nick' and 'session' must find record.
        otk_error($lang["errors"]["must_aut"], $url);
    }
    if (!$xax_user->active) {
        //user must be active
        otk_error($lang["errors"]["user_not_active"], $url);
    }
    if (!$_POST and !$_GET and !$only_users) {
        //if there's no vars posted by a form (GET or POST)
        //or a page 'only users' (may cause a redirect on not enough permissions)
        //updating cookie 'xax_session'
        //if there's any redirect,
        //they can give problems on server windows
        //on server unix or linux, you can de-if the following code
        $session = rand();
        $xax_user->Set("session", $session);
        otk_cookie_set("xax_nick", $_COOKIE["xax_nick"]);
        otk_cookie_set("xax_session", $session);
    }
    //permissions user
    $permission = FALSE;
    if ($module) {
        if ($xax_user->permissions->content[$module]) {
            $permission = TRUE;
        }
    } else {
        $permission = TRUE;
    }
    if (!$permission) {
        otk_error($lang["errors"]["unauthorized"], "users/no.php?");
    }
}

//include personalization scripts
otk_include_dir("personal/scripts/");

if ($module) {
    include_once("common.php");
    if ($module2) {
        include_once("../common.php");
        if ($module3) {
            include_once("../../common.php");
        }
    }
}
?>
