<?
/*
    +----------------------------------------------------------------------+
    | Xax is a modularized tool for administration of websites             |
    | Copyright (C) 2004-2007 Neovision                                    |
    | [http://www.neovision.it]                                            |
    | Giorgio Sironi, Roberto Reposo                                       |
    +----------------------------------------------------------------------+
    |  This program is free software; you can redistribute it and/or       |
    | modify it under the terms of the GNU General Public License as       |
    | published by the Free Software Foundation; either version 2 of the   |
    | License, or (at your option) any later version.                      |
    |  This program is distributed in the hope that it will be useful,     |
    | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
    | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
    | GNU General Public License for more details.                         |
    |  You should have received a copy of the GNU General Public License   |
    | along with this program; if not, write to the Free Software          |
    | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 |
    | USA                                                                  |
    +----------------------------------------------------------------------+
    Module: xax-backup
    File
    /backup/backup.php
    This file dump tables (with form_backup.php)
*/

$module = "backup";
$only_users = TRUE;
$abc = "backup/form_backup.php";
include("../common/config.php");

$header["title"] = $lang["titles"]["backup"];
require("../common/header.php");
$separator = "# -------------------------------------------\n";
$start = otk_time_getmicro();
$tables = otk_sql_list_tables($db);
$dump  = "";
$dump .= "# {$lang["backup"]["dump"]} [$host]\n";
$dump .= "# {$lang["backup"]["generated"]}: ". otk_time_getdate($timestamp)."\n";
$dump .= "# {$lang["backup"]["db"]}: $db\n";
$dump .= $separator;
foreach ($tables as $name) {
    if (isset($_POST["s_".$name])) {
        $dump .= "# {$lang["backup"]["structure"]} `$name`\n";
        $dump .= otk_sql_dump_structure($name)."\n";
        $dump .= $separator;
    }
    if (isset($_POST["d_".$name])) {
        $dump .= "# {$lang["backup"]["data"]} `$name`\n";
        $dump .= otk_sql_dump_data($name)."\n";
        $dump .= $separator;
    }
}
if ($_POST["no_mail"]) {
    echo "<p><pre>" . htmlentities($dump) . "</pre></p>
    ";
} else {
    mail($_POST["mail"], "{$lang["backup"]["dump"]} $db -> $host", $dump);
}
$finish = otk_time_getmicro();
?>
<hr />
<p><? echo $lang["backup"]["time"]["elapsed"]; ?>: <? echo ($finish-$start); ?> <? echo $lang["backup"]["time"]["seconds"]; ?>.</p>
<?
require("../common/footer.php");
?>
